<?php

/**

 * Routes configuration

 *

 * In this file, you set up routes to your controllers and their actions.

 * Routes are very important mechanism that allows you to freely connect

 * different URLs to chosen controllers and their actions (functions).

 *

 * @link          http://cakephp.org CakePHP(tm) Project

 * @package       app.Config

 * @since         CakePHP(tm) v 0.2.9

 */



/**

 * Here, we are connecting '/' (base path) to controller called 'Pages',

 * its action called 'display', and we pass a param to select the view file

 * to use (in this case, /app/View/Pages/home.ctp)...

 */

Router::connect('/pages/*', array('controller' => 'pages', 'action' => 'Info'));
Router::connect('/details/*', array('controller' => 'pages', 'action' => 'Details'));

Router::connect('/how_it_works', array('controller' => 'pages', 'action' => 'display', 'how_it_works', 'admin' => false));

Router::connect('/newsroom', array('controller' => 'pages', 'action' => 'newsrooms'));


Router::connect('/terms_and_conditions', array('controller' => 'pages', 'action' => 'display', 'terms_and_conditions', 'admin' => false));

Router::connect('/faq', array('controller' => 'pages', 'action' => 'display', 'faq', 'admin' => false));

Router::connect('/membership', array('controller' => 'pages', 'action' => 'display', 'membership', 'admin' => false));

Router::connect('/', array('controller' => 'pages', 'action' => 'home'));

//Router::connect('/categories/*', array('controller' => 'categories', 'action' => 'index'));


Router::connect('/directory/*', array('controller' => 'directory', 'action' => 'index'));

Router::connect('/upcoming_events/*', array('controller' => 'eventshomes', 'action' => 'upcoming_events'));

Router::connect('/delegates/*', array('controller' => 'pages', 'action' => 'delegate'));

Router::connect('/past_events', array('controller' => 'eventshomes', 'action' => 'past_events'));

Router::connect('/view_event_details/*', array('controller' => 'eventshomes', 'action' => 'details'));

Router::connect('/admin', array('controller' => 'users', 'action' => 'home', 'prefix' => 'admin', 'admin' => true));

//Router::connect('/signup', array('controller' => 'users', 'action' => 'signup'));

Router::connect('/doctorsignup', array('controller' => 'users', 'action' => 'doctorsignup'));

Router::connect('/patientsignup', array('controller' => 'users', 'action' => 'patientsignup'));

//Router::connect('/login', array('controller' => 'users', 'action' => 'login'));

Router::connect('users/dashboard', array('controller' => 'users', 'action' => 'dashboard'));

Router::connect('users/profile', array('controller' => 'users', 'action' => 'profile'));

Router::connect('users/inbox', array('controller' => 'users', 'action' => 'inbox'));

Router::connect('users/compose_message', array('controller' => 'users', 'action' => 'compose_message'));

Router::connect('/logout', array('controller' => 'users', 'action' => 'logout'));

Router::connect('/forgot_password', array('controller' => 'users', 'action' => 'forgot_password'));

/**

 * Load all plugin routes. See the CakePlugin documentation on

 * how to customize the loading of plugin routes.

 */

	CakePlugin::routes();



/**

 * Load the CakePHP default routes. Only remove this if you do not want to use

 * the built-in default routes.

 */

	require CAKE . 'Config' . DS . 'routes.php';

