<?php
App::uses('AppController', 'Controller');
/**
 * AbuseReports Controller
 *
 * @property AbuseReport $AbuseReport
 */
class AbuseReportsController extends AppController {

    public $uses = array('AbuseReport', 'Product', 'Reply');

    /* --------------------------------------------------------------- START :: ADMIN PANEL FUNCTIONS --------------------------------------- */

	public function admin_index($id = null){
		$report_abuseTypeSearch = $this->report_abuseTypeSearch;
		$report_dateSearch = $this->report_dateSearch;		
		$this->AbuseReport->recursive = 1;	
		if(!empty($id)){
			$condition = '(';			
			if($id == 'N'){
				$condition .= "AbuseReport.status = 1 AND ";
			}
			else if($id == 'P'){
					$condition .= "AbuseReport.status = 2 AND ";
			}
			else if($id == 'R'){
				$condition .= "AbuseReport.status = 3 AND DATEDIFF(CURDATE(),AbuseReport.resolved_on) <= 30 AND ";
			}
			else if($id == 'A'){
				$condition .= "AbuseReport.status = 3 AND DATEDIFF(CURDATE(),AbuseReport.resolved_on) > 30 AND ";
			}			
			if(!empty($this->request->data)){
				if(!empty($this->request->data['AbuseReports']['abuse_type'])){					
					if($this->request->data['AbuseReports']['abuse_type'] == '10'){
						$condition .= "AbuseReport.abuse_type LIKE '%". trim($this->request->data['AbuseReports']['other_abuse_type']) ."%' AND ";
					}
					else{
						$condition .= "AbuseReport.abuse_type LIKE '%". trim($report_abuseTypeSearch[$this->request->data['AbuseReports']['abuse_type']]) ."%' AND ";
					}
				}
				if(!empty($this->request->data['AbuseReports']['date_search'])){					
					if($this->request->data['AbuseReports']['date_search'] == 1){
						$day = 7 ;
					}
					else if($this->request->data['AbuseReports']['date_search'] == 2){
						$day = 14 ;
					}
					else if($this->request->data['AbuseReports']['date_search'] == 3){
						$day = 30 ;
					}
					else if($this->request->data['AbuseReports']['date_search'] == 4){
						$day = 60 ;
					}
					else if($this->request->data['AbuseReports']['date_search'] == 5){
						$day = 90 ;
					}
					$date1 = date('Y-m-d');
					$date2 = date('Y-m-d',mktime(0, 0, 0, date("m"), date("d")-$day, date("Y")));
					$condition .= "AbuseReport.abused_on BETWEEN '".$date2."' AND '".$date1."' AND ";
				}
				if(!empty($this->request->data['AbuseReports']['email'])){
					$condition .= "User.email = '".$this->request->data['AbuseReports']['email']."' AND ";
				}
				if(!empty($this->request->data['AbuseReports']['username'])){
					$condition .= "User.username = '".$this->request->data['AbuseReports']['username']."' AND ";
					$count_new = $this->AbuseReport->find('count', array('conditions' => array('AbuseReport.status' => '1', 'User.username' => $this->request->data['AbuseReports']['username'])));
					$count_pending = $this->AbuseReport->find('count', array('conditions' => array('AbuseReport.status' => '2', 'User.username' => $this->request->data['AbuseReports']['username'])));
					$count_resolved = $this->AbuseReport->find('count', array('conditions' => array('AbuseReport.status' => '3', 'User.username' => $this->request->data['AbuseReports']['username'])));
					$this->set(compact('count_new', 'count_pending', 'count_resolved'));
				}
			}
			$condition = rtrim($condition, ' AND ');
			$condition = $condition . ')';
			#echo $condition;
			$this->paginate =  array(
					'fields' => array('AbuseReport.*', 'User.*', 'Product.*'),
					'conditions' => array($condition),
					'limit' =>'10',
					'order' => 'AbuseReport.id DESC' );
		}
		else{
			if(!empty($this->request->data)){
				$condition = '(';				
				if(!empty($this->request->data['AbuseReports']['abuse_type'])){					
					if($this->request->data['AbuseReports']['abuse_type'] == '10'){
						$condition .= "AbuseReport.abuse_type LIKE '%". trim($this->request->data['AbuseReports']['other_abuse_type']) ."%' AND ";
					}
					else{
						$condition .= "AbuseReport.abuse_type LIKE '%". trim($report_abuseTypeSearch[$this->request->data['AbuseReports']['abuse_type']]) ."%' AND ";
					}
				}
				if(!empty($this->request->data['AbuseReports']['date_search'])){
					$date1 = date('Y-m-d');
					if($this->request->data['AbuseReports']['date_search'] == 1){
						$date2 = date('Y-m-d',mktime(0, 0, 0, date("m"), date("d")-7, date("Y")));
					}
					else if($this->request->data['AbuseReports']['date_search'] == 2){
						$date2 = date('Y-m-d',mktime(0, 0, 0, date("m"), date("d")-14, date("Y")));
					}
					else if($this->request->data['AbuseReports']['date_search'] == 3){
						$date2 = date('Y-m-d',mktime(0, 0, 0, date("m"), date("d")-30, date("Y")));
					}
					else if($this->request->data['AbuseReports']['date_search'] == 4){
						$date2 = date('Y-m-d',mktime(0, 0, 0, date("m"), date("d")-60, date("Y")));
					}
					else if($this->request->data['AbuseReports']['date_search'] == 5){
						$date2 = date('Y-m-d',mktime(0, 0, 0, date("m"), date("d")-90, date("Y")));
					}
					else if($this->request->data['AbuseReports']['date_search'] == 6){
						$date2 = '0000-00-00';
					}		
					$condition .= "AbuseReport.abused_on BETWEEN '".$date2."' AND '".$date1."' AND ";
				}
				if(!empty($this->request->data['AbuseReports']['email'])){
					$condition .= "User.email LIKE '%".$this->request->data['AbuseReports']['email']."%' AND ";
				}
				if(!empty($this->request->data['AbuseReports']['username'])){
					$condition .= "User.username = '".$this->request->data['AbuseReports']['username']."' AND ";
					$count_new = $this->AbuseReport->find('count', array('conditions' => array('AbuseReport.status' => '1', 'User.username' => $this->request->data['AbuseReports']['username'])));
					$count_pending = $this->AbuseReport->find('count', array('conditions' => array('AbuseReport.status' => '2', 'User.username' => $this->request->data['AbuseReports']['username'])));
					$count_resolved = $this->AbuseReport->find('count', array('conditions' => array('AbuseReport.status' => '3', 'User.username' => $this->request->data['AbuseReports']['username'])));
					$this->set(compact('count_new', 'count_pending', 'count_resolved'));
				}
				$condition = rtrim($condition, ' AND ');
				$condition = $condition . ')';				
				$this->paginate =  array(
					'fields' => array('AbuseReport.*', 'User.*', 'Product.*'),
					'conditions' => array($condition),
					'limit' =>'10',
					'order' => 'AbuseReport.id DESC' );
			}
			else{
				$this->paginate =  array(
					'fields' => array('AbuseReport.*', 'User.*', 'Product.*'),
					'limit' =>'10',
					'order' => 'AbuseReport.id DESC' );
			}
		}
		#pr($this->paginate);
		if(isset($this->paginate['conditions'][0]) && $this->paginate['conditions'][0]==''){
			unset($this->paginate['conditions'][0]);
		}
		#pr($this->paginate);
		$abusereport = $this->paginate();
		$this->set(compact('abusereport', 'report_abuseTypeSearch', 'report_dateSearch'));
		//pr($abusereport);
	}

	public function admin_view($id=null, $pass=null, $rpage=null){
		if (!$id){
			$this->Session->setFlash(__('ERROR :: Invalid Id', true));
			$this->redirect(array('action'=>'view', $pass, $rpage));
		}
		#echo 'in'; exit;
		if(!empty($id)){
			$report_abuse = $this->AbuseReport->read(null,$id);			
			if(!empty($this->request->data)){
				$reply['report_id'] = $id;
				$reply['reply'] = $this->request->data['AbuseReports']['reply'];
				$reply['replied_by'] =	$this->Session->read('Auth.User.id');
				$reply['reply_on'] = date('Y-m-d');
				$this->Reply->create();
				if($this->Reply->save($reply)){
					$this->AbuseReport->id = $id;
					if($this->AbuseReport->saveField('last_updated_on',date('Y-m-d'))){
						if($this->request->data['AbuseReports']['email']!=""){
							$mail_To = $this->request->data['AbuseReports']['email'];
							$mail_From = $this->Session->read('Auth.User.email');
							$mail_subject = "Product is reported abuse!";
							$mail_Body1 = "Dear ".$this->request->data['AbuseReports']['name'].",<br>";
							$mail_Body2 = $mail_Body1.$this->request->data['AbuseReports']['reply'];
							$mail_Body  = nl2Br($mail_Body2);
							//echo $mail_To."<br>".$mail_From."<br>".$mail_subject."<br>".$mail_Body;exit();						
							$this->Send_HTML_Mail($mail_To, $mail_From,'', $mail_subject, $mail_Body);
							$this->Session->setFlash(sprintf(__('The reply is successfully saved and sent to the user.', true), ''), 'default', array('class' => 'success'));
						}
						else{
							$this->Session->setFlash(sprintf(__('The reply is successfully saved.', true), ''), 'default', array('class' => 'success'));
						}						
					}
				}
				else{
					$this->Session->setFlash(sprintf(__('The reply cannot be saved and sent. Please try again.', true), ''), 'default', array('class' => ''));
				}
			}
			$this->Reply->recursive = 0;
			$replies = $this->Reply->find('all', array('conditions' => array('Reply.report_id' => $id), 'order' => 'Reply.id DESC'));
			$this->set(compact('report_abuse', 'report_genreSearch', 'replies'));
			$report_abuse['AbuseReport']['view'] = $report_abuse['AbuseReport']['view'] + 1;
			if($this->AbuseReport->saveField('view', $report_abuse['AbuseReport']['view'])){
				if($report_abuse['AbuseReport']['view'] > 0 && $report_abuse['AbuseReport']['status'] == 1)
				$this->AbuseReport->saveField('status',2);
			}
		}
	}
	
	public function admin_resolved($id=null, $pass=null, $rpage=null){		
		if(!empty($id)){
			$this->AbuseReport->id = $id;
			if($this->AbuseReport->saveField('status',3)){
				$this->AbuseReport->saveField('resolved_on',date('Y-m-d'));
				$this->AbuseReport->saveField('last_updated_on',date('Y-m-d'));
				$report = $this->AbuseReport->read(null, $id);
				//pr($report);
				if($report['AbuseReport']['is_sent_mail']==1){
					$mail_To = $report['User']['email'];
					$mail_From = $this->Session->read('Auth.User.email');
					$mail_subject = "Product issue is resolved.";
					$mail_Body1 = "Dear ".$report['User']['first_name'].",<br>Your product issue is resolved.";
					$mail_Body =nl2Br($mail_Body1);
					//echo $mail_To."<br>".$mail_From."<br>".$mail_subject."<br>".$mail_Body;exit();					
					$this->Send_HTML_Mail($mail_To, $mail_From,'', $mail_subject, $mail_Body);
				}
				//exit();
				$this->Session->setFlash(sprintf(__('The abuse report is resolved successfully.', true), ''), 'default', array('class' => 'success'));
				if(isset($pass)){
					$this->redirect(array('controller' => 'abuse_reports','action' => 'admin_index', $pass));
					if(isset($rpage))
					$this->redirect(array('controller' => 'abuse_reports','action' => 'admin_index', $pass, $rpage));
					$this->redirect(array('controller' => 'abuse_reports','action' => 'admin_index', $pass));
				}
				else{
					if(isset($rpage))
					$this->redirect(array('controller' => 'abuse_reports','action' => 'admin_index', $rpage));
					$this->redirect(array('controller' => 'abuse_reports','action' => 'admin_index'));
				}
			}
		}
	}

	public function admin_activateproduct($id=null, $pass=null, $rpage=null){
		$report = $this->AbuseReport->read(null, $id);
		if(!empty($this->request->data)){
			//pr($this->request->data);exit;
			$this->Product->id = $this->request->data['AbuseReports']['product_id'];
			if($this->Product->saveField('blocked','0')){
				$this->Session->setFlash(sprintf(__('The product has been successfully activated.', true), ''), 'default', array('class' => 'success'));						
				$mail_To = $report['User']['email'];
				$mail_From = $this->Session->read('Auth.User.email');
				$mail_subject = "Product has been activated.";
				$mail_Body1 = "Dear ".$report['User']['first_name'].",<br>Your product has been activated.<br/>Product id : ".$report['Product']['id']."<br>Product name : ".$report['Product']['product_name'];
				$mail_Body =nl2Br($mail_Body1);
				//echo $mail_To."<br>".$mail_From."<br>".$mail_subject."<br>".$mail_Body;exit();				
				$this->Send_HTML_Mail($mail_To, $mail_From,'', $mail_subject, $mail_Body);
				$this->redirect(array('controller' => 'abuse_reports', 'action' => 'admin_view', $id, $rpage));
			}
			else{
				$this->Session->setFlash(sprintf(__('The product could not be activated.Please try again!', true), ''), 'default', array('class' => ''));
				$this->redirect(array('controller' => 'abuse_reports', 'action' => 'admin_view', $id, $rpage));
			}
		}
		else{
			//echo $id;exit;
			$this->Product->id = $id;
			if($this->Product->saveField('blocked','0')){
				$this->Session->setFlash(sprintf(__('The product has been successfully activated.', true), ''), 'default', array('class' => 'success'));
				//$this->redirect(array('controller' => 'abuse_reports'));
				$mail_To = $report['User']['email'];
				$mail_From = $this->Session->read('Auth.User.email');
				$mail_subject = "Product has been activated.";
				$mail_Body1 = "Dear ".$report['User']['first_name'].",<br>Your product has been activated.<br/>Product id : ".$report['Product']['id']."<br>Product name : ".$report['Product']['product_name'];
				$mail_Body =nl2Br($mail_Body1);
				$this->Send_HTML_Mail($mail_To, $mail_From,'', $mail_subject, $mail_Body);
				$this->redirect(array('controller' => 'abuse_reports', 'action' => 'admin_index', $pass, $rpage));
			}
			else{
				$this->Session->setFlash(sprintf(__('The product could not be activated. Please try again!', true), ''), 'default', array('class' => ''));
				//$this->redirect(array('controller' => 'abuse_reports'));
				$this->redirect(array('controller' => 'abuse_reports', 'action' => 'admin_index', $pass, $rpage));
			}
		}
	}

	public function admin_deactivateproduct($id=null, $pass=null, $rpage=null){
		$report = $this->AbuseReport->read(null, $id);
		if(!empty($this->request->data)){
			//pr($this->request->data);exit;
			$this->Product->id = $this->request->data['AbuseReports']['product_id'];
			if($this->Product->saveField('blocked','1')){
				$this->Session->setFlash(sprintf(__('The product has been successfully deactivated.', true), ''), 'default', array('class' => 'success'));
				$mail_To = $report['User']['email'];
				$mail_From = $this->Session->read('Auth.User.email');
				$mail_subject = "Product has been deactivated.";
				$mail_Body1 = "Dear ".$report['User']['first_name'].",<br>Your product has been deactivated.<br/>Product id : ".$report['Product']['id']."<br>Product name : ".$report['Product']['product_name'];
				$mail_Body =nl2Br($mail_Body1);
				$this->Send_HTML_Mail($mail_To, $mail_From,'', $mail_subject, $mail_Body);
				$this->redirect(array('controller' => 'abuse_reports', 'action' => 'admin_view', $id, $pass));
			}
			else{
				$this->Session->setFlash(sprintf(__('The product could not be deactivated. Please try again!', true), ''), 'default', array('class' => ''));
				$this->redirect(array('controller' => 'abuse_reports', 'action' => 'admin_view', $id, $pass));
			}
		}
		else{
			//echo $id;exit;
			$this->Product->id = $id;
			if($this->Product->saveField('blocked','1')){
				$this->Session->setFlash(sprintf(__('The product has been successfully deactivated.', true), ''), 'default', array('class' => 'success'));
				//$this->redirect(array('controller' => 'abuse_reports'));
				$mail_To = $report['User']['email'];
				$mail_From = $this->Session->read('Auth.User.email');
				$mail_subject = "Product has been deactivated.";
				$mail_Body1 = "Dear ".$report['User']['first_name'].",<br>Your product has been deactivated.<br/>Product id : ".$report['Product']['id']."<br>Product name : ".$report['Product']['product_name'];
				$mail_Body =nl2Br($mail_Body1);
				$this->Send_HTML_Mail($mail_To, $mail_From,'', $mail_subject, $mail_Body);
				$this->redirect(array('controller' => 'abuse_reports', 'action' => 'admin_index', $pass, $rpage));
			}
			else{
				$this->Session->setFlash(sprintf(__('The product could not be deactivated.Please try again!', true), ''), 'default', array('class' => ''));
				//$this->redirect(array('controller' => 'abuse_reports'));
				$this->redirect(array('controller' => 'abuse_reports', 'action' => 'admin_index', $pass, $rpage));
			}
		}
	}

	public function admin_post_delete($id = null, $abuseid=null, $pass=null){
		if (!$id){
			$this->Session->setFlash(__('ERROR :: Invalid Id', true));
			$this->redirect(array('action'=>'view', $abuseid, $pass));
		}
		$this->request->data = $this->Reply->read(null, $id);
		if ($this->Reply->delete($id)){
			$this->Session->setFlash(__('The comment has been deleted successfully.', true), 'default', array('class' => 'success'));
			$this->redirect(array('action'=>'view', $abuseid, $pass));
		}
		$this->Session->setFlash(__('ERROR :: The comment was not deleted.', true));
		$this->redirect(array('action'=>'view', $abuseid, $pass));
	}

	/* --------------------------------------------------------------- END :: ADMIN PANEL FUNCTIONS --------------------------------------- */

}
