<?php
App::uses('AppController', 'Controller');
/**
 * Products Controller
 *
 * @property Product $Product
 */
class ApprovalsController extends AppController {
	public $uses = array('Approval', 'User', 'Message');

	/* --------------------------------------------------------------- START :: ADMIN PANEL FUNCTIONS --------------------------------------- */
/**
 * index method
 *
 * @return void
 */
	public function admin_index(){
		if($this->Session->read('Auth.User.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		//$message=$this->paginate();
		//$this->set(compact('messages'));
		$this->set('approvals',$this->paginate());
		//pr($this->paginate());exit;
	}
	
	public function admin_add(){
		if($this->Session->read('Auth.User.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}		
		$approval=$this->Approval->find('list',array('fields'=>array('Approval.id','Approval.sent_from')));
		//pr($users);exit;		
		//$currency=$this->Currency->find('list',array('fields'=>array('Currency.currency_id','Currency.currency_name')));
		//pr($currency);exit;
		$users=$this->User->find('list',array('fields'=>array('User.id','User.email'),'conditions'=>array('User.user_type !='=>1)));		
		if(!empty($this->request->data)){
			$this->request->data['Approval']['send_on']=date('Y-m-d h:i:s');
			$this->Approval->create();
			if($this->Approval->save($this->request->data)){
				$this->Session->setFlash(sprintf(__('The Request has been successfully saved.', true), ''), 'default', array('class' => 'success'));
				$this->redirect('/admin/approvals/');
			}
		}
		$this->set(compact('users'));		
		$this->set(compact('approvals'));
		//pr($this->paginate());exit;
	}

	public function admin_edit($id = 0){
	    // echo 44;exit;
		if($this->Session->read('Auth.User.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		$approval=$this->Approval->read(null, $id);
		/*if (!$order){
			$this->Session->setFlash(__('ERROR :: Invalid Id.', true));
			$this->redirect(array('action'=>'index'));
		}*/
		$fileName = '';
		if (!empty($this->request->data)){
			//pr($this->request->data);exit;
			if ($this->Approval->save($this->request->data)){					
				$this->Session->setFlash(__('Request has been updated successfully.', true), 'default', array('class' => 'success'));
				$this->redirect('/admin/approvals/');
			} 
			else{
				$this->Session->setFlash(__('ERROR :: Request could not be updated. Please, try again.', true));
			}	
		}
		//$property=$this->Property->find('list',array('fields'=>array('Property.id','Property.property_title')));
		//$currency=$this->Currency->find('list',array('fields'=>array('Currency.currency_id','Currency.currency_name')));
		$users=$this->User->find('list',array('fields'=>array('User.id','User.email')));
		$status=array('1'=>'Accepted','0'=>'Rejected');
		$this->set(compact('users','id','status'));		
		if(empty($this->request->data)){
			$this->request->data = $approval;
			$temp=explode('-',$this->request->data['Approval']['sent_on']);			
			//$temp2=explode('-',$this->request->data['Approval']['from_date']);
			$this->request->data['Approval']['sent_on1']['year']=$temp[0];
			$this->request->data['Approval']['sent_on1']['month']=$temp[1];
			$this->request->data['Approval']['sent_on1']['day']=$temp[2];
			//$this->request->data['Order']['from_date1']['year']=$temp2[0];
			//$this->request->data['Order']['from_date1']['month']=$temp2[1];
			//$this->request->data['Order']['from_date1']['day']=$temp2[2];
		}
	}

	public function admin_delete($id = 0){
	    // echo 44;exit;
		if($this->Session->read('Auth.User.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		$approval=$this->Approval->read(null, $id);
		if (!$order){
			$this->Session->setFlash(__('ERROR :: Invalid Id.', true));
			$this->redirect(array('action'=>'index'));
		}
		if($this->Approval->delete($id)){
			$this->Session->setFlash(sprintf(__('ERROR :: Approval deleted successfully', true), ''));
			$this->redirect('/admin/approvals/');
		}
	}
	
	function contact_me($id=0){
	   //echo $property_id; exit;	    
	    if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}		
		if(!empty($this->request->data)){
			pr($this->request->data); //exit();
		    $user=$this->User->find('first',array('conditions'=>array('User.id'=>$id)));
			$sent_on = date('Y-m-d h:i:s');
			$this->request->data['Approval']['sent_from'] = $this->request->data['Approvals']['sender'];
			$this->request->data['Approval']['sent_to'] = $this->request->data['Approvals']['receiver'];
			$this->request->data['Approval']['message'] = $this->request->data['Approvals']['message'];	 
			$this->request->data['Approval']['sent_on'] = $sent_on;
			$this->Approval->create(); 	
			if($this->Approval->save($this->request->data['Approval'])){		  
				$this->request->data['Message']['send_date'] = $sent_on;					
				$this->request->data['Message']['to_user'] = $this->request->data['Approvals']['receiver'];
				$this->request->data['Message']['from_user'] = $this->request->data['Approvals']['sender'];
				$this->request->data['Message']['message'] = $this->request->data['Approvals']['message'];
				$this->request->data['Message']['approval_id']=$this->Approval->id;			
				$this->Message->create();						
				if($this->Message->save($this->request->data['Message'])){				
					$this->redirect('/users/dashboard');
				}				 			     
			}
			//$this->redirect('/users/dashboard');
	    }
		$user=$this->User->read(null, $id);
	    $this->set(compact('user'));
    }

	/* --------------------------------------------------------------- END :: ADMIN PANEL FUNCTIONS --------------------------------------- */

}
