<?php
App::uses('AppController', 'Controller');
/**
 * Blogs Controller
 *
 * @property Blog $Blog
 */
class ArticlesController extends AppController {


/* --------------------------------------------------------------- START :: ADMIN PANEL FUNCTIONS --------------------------------------- */
/**
 * index method
 *
 * @return void
 */
	public function admin_index(){
		$this->Article->recursive = 0;
		$this->set('articles', $this->paginate());
	}

/**
 * add method
 *
 * @return void
 */
	public function admin_add(){
		if ($this->request->is('post')){
			$get_blog_name = $this->Article->find('first', array('conditions' => array('Article.title' => $this->request->data['Article']['title'])));
			if($get_blog_name){
				$this->Session->setFlash(__('ERROR :: Same article title already exists.', true));
			}
			else{
				$this->Article->create();
				if ($this->Article->save($this->request->data)){
					$this->Session->setFlash(__('The article has been saved successfully.', true), 'default', array('class' => 'success'));
					$this->redirect(array('action' => 'index'));
				} 
				else{
					$this->Session->setFlash(__('ERROR :: The article could not be saved. Please, try again.', true));
				}
			}			
		}
		$users = $this->Article->User->find('list');
		$this->set(compact('users'));
	}

/**
 * edit method
 *
 * @throws NotFoundException
 * @param string $id
 * @return void
 */
	public function admin_edit($id = null){
		$this->Article->id = $id;
		if (!$this->Article->exists()){
			throw new NotFoundException(__('ERROR :: Invalid Article'));
		}
		if ($this->request->is('post') || $this->request->is('put')){
			$get_blog_name = $this->Article->find('first', array('conditions' => array('Article.title' => $this->request->data['Article']['title'], 'Article.id <>' => $this->request->data['Article']['id'])));
			if($get_blog_name){
				$this->Session->setFlash(__('ERROR :: Same Article already exists.', true));
			}
			else{
				if ($this->Article->save($this->request->data)){
					$this->Session->setFlash(__('The article has been saved successfully.', true), 'default', array('class' => 'success'));
					$this->redirect(array('action' => 'index'));
				} 
				else{
					$this->Session->setFlash(__('ERROR :: The article could not be saved. Please, try again.', true));
				}
			}
		} 
		else{
			$this->request->data = $this->Article->read(null, $id);
		}
		$users = $this->Article->User->find('list');
		$this->set(compact('users'));
	}

	public function admin_delete($id = null){
		if (!$id){
			$this->Session->setFlash(__('ERROR :: Invalid Id for Article', true));
			$this->redirect(array('action'=>'index'));
		}

		$this->request->data = $this->Article->read(null, $id);
		if ($this->Article->delete($id)){
			$this->Session->setFlash(__('The Article has been deleted successfully.', true), 'default', array('class' => 'success'));
			$this->redirect(array('action'=>'index'));
		}
		$this->Session->setFlash(__('ERROR :: The Article was not deleted.', true));
		$this->redirect(array('action' =>'index'));
	}

	/* --------------------------------------------------------------- END :: ADMIN PANEL FUNCTIONS --------------------------------------- */

	public function index(){
		$this->Article->recursive = 0;
		$this->paginate = array('conditions' => array('Article.status' => 1), 'order' => array('Article.id' => 'DESC'));
		$this->set('article', $this->paginate());
	}

	public function details($id = null){
		$this->Article->id = $id;
		if (!$this->Article->exists()) {
			throw new NotFoundException(__('Invalid Article'));
		}
		$this->set('article', $this->Blog->read(null, $id));
	}

}
