<?php
App::uses('AppController', 'Controller');
/**
 * Blogs Controller
 *
 * @property Blog $Blog
 */
class BlogsController extends AppController {


/* --------------------------------------------------------------- START :: ADMIN PANEL FUNCTIONS --------------------------------------- */
/**
 * index method
 *
 * @return void
 */
	public function admin_index(){
		$this->Blog->recursive = 0;
		$this->set('blogs', $this->paginate());
	}

/**
 * add method
 *
 * @return void
 */
	public function admin_add(){
		if ($this->request->is('post')){
			$get_blog_name = $this->Blog->find('first', array('conditions' => array('Blog.title' => $this->request->data['Blog']['title'])));
			if($get_blog_name){
				$this->Session->setFlash(__('ERROR :: Same blog title already exists.', true));
			}
			else{
				$this->Blog->create();
				if ($this->Blog->save($this->request->data)){
					$this->Session->setFlash(__('The blog has been saved successfully.', true), 'default', array('class' => 'success'));
					$this->redirect(array('action' => 'index'));
				} 
				else{
					$this->Session->setFlash(__('ERROR :: The blog could not be saved. Please, try again.', true));
				}
			}			
		}
		$users = $this->Blog->User->find('list');
		$this->set(compact('users'));
	}

/**
 * edit method
 *
 * @throws NotFoundException
 * @param string $id
 * @return void
 */
	public function admin_edit($id = null){
		$this->Blog->id = $id;
		if (!$this->Blog->exists()){
			throw new NotFoundException(__('ERROR :: Invalid blog'));
		}
		if ($this->request->is('post') || $this->request->is('put')){
			$get_blog_name = $this->Blog->find('first', array('conditions' => array('Blog.title' => $this->request->data['Blog']['title'], 'Blog.id <>' => $this->request->data['Blog']['id'])));
			if($get_blog_name){
				$this->Session->setFlash(__('ERROR :: Same blog already exists.', true));
			}
			else{
				if ($this->Blog->save($this->request->data)){
					$this->Session->setFlash(__('The blog has been saved successfully.', true), 'default', array('class' => 'success'));
					$this->redirect(array('action' => 'index'));
				} 
				else{
					$this->Session->setFlash(__('ERROR :: The blog could not be saved. Please, try again.', true));
				}
			}
		} 
		else{
			$this->request->data = $this->Blog->read(null, $id);
		}
		$users = $this->Blog->User->find('list');
		$this->set(compact('users'));
	}

	public function admin_delete($id = null){
		if (!$id){
			$this->Session->setFlash(__('ERROR :: Invalid Id for blog', true));
			$this->redirect(array('action'=>'index'));
		}

		$this->request->data = $this->Blog->read(null, $id);
		if ($this->Blog->delete($id)){
			$this->Session->setFlash(__('The blog has been deleted successfully.', true), 'default', array('class' => 'success'));
			$this->redirect(array('action'=>'index'));
		}
		$this->Session->setFlash(__('ERROR :: The blog was not deleted.', true));
		$this->redirect(array('action' =>'index'));
	}

	/* --------------------------------------------------------------- END :: ADMIN PANEL FUNCTIONS --------------------------------------- */

	public function index(){
		$this->Blog->recursive = 0;
		$this->paginate = array('conditions' => array('Blog.status' => 1), 'order' => array('Blog.id' => 'DESC'));
		$this->set('blogs', $this->paginate());
	}

	public function details($id = null){
		$this->Blog->id = $id;
		if (!$this->Blog->exists()) {
			throw new NotFoundException(__('Invalid blog'));
		}
		$this->set('blog', $this->Blog->read(null, $id));
	}

}
