<?php
App::uses('AppController', 'Controller');
/**
* Products Controller
*
* @property Product $Product
*/
class BooksController extends AppController {
	public $uses = array('Sumhit', 'User', 'Transaction', 'Message', 'Product');
/* --------------------------------------------------------------- START :: ADMIN PANEL FUNCTIONS --------------------------------------- */
	function beforeFilter(){
    	$this->myRandomNumber = rand();
	}
/**
* index method
*
* @return void
*/
	public function admin_index(){
		$this->layout = 'admin';
		if($this->Session->read('Auth.Admin.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		$sumhits = $this->Sumhits->find('all', array('conditions' => array('Sumhits.status' => '1')));
		$this->set('sumhits', $this->paginate());
	}
/* --------------------------------------------------------------- END :: ADMIN PANEL FUNCTIONS --------------------------------------- */
	function add(){
		$this->layout = 'default';
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		$flag = true;
		$fileName = '';
		if(!empty($this->request->data)){
			$flag = true;
			//pr($this->request->data);exit;
			 
			$upc = $this->request->data['Product']['upc'];
			if($upc != ""){
				if(ctype_alnum($upc) !=1)
				{
					$this->Session->setFlash(sprintf(__('ERROR :: Upc field must with (A to Z or 1-9).', true)));
					$flag = false;
				}
				
				if (strlen($upc)>13) {
					$this->Session->setFlash(sprintf(__('ERROR :: Upc field maximum content 13 character.', true)));
					$flag = false;
				}
			}
			if(isset($this->request->data['Product']['image']['tmp_name']) && is_uploaded_file($this->request->data['Product']['image']['tmp_name'])){
				
				$image_info = getimagesize($this->request->data['Product']['image']['tmp_name']);
				
				//pr($image_info);exit;
				
				if($image_info[0] < 250){ $this->Session->setFlash(__('ERROR :: Image Minimum Dimention: 200 X 200.', true)); $flag = false; }
				if($image_info[1] < 250){ $this->Session->setFlash(__('ERROR :: Image Minimum Dimention: 200 X 200.', true)); $flag = false; }
							
				$extentioni = strtolower(strrchr($this->request->data['Product']['image']['name'], "."));
				$fileDetaili = $this->request->data['Product']['image'];
				$this->request->data['Product']['image'] = " ";					
				if(!in_array($extentioni, $this->validImageFormats)){
					$flag = false;
					$this->Session->setFlash(sprintf(__('ERROR :: Please upload photo only having %s extensions.', true), implode(", ", $this->validImageFormats)));
				}
			} else {
				$this->request->data['Product']['image'] = "";
				//$this->request->data['Product']['image'] = $this->request->data['Product']['image'];
			}			
			
			if(isset($this->request->data['Product']['pdf']['tmp_name']) && is_uploaded_file($this->request->data['Product']['pdf']['tmp_name'])){
				$extentionp = strtolower(strrchr($this->request->data['Product']['pdf']['name'], "."));
				$fileDetailp = $this->request->data['Product']['pdf'];
				$this->request->data['Product']['pdf'] = " ";					
				if(!in_array($extentionp, $this->validPdfFormats)){
					$flag = false;
					$this->Session->setFlash(sprintf(__('ERROR :: Please upload pdf only .', true), implode(", ", $this->validImageFormats)));
				}
			} else {
				$this->request->data['Product']['pdf'] = "";
				//$this->request->data['Product']['pdf'] = $this->request->data['Product']['pdf'];
			}			
				
			$this->request->data['Product']['user_id'] = $this->Session->read('Auth.User.id');
			$this->request->data['Product']['post_date'] = date('Y-m-d h:i:s');
			$this->request->data['Product']['blocked'] = 0;
			
			
			if($flag){
				$this->Product->create();
				if($this->Product->save($this->request->data)){
					if(isset($fileDetaili) && is_uploaded_file($fileDetaili['tmp_name'])){
						$fileNamei = $this->Session->read('Auth.User.id').$this->request->data['Product']['product_name'].$extentioni;
						
						$width = 250; $height = 250;
						$this->request->data['Product']['image'] = $fileDetaili;
						list($w, $h) = getimagesize($this->request->data['Product']['image']['tmp_name']);
						/* calculate new image size with ratio */
						$ratio = max($width/$w, $height/$h);
						$h = ceil($height / $ratio);
						$x = ($w - $width / $ratio) / 2;
						$w = ceil($width / $ratio);
						/* new file name */
						$path = BOOKS_IMAGES . $fileNamei;
						/* read binary data from image file */
						$imgString = file_get_contents($this->request->data['Product']['image']['tmp_name']);
						/* create image from string */
						$image = imagecreatefromstring($imgString);
						$tmp = imagecreatetruecolor($width, $height);
						imagecopyresampled($tmp, $image, 0, 0, $x, 0, $width, $height, $w, $h);
						/* Save image */
						switch ($this->request->data['Product']['image']['type']) {
							case 'image/jpeg':
								imagejpeg($tmp, $path, 100);
								break;
							case 'image/png':
								imagepng($tmp, $path, 0);
								break;
							case 'image/gif':
								imagegif($tmp, $path);
								break;
							default:
								exit;
								break;
						}
						imagedestroy($image); imagedestroy($tmp);						
						
						
						
						
						
						
						//move_uploaded_file($fileDetaili['tmp_name'], BOOKS_IMAGES . $fileNamei);
						$this->Product->saveField('image', $fileNamei);
						/*if($this->request->data['Product']['image'] != ' ' && $this->request->data['Product']['image'] != $fileName){
							if(file_exists(PROD_IMAGES . $this->request->data['Product']['image'])){
								unlink(PROD_IMAGES . $this->request->data['Product']['image']);
								}
							}*/
						//$this->request->data['Product']['image'] = $fileName;
					}
					if(isset($fileDetailp) && is_uploaded_file($fileDetailp['tmp_name'])){
						$fileNamep = $this->Session->read('Auth.User.id').$this->request->data['Product']['product_name'].$extentionp;
						move_uploaded_file($fileDetailp['tmp_name'], BOOKS_PDFS . $fileNamep);
						$this->Product->saveField('pdf', $fileNamep);
						/*if($this->request->data['Product']['image'] != ' ' && $this->request->data['Product']['image'] != $fileName){
							if(file_exists(PROD_IMAGES . $this->request->data['Product']['image'])){
								unlink(PROD_IMAGES . $this->request->data['Product']['image']);
								}
							}*/
						//$this->request->data['Product']['image'] = $fileName;
					}					
					
					
					
					
						$this->Session->setFlash(__('Books has been added successfully.', true),'default', array('class' => 'success'));
						$this->redirect(array('action' => ''));
				} else {
				  $this->Session->setFlash(__('ERROR :: Books could not be added. Please, try again.', true));
				}
			}
		}	
	}



	function edit($id = null){
		$this->layout = 'default';
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		$flag = true;
		$fileName = '';
		if(!empty($this->request->data)){
			$flag = true;
			//pr($this->request->data); exit;
			$pre_image = $this->request->data['Product']['pre_image'];
			$pre_pdf = $this->request->data['Product']['pre_pdf'];
			
			
			$upc = $this->request->data['Product']['upc'];
			if($upc != ""){			
				if(ctype_alnum($upc) !=1)
				{
					$this->Session->setFlash(sprintf(__('ERROR :: Upc field must with (A to Z or 1-9).', true)));
					$flag = false;
				}
				
				if (strlen($upc)>13) {
					$this->Session->setFlash(sprintf(__('ERROR :: Upc field maximum content 13 character.', true)));
					$flag = false;
				}
			}
			
			
			if(isset($this->request->data['Product']['image']['tmp_name']) && $this->request->data['Product']['image']['tmp_name']!='' && is_uploaded_file($this->request->data['Product']['image']['tmp_name'])){
				$extentioni = strtolower(strrchr($this->request->data['Product']['image']['name'], "."));
				$fileDetaili = $this->request->data['Product']['image'];
				$this->request->data['Product']['image'] = '';					
				if(!in_array($extentioni, $this->validImageFormats)){
					$this->request->data['Product']['pre_image'] = $pre_image;
					$flag = false;
					$this->Session->setFlash(sprintf(__('ERROR :: Please upload photo only having %s extensions.', true), implode(", ", $this->validImageFormats)));
				}
				
			} else {
				$this->request->data['Product']['image'] = $this->request->data['Product']['pre_image'];
			}			
			
			if(isset($this->request->data['Product']['pdf']['tmp_name']) && $this->request->data['Product']['pdf']['tmp_name']!='' && is_uploaded_file($this->request->data['Product']['pdf']['tmp_name'])){
				$extentionp = strtolower(strrchr($this->request->data['Product']['pdf']['name'], "."));
				$fileDetailp = $this->request->data['Product']['pdf'];
				$this->request->data['Product']['pdf'] = '';					
				if(!in_array($extentionp, $this->validPdfFormats)){
					$this->request->data['Product']['pre_pdf'] = $pre_pdf;
					$flag = false;
					$this->Session->setFlash(sprintf(__('ERROR :: Please upload pdf only .', true), implode(", ", $this->validImageFormats)));
				}
				
			} else {
				$this->request->data['Product']['pdf'] = $this->request->data['Product']['pre_pdf'];
			}			
				
			$this->request->data['Product']['user_id'] = $this->Session->read('Auth.User.id');
			//$this->request->data['Product']['post_date'] = date('Y-m-d h:i:s');
			$this->request->data['Product']['blocked'] = 0;
			
			//pr($this->request->data);exit;
			

			
			if($flag){
				$this->Product->create();
				if($this->Product->save($this->request->data)){
					if(isset($fileDetaili) && is_uploaded_file($fileDetaili['tmp_name'])){
						$fileNamei = $this->Session->read('Auth.User.id').$this->request->data['Product']['product_name'].$extentioni;
						move_uploaded_file($fileDetaili['tmp_name'], BOOKS_IMAGES . $fileNamei);
						$this->Product->saveField('image', $fileNamei);
						if($this->request->data['Product']['pre_image'] != '' && $this->request->data['Product']['pre_image'] != $fileNamei){
							if(file_exists(BOOKS_IMAGES . $this->request->data['Product']['pre_image'])){
								unlink(BOOKS_IMAGES . $this->request->data['Product']['pre_image']);
							}
						}
						$this->request->data['Product']['image'] = $fileNamei;
					} 
					
					if(isset($fileDetailp) && is_uploaded_file($fileDetailp['tmp_name'])){
						$fileNamep = $this->Session->read('Auth.User.id').$this->request->data['Product']['product_name'].$extentionp;
						move_uploaded_file($fileDetailp['tmp_name'], BOOKS_PDFS . $fileNamep);
						$this->Product->saveField('pdf', $fileNamep);
						if($this->request->data['Product']['pre_pdf'] != '' && $this->request->data['Product']['pre_pdf'] != $fileNamep){
							if(file_exists(BOOKS_PDFS . $this->request->data['Product']['pre_pdf'])){
								unlink(BOOKS_PDFS . $this->request->data['Product']['pre_pdf']);
								}
							}
						$this->request->data['Product']['pre_pdf'] = $fileNamep;
					} 			
					
					
					
					
						$this->Session->setFlash(__('Books has been edited successfully.', true),'default', array('class' => 'success'));
						$this->redirect(array('controller' => 'users', 'action' => 'bookshelf', $this->Session->read('Auth.User.id')));
				} else {
				  $this->Session->setFlash(__('ERROR :: Books could not be edited. Please, try again.', true));
				}
			}
		} else {
		
			$this->request->data = $this->Product->read(null, $id);
			$this->request->data['Product']['pre_pdf'] = $this->request->data['Product']['pdf'];
			$this->request->data['Product']['pre_image'] = $this->request->data['Product']['image'];
			//pr($book);exit;
			//$this->set(compact('book'));
		}
	}
















	function sumhitsdetail($id = null){
		$this->layout = 'default';
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		$uid = $this->Session->read('Auth.User.id');
		$curdate = date('Y-m-d h:i:s');
		$seminars = $this->Seminar->find('all', array('conditions' => array('Seminar.id' => $id, 'Seminar.status' => '1')));
		$this->set(compact('seminars', 'id', 'uid', 'curdate'));
		$go = "";
		$uid = "";									
		if(!empty($this->request->data)){
			$uid = $this->Session->read('Auth.User.id');
			$title = $this->request->data['Seminar']['title'];
			$reg_cost = $this->request->data['Seminar']['reg_cost'];
			$organizer = $this->request->data['Seminar']['user_id'];
			$go = 1;
			$id = $this->request->data['Seminar']['semid'];
		}
		$this->set(compact('go', 'uid', 'id', 'title', 'reg_cost', 'organizer'));
	}
	public function thankyou(){
		if(!empty($_GET)){
			$id = explode("@", $_GET['cm']);
			$transaction = $_GET['tx'];
			$status = $_GET['st'];
			$paidon = date('Y-m-d h:i:s');
			$this->request->data['Transaction']['sem_id'] = $id[0];
			$this->request->data['Transaction']['web_id'] = '0';
			$this->request->data['Transaction']['work_id'] = '0';
			$this->request->data['Transaction']['cou_id'] = '0';
			$this->request->data['Transaction']['pub_id'] = '0';
			$this->request->data['Transaction']['ticket'] = $this->myRandomNumber;
			$this->request->data['Transaction']['type'] = '1';
			$this->request->data['Transaction']['user_id'] = $this->Session->read('Auth.User.id');
			$this->request->data['Transaction']['transaction_id'] = $transaction;
			$this->request->data['Transaction']['status'] = $status;
			$this->request->data['Transaction']['paidon'] = $paidon;
			$this->request->data['Transaction']['amount'] = $_GET['amt'];
			$this->request->data['User']['send_date'] = $paidon;
			$this->request->data['User']['from_user'] = $id[1];
			$this->request->data['User']['to_user'] = $this->Session->read('Auth.User.id');
			$this->request->data['User']['message'] = "Your ticket number for the Seminar is " . $this->request->data['Transaction']['ticket'];
			$this->Transaction->create();
		 	if($this->Transaction->save($this->request->data)){
				$this->Session->setFlash(__('Seminar has been updated successfully.', true),'default', array('class' => 'success'));
				$this->Message->create();
				if($this->Message->save($this->request->data['User'])){
				}
		 		$this->redirect('/users/dashboard/');
		 	}
		 	else{
		 		$this->Session->setFlash(__('ERROR :: Seminar could not be updated. Please, try again.', true));
		 	}
		}
	}
	public function notify(){
		$this->layout = false;
		if(!empty($_GET)){
			$id = explode("@", $_GET['cm']);
			$transaction = $_GET['tx'];
			$status = $_GET['st'];
			$paidon = date('Y-m-d h:i:s');
			$this->request->data['Transaction']['sem_id'] = $id[0];
			$this->request->data['Transaction']['web_id'] = '0';
			$this->request->data['Transaction']['work_id'] = '0';
			$this->request->data['Transaction']['cou_id'] = '0';
			$this->request->data['Transaction']['pub_id'] = '0';
			$this->request->data['Transaction']['type'] = '1';
			$this->request->data['Transaction']['user_id'] = $this->Session->read('Auth.User.id');
			$this->request->data['Transaction']['transaction_id'] = $transaction;
			$this->request->data['Transaction']['status'] = $status;
			$this->request->data['Transaction']['paidon'] = $paidon;
			$this->request->data['Transaction']['amount'] = $_GET['amt'];
			$this->request->data['User']['from_user'] = $id[1];
			$this->request->data['User']['to_user'] = $this->Session->read('Auth.User.id');
			$this->request->data['User']['message'] = "Your ticket number for the Seminar is " . $this->request->data['Transaction']['ticket'];
			$this->Transaction->create();
		 	if($this->Transaction->save($this->request->data)){
				$this->Session->setFlash(__('Seminar has been updated successfully.', true),'default', array('class' => 'success'));
		 		$this->Message->create();
				if($this->Message->save($this->request->data['User'])){
				}
		 		$this->redirect('/users/dashboard/');
		 	}
		 	else{
		 		$this->Session->setFlash(__('ERROR :: Seminar could not be updated. Please, try again.', true));
		 	}
		}
		exit;
	}
	/*archive*/
	public function archive($id=null){
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		$uid = $this->Session->read('Auth.User.id');
		$curdate = date('Y-m-d h:i:s');
		$this->Transaction->recursive = 3;
		$reg_infos = $this->Transaction->find('all', array('conditions' => array('Transaction.type' => '1', 'Transaction.status' => 'Completed')));
		$get_user = $this->User->find('first', array('conditions' => array('User.id' => $uid)));
		$dates = $this->Product->find('all', array('conditions' => array('Product.user_id' => $uid, 'Product.blocked' => 0, 'Product.product_type_id' => 1)));
		
		$archives = $this->Product->find('all',
													array(
													'conditions' => array('Product.user_id'=>$uid),
													'fields'=>array('DATE_FORMAT(Product.post_date, \'%Y %M\') AS  arch','count(Product.id) AS numblogs'),
													'order' => array('Product.post_date'=>'ASC'),
													'group'=>array('arch')
													));
		
		
		
		
		$this->set(compact('seminars', 'id', 'uid', 'get_user', 'curdate', 'reg_infos','archives'));
	}
	/*detail*/
	public function detail($id = null){
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		
				$date_var = explode("-", $id);
				if($date_var[1] == "January"){
					$d = $date_var[0]."-01";
				} else if($date_var[1] == "February"){
					$d = $date_var[0]."-02";
				} else if($date_var[1] == "March"){
					$d = $date_var[0]."-03";
				} else if($date_var[1] == "April"){
					$d = $date_var[0]."-04";
				} else if($date_var[1] == "May"){
					$d = $date_var[0]."-05";
				} else if($date_var[1] == "June"){
					$d = $date_var[0]."-06";
				} else if($date_var[1] == "July"){
					$d = $date_var[0]."-07";
				} else if($date_var[1] == "August"){
					$d = $date_var[0]."-08";
				} else if($date_var[1] == "September"){
					$d = $date_var[0]."-09";
				} else if($date_var[1] == "October"){
					$d = $date_var[0]."-10";
				} else if($date_var[1] == "November"){
					$d = $date_var[0]."-11";
				} else if($date_var[1] == "December"){
					$d = $date_var[0]."-12";
				}
		
		
		
		$uid = $this->Session->read('Auth.User.id');
		$curdate = date('Y-m-d h:i:s');
		$this->Transaction->recursive = 3;
		$reg_infos = $this->Transaction->find('all', array('conditions' => array('Transaction.type' => '1', 'Transaction.status' => 'Completed')));
		$get_user = $this->User->find('first', array('conditions' => array('User.id' => $uid)));
		$dts = $this->Product->find('all', array('conditions' => array('Product.post_date LIKE' => $d.'%','Product.user_id' => $uid,'Product.product_type_id' => 1)));
		
		//pr($dts);exit;
		
		
		$this->set(compact('seminars', 'id', 'uid', 'get_user', 'curdate', 'reg_infos', 'dts', 'd'));
	}
	/*registrants*/
	public function registrants($id=null){
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		$uid = $this->Session->read('Auth.User.id');
		$curdate = date('Y-m-d h:i:s');
		$this->Transaction->recursive = 3;
		$reg_infos = $this->Transaction->find('all', array('conditions' => array('Transaction.type' => '1', 'Transaction.status' => 'Completed')));
		$get_user = $this->User->find('first', array('conditions' => array('User.id' => $uid)));
		$seminars = $this->Seminar->find('all', array('conditions' => array('Seminar.user_id' => $id, 'Seminar.status' => '1')));
		$this->set(compact('seminars', 'id', 'uid', 'get_user', 'curdate', 'reg_infos'));
	}
	/*payments*/
	public function payments($id=null){
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		$uid = $this->Session->read('Auth.User.id');
		$curdate = date('Y-m-d h:i:s');
		$reg_infos = $this->Transaction->find('all', array('conditions' => array('Transaction.type' => '1', 'Transaction.status' => 'Completed')));
		$total = $this->Transaction->find('list', array('fields' => 'Transaction.amount', 'conditions' => array('Transaction.type' => '1', 'Transaction.status' => 'Completed')));
		$get_user = $this->User->find('first', array('conditions' => array('User.id' => $uid)));
		$seminars = $this->Seminar->find('all', array('conditions' => array('Seminar.user_id' => $id, 'Seminar.status' => '1')));
		$this->set(compact('seminars', 'id', 'uid', 'get_user', 'curdate', 'reg_infos', 'total'));
	}
}