<?php
App::uses('AppController', 'Controller');
/**
 * Categories Controller
 *
 * @property Category $Category
 */
class CategoriesController extends AppController {

	/* --------------------------------------------------------------- START :: ADMIN PANEL FUNCTIONS --------------------------------------- */

	public function admin_index(){
		if($this->Session->read('Auth.Admin.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		$total_cat="";
		$total=$this->Category->find('count');
		for($i=1;$i<=$total;$i++){
			$total_cat[$i]=$i;
		}
		$this->Category->recursive = 0;
		$this->paginate = array('order' => array('display_order' => 'asc'));		
		$cat = $this->Category->find('all');
		//pr($cat);exit;		
		$this->set('categories', $this->paginate());
		//$this->set('cat', $cat);
		$this->set(compact('cat'));
		$this->set(compact('total_cat'));
	}

	public function admin_add(){
		if($this->Session->read('Auth.Admin.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		$total_cat="";
		$total=$this->Category->find('count') +1;
		for($i=1;$i<=$total;$i++){
			$total_cat[$i]=$i;
		}
		$all_parent="";
		$data_parent = $this->Category->find('list',array('fields'=>array('Category.id','Category.category_name')));
		if (!empty($this->request->data)){
			$get_category_name = $this->Category->find('first', array('conditions' => array('Category.category_name' => $this->request->data['Category']['category_name'])));
			if($get_category_name){
				$this->Session->setFlash(__('ERROR :: Same category already exists.', true));
			}
			else{
				$this->Category->create();
				$display_order_exist=$this->Category->find('first',array('conditions'=>array('Category.display_order'=>$this->request->data['Category']['display_order'])));
				if ($this->Category->save($this->request->data)){					
					if($display_order_exist && $this->request->data['Category']['display_order']!=$total){
						$this->request->data=$display_order_exist;
						$this->request->data['Category']['display_order']=$total;
						$this->Category->save($this->request->data);
					}
					$this->Session->setFlash(__('The category has been saved successfully.', true), 'default', array('class' => 'success'));
					$this->redirect(array('action' => 'index'));
				} 
				else{
					$this->Session->setFlash(__('ERROR :: The category could not be saved. Please, try again.', true));
				}
			}
		}

		if (empty($this->request->data)){
			$this->request->data['Category']['display_order']=$total;
		}
		$this->set(compact('total_cat','data_parent'));
	}

	public function admin_edit($id = null){
		if($this->Session->read('Auth.Admin.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		$total_cat="";
		$total=$this->Category->find('count');
		for($i=1;$i<=$total;$i++){
			$total_cat[$i]=$i;
		}
		$all_parent="";
		$data_parent = $this->Category->find('list',array('fields'=>array('Category.id','Category.category_name'),'conditions'=>array('Category.id !='=>$id)));
		if (!$id && empty($this->request->data)){
			$this->Session->setFlash(__('ERROR :: Invalid category.', true));
			$this->redirect(array('action' => 'index'));
		}
		if (!empty($this->request->data)){			
			$get_category_name = $this->Category->find('first', array('conditions' => array('Category.category_name' => $this->request->data['Category']['category_name'], 'Category.id <>' => $this->request->data['Category']['id'])));
			if($get_category_name){
				$this->Session->setFlash(__('ERROR :: Same category already exists.', true));
			}
			else{
				$display_order_exist=$this->Category->find('first',array('conditions'=>array('Category.display_order'=>$this->request->data['Category']['display_order'])));
				if ($this->Category->save($this->request->data)){
					if($display_order_exist && $this->request->data['Category']['display_order']!=$this->request->data['Category']['prev_order']){
						$prev_order=$this->request->data['Category']['prev_order'];
						$this->request->data=$display_order_exist;
						$this->request->data['Category']['display_order']=$prev_order;
						$this->Category->save($this->request->data);						
					}
					$this->Session->setFlash(__('The category has been saved successfully.', true), 'default', array('class' => 'success'));
					$this->redirect(array('action' => 'index'));
				} 
				else{
					$this->Session->setFlash(__('ERROR :: The category could not be saved. Please, try again.', true));
				}
			}
		}
		if (empty($this->request->data)) {
			$this->request->data = $this->Category->read(null, $id);
			$this->request->data['Category']['prev_order']=$this->request->data['Category']['display_order'];			
		}
		$this->set(compact('total_cat','data_parent'));
	}

	public function admin_setorder(){
	   if($this->Session->read('Auth.Admin.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
	   }
	   $this->layout = false;
	   $display_order_exist=$this->Category->find('first',array('conditions'=>array('Category.display_order'=>$_POST['displayid'])));
	   if($display_order_exist && $_POST['displayid']!=$_POST['previd']){
			$dt['Category']['id'] = $_POST['catid'];
			$dt['Category']['display_order'] = $_POST['displayid'];
			$this->Category->save($dt);						
			$dt['Category']['id'] = $display_order_exist['Category']['id'];
			$dt['Category']['display_order'] = $_POST['previd'];
			$this->Category->save($dt);		
	   }
	   $this->Session->setFlash(__('The category display order has been set successfully.', true), 'default', array('class' => 'success'));
	   exit;
	}

	/* --------------------------------------------------------------- END :: ADMIN PANEL FUNCTIONS --------------------------------------- */

	function index($cat=null){
		$this->Category->recursive=2;
		$category="";
		if($cat){
			$category=$this->Category->find('first',array('conditions'=>array('Category.category_name'=>$cat)));
		}
		/*elseif(isset($this->request->data['Category']['key']) && $this->request->data['Category']['key']){
			$keys=explode(' ',trim($this->request->data['Category']['key']));
			$temp=array();
			
			for($i=0;$i<count($keys);$i++){
				array_push($temp,"Category.category_name LIKE '%".$keys[$i]."%'");
			}

			$where= 'WHERE ('.implode(' || ',$temp).')';
			//echo $where;
			//exit;
			$this

		}*/
		else{
			$category=$this->Category->find('first',array('conditions'=>array('Category.display_order'=>1)));
			$this->redirect(array('action'=>'index/'.$category['Category']['category_name']));
		}
		$this->set('tagtype',$category['TagType']);
		$this->set('products',$category['Product']);
	}
}
