<?php
App::uses('AppController', 'Controller');
/**
* Products Controller
*
* @property Product $Product
*/
class FunnelsController extends AppController {
	public $uses = array('Funnel', 'User', 'Transaction', 'Message');
/* --------------------------------------------------------------- START :: ADMIN PANEL FUNCTIONS --------------------------------------- */
	/*function beforeFilter(){
    	$this->myRandomNumber = rand();
	}*/


	public function admin_delete($id = null,$type=null){
      
	  if($this->Session->read('Auth.Admin.user_type')!=1)
		{
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		
		
		$this->Funnel->id = $id;
		if (!$this->Funnel->exists()){
			throw new NotFoundException(__('Invalid product'));
		}
		
		
		$report = $this->Funnel->read(null, $id);
		//pr($report); exit;
		if ($this->Funnel->delete()){

				if($report['Funnel']['file'] != ""){
					if(file_exists(WEBINNER_FILE . $report['Funnel']['file'])){
						unlink(WEBINNER_FILE . $report['Funnel']['file']);
					}
				}
				$this->Session->setFlash(sprintf(__('The Funnel has been deleted successfully.', true), ''), 'default', array('class' => 'success'));
				$this->redirect(array('controller' => 'funnels', 'action' => 'index'));
		
		}
		
		$this->Session->setFlash(__('Sumhit was not deleted'));
		$this->redirect(array('action' => 'index'));
	}


	public function admin_activate($id=null){

       if($this->Session->read('Auth.Admin.user_type')!=1)
		{
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		$report = $this->Funnel->read(null, $id);
		
		$this->Funnel->id = $id;
		if($this->Funnel->saveField('status','1')){

				$this->Session->setFlash(sprintf(__('The Funnel has been successfully activated.', true), ''), 'default', array('class' => 'success'));
				$this->redirect(array('controller' => 'funnels', 'action' => 'index'));

		} else {
				$this->Session->setFlash(sprintf(__('The Funnel could not be deactivated.Please try again!', true), ''), 'default', array('class' => ''));
				$this->redirect(array('controller' => 'funnels', 'action' => 'index'));
	
		}
	}

	public function admin_deactivate($id=null){
		
		if($this->Session->read('Auth.Admin.user_type')!=1)
		{
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		
		$report = $this->Funnel->read(null, $id);
		//echo $id; exit;
		
		//pr($report);exit;
		$this->Funnel->id = $id;
		if($this->Funnel->saveField('status','0')){
			$this->Session->setFlash(sprintf(__('The Funnel has been successfully deactivated.', true), ''), 'default', array('class' => 'success'));
			$this->redirect(array('controller' => 'funnels', 'action' => 'index'));
		} else {
			$this->Session->setFlash(sprintf(__('The Funnel could not be deactivated.Please try again!', true), ''), 'default', array('class' => ''));
			$this->redirect(array('controller' => 'funnels', 'action' => 'index'));
		}
	}	

	public function admin_index(){
		$this->layout = 'admin';
		if($this->Session->read('Auth.Admin.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
	  // pr($this->Session->read('funnel'));exit;
	
		$this->Funnel->recursive = 0;		
		if (!empty($this->request->data) ){
			
			
			$conditions=array();
			//pr($this->request->data);exit;
			
			if(isset($this->request->data['Funnel']['search']) && $this->request->data['Funnel']['search']){
				$temp=explode(' ',trim($this->request->data['Funnel']['search']));
				//pr($temp);exit;
				$whereClause="";
				for($i=0;$i<count($temp);$i++){
					$whereClause.='User.first_name like '."'%".$temp[$i]."%'".' OR User.last_name like '."'%".$temp[$i]."%'";
					if($i!=count($temp)-1){
						$whereClause.=" OR ";
					}
				}
				
				//pr($whereClause);exit;
			    $users=$this->User->find('list',array('conditions'=>array($whereClause)));
			    if(empty($users)){
				$users=array('0'=>'0');
			   }
				$conditions=array_merge($conditions,array('Funnel.user_id IN ('.implode(',',$users).')'));
			}
			
			
			
			//$this->paginate = array('conditions' =>$conditions, 'order' => array('Product.id' => 'ASC'));
			$this->paginate = array('conditions' => array($conditions, 'Funnel.status'=>array(0,1)), 'order' => array('Funnel.id' => 'ASC'));
		} else {
			$this->paginate = array('conditions' => array('Funnel.status'=>array(0,1)), 'order' => array('Funnel.id' => 'ASC'));
		}		
		$this->set('webiner', $this->paginate());
		//$cat_options = $this->Category->find('list', array('fields' => array('Category.id', 'Category.category_name')));
		//$user_options=$this->User->find('list', array('fields' => array('User.id', 'User.username'),'conditions'=>array('User.user_type'=>4)));
		$users=$this->User->find('all', array('fields' => array('User.id', 'User.first_name','User.last_name'),'conditions'=>array('User.user_type'=>2)));
		$user_options="";
		if($users){
			foreach($users as $u){
				$user_options[$u['User']['id']]=$u['User']['first_name'].' '.$u['User']['last_name'];
			}
		}
		$this->set(compact('users'));
	}

 	public function admin_add(){
		
		$this->layout = 'admin';
		if($this->Session->read('Auth.Admin.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		if ($this->request->is('post')){
			$flag = true;
			//pr($this->request->data); //exit;
			
			if($flag){
				$this->Funnel->create();
				if($this->Funnel->save($this->request->data)){
				
					$this->Session->setFlash(__('Funnel has been updated successfully.', true),'default', array('class' => 'success'));
					$this->redirect(array('action' => 'index'));
				}
				else{
					$this->Session->setFlash(__('ERROR :: Funnel could not be updated. Please, try again.', true));
				}
			}			
			
		}
		
		$users = $this->User->find('superlist', array('fields'=>array('User.id', 'User.first_name', 'User.last_name'), 
													  'conditions' => array('User.user_type'=>2, 'User.suspend'=>0, 'User.status'=>1)));

		$this->set(compact('users'));
	}


	public function admin_edit($id = null){
	
	   if($this->Session->read('Auth.Admin.user_type')!=1)
		{
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		
		$this->layout = 'admin';
		$this->Funnel->id = $id;
		if(!$this->Funnel->exists()){
			throw new NotFoundException(__('Invalid product'));
		}

		$fileName = '';
		if(!empty($this->request->data)){
			$flag = true;
			//pr($this->request->data);exit;
			
			
			$this->request->data['Funnel']['reg_cost'] = $this->request->data['Funnel']['price'];
			unset($this->request->data['Funnel']['price']);
			
			$prev_video = $this->request->data['Funnel']['prev_video'];
			
			if(isset($this->request->data['Funnel']['video']['tmp_name']) && $this->request->data['Funnel']['video']['tmp_name']!='' && is_uploaded_file($this->request->data['Funnel']['video']['tmp_name'])){
				$extentioni = strtolower(strrchr($this->request->data['Funnel']['video']['name'], "."));
				$fileDetaili = $this->request->data['Funnel']['video'];
				$this->request->data['Funnel']['video'] = '';					
				if(!in_array($extentioni, $this->validVideoFormats)){
					$this->request->data['Funnel']['prev_video'] = $prev_video;
					$flag = false;
					$this->Session->setFlash(sprintf(__('ERROR :: Please upload photo only having %s extensions.', true), implode(", ", $this->validImageFormats)));
				}
				
			} else {
				//$this->request->data['Funnel']['video'] = $this->request->data['Funnel']['prev_video'];
			}			
			
			//pr($this->request->data);exit;
		
			if($flag){
				$this->Funnel->create();
				if($this->Funnel->save($this->request->data)){
					if(isset($fileDetaili) && is_uploaded_file($fileDetaili['tmp_name'])){
						$fileNamei = $this->request->data['Funnel']['user_id'].$this->request->data['Funnel']['title'].$extentioni;
						move_uploaded_file($fileDetaili['tmp_name'], WEBINNER_FILE . $fileNamei);
						$this->Funnel->saveField('file', $fileNamei);
						if($this->request->data['Funnel']['prev_video'] != '' && $this->request->data['Funnel']['prev_video'] != $fileNamei){
							if(file_exists(WEBINNER_FILE . $this->request->data['Funnel']['prev_video'])){
								unlink(WEBINNER_FILE . $this->request->data['Funnel']['prev_video']);
							}
						}
						$this->request->data['Funnel']['video'] = $fileNamei;
					} 
					
						$this->Session->setFlash(__('Funnel has been edited successfully.', true),'default', array('class' => 'success'));
						$this->redirect(array('action' => 'index'));
				} else {
				  $this->Session->setFlash(__('ERROR :: Funnel could not be edited. Please, try again.', true));
				}
			}
		} 
			$this->request->data = $this->Funnel->read(null, $id);
			$this->request->data['Funnel']['pre_video'] = $this->request->data['Funnel']['file'];
			$this->request->data['Funnel']['price'] = $this->request->data['Funnel']['reg_cost'];
			
			
			//pr($this->request->data);exit;
			
			$users = $this->User->find('superlist', array('fields'=>array('User.id', 'User.first_name', 'User.last_name'), 
													  'conditions' => array('User.user_type'=>2, 'User.suspend'=>0, 'User.status'=>1)));
			$this->set(compact('users'));

	}	
	
	
	
	
	
	
	
	
	
	
	
/* --------------------------------------------------------------- END :: ADMIN PANEL FUNCTIONS --------------------------------------- */







	function add(){
		$this->layout = 'default';
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		$fileName = '';
		$flag = true;
		if(!empty($this->request->data)){
			//pr($this->request->data);exit;
			
			
			if(isset($this->request->data['Funnel']['video']['tmp_name']) && is_uploaded_file($this->request->data['Funnel']['video']['tmp_name'])){
					$extention = strtolower(strrchr($this->request->data['Funnel']['video']['name'],"."));
					$fileDetail = $this->request->data['Funnel']['video'];
					$this->request->data['Funnel']['video'] = "";
					if(!in_array($extention, $this->validVideoFormats)){
						$flag = false;
						$this->Session->setFlash(sprintf(__('ERROR :: Please upload Video only .', true), implode(", ", $this->validVideoFormats)));
					}
			}
			else{
				$this->request->data['Funnel']['video'] = '';
			}
			
			
			
			//pr($fileDetail);
			//pr($this->request->data);exit;
			if($flag){
				$this->request->data['Funnel']['web_date'] = date('Y-m-d h:i:s');
				$this->request->data['Funnel']['user_id'] = $this->Session->read('Auth.User.id');
				$this->request->data['Funnel']['status'] = '1';
				$this->Funnel->create();
				if($this->Funnel->save($this->request->data)){
						if(isset($fileDetail) && is_uploaded_file($fileDetail['tmp_name'])){
							$fileName = $this->Session->read('Auth.User.id')."_".$this->request->data['Funnel']['title'].$extention;
							move_uploaded_file($fileDetail['tmp_name'], WEBINNER_FILE . $fileName);
							$this->Funnel->saveField('file', $fileName);
						}
				
					$this->Session->setFlash(__('Funnel has been updated successfully.', true),'default', array('class' => 'success'));
					$this->redirect('/users/funnel/');
				}
				else{
					$this->Session->setFlash(__('ERROR :: Funnel could not be updated. Please, try again.', true));
				}
			}
		}
	}

	function edit($id = null){
		$this->layout = 'default';
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		$flag = true;
		$fileName = '';
		if(!empty($this->request->data)){
			$flag = true;
			//pr($this->request->data);exit;
			
			$this->request->data['Funnel']['user_id'] = $this->Session->read('Auth.User.id');
			//$this->request->data['Product']['post_date'] = date('Y-m-d h:i:s');
			$this->request->data['Funnel']['status'] = 1;
						
			if($flag){
				$this->Funnel->create();
				if($this->Funnel->save($this->request->data)){
						$this->Session->setFlash(__('Funnel has been edited successfully.', true),'default', array('class' => 'success'));
						$this->redirect(array('controller' => 'users', 'action' => 'funnel', $this->Session->read('Auth.User.id')));
						//$this->redirect(array('action' => ''));
				} else {
				  $this->Session->setFlash(__('ERROR :: Funnel could not be edited. Please, try again.', true));
				}
			}
		} else {
		
			$this->request->data = $this->Funnel->read(null, $id);
			//pr($book);exit;
			//$this->set(compact('prod'));
		}		
		
	}












	function funneldetail($id = null){
		$this->layout = 'default';
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		$uid = $this->Session->read('Auth.User.id');
		$curdate = date('Y-m-d h:i:s');
		$funnels = $this->Funnel->find('all', array('conditions' => array('Funnel.id' => $id, 'Funnel.status' => '1')));
		$this->set(compact('funnels', 'id', 'uid', 'curdate'));
		$go = "";
		$uid = "";
		if(!empty($this->request->data)){
			$uid = $this->Session->read('Auth.User.id');
			$this->request->data['Funnel']['reg_users'] = $this->Session->read('Auth.User.id');
			$title = $this->request->data['Funnel']['title'];
			$reg_cost = $this->request->data['Funnel']['reg_cost'];
			$organizer = $this->request->data['Funnel']['user_id'];
			$this->Funnel->id = $this->request->data['Funnel']['webid'];
			$this->Funnel->saveField("reg_users", $this->request->data['Funnel']['reg_users']);
			$go = 1;
			$id = $this->Funnel->id;
		}
		$this->set(compact('go', 'uid', 'id', 'title', 'reg_cost', 'organizer'));
	}
	public function thankyou(){
		if(!empty($_GET)){
			$id = explode("@", $_GET['cm']);
			$transaction = $_GET['tx'];
			$status = $_GET['st'];
			$paidon = date('Y-m-d h:i:s');
			$this->request->data['Transaction']['sem_id'] = '0';
			$this->request->data['Transaction']['web_id'] = $id[0];
			$this->request->data['Transaction']['work_id'] = '0';
			$this->request->data['Transaction']['cou_id'] = '0';
			$this->request->data['Transaction']['pub_id'] = '0';
			$this->request->data['Transaction']['ticket'] = $this->myRandomNumber;
			$this->request->data['Transaction']['type'] = '2';
			$this->request->data['Transaction']['user_id'] = $this->Session->read('Auth.User.id');
			$this->request->data['Transaction']['transaction_id'] = $transaction;
			$this->request->data['Transaction']['status'] = $status;
			$this->request->data['Transaction']['paidon'] = $paidon;
			$this->request->data['Transaction']['amount'] = $_GET['amt'];
			$this->request->data['User']['send_date'] = $paidon;
			$this->request->data['User']['from_user'] = $id[1];
			$this->request->data['User']['to_user'] = $this->Session->read('Auth.User.id');
			$this->request->data['User']['message'] = "Your ticket number for the Funnel is " . $this->request->data['Transaction']['ticket'];
			$this->Transaction->create();
		 	if($this->Transaction->save($this->request->data)){
				$this->Session->setFlash(__('Funnel has been updated successfully.', true),'default', array('class' => 'success'));
		 		$this->Message->create();
				if($this->Message->save($this->request->data['User'])){
				}
		 		$this->redirect('/users/dashboard/');
		 	}
		 	else{
		 		$this->Session->setFlash(__('ERROR :: Funnel could not be updated. Please, try again.', true));
		 	}
		}
	}
	public function notify(){
		$this->layout = false;
		if(!empty($_GET)){
			$id = explode("@", $_GET['cm']);
			$transaction = $_GET['tx'];
			$status = $_GET['st'];
			$paidon = date('Y-m-d h:i:s');
			$this->request->data['Transaction']['sem_id'] = '0';
			$this->request->data['Transaction']['web_id'] = $id[0];
			$this->request->data['Transaction']['work_id'] = '0';
			$this->request->data['Transaction']['cou_id'] = '0';
			$this->request->data['Transaction']['pub_id'] = '0';
			$this->request->data['Transaction']['type'] = '2';
			$this->request->data['Transaction']['user_id'] = $this->Session->read('Auth.User.id');
			$this->request->data['Transaction']['transaction_id'] = $transaction;
			$this->request->data['Transaction']['status'] = $status;
			$this->request->data['Transaction']['paidon'] = $paidon;
			$this->request->data['Transaction']['amount'] = $_GET['amt'];
			$this->request->data['User']['send_date'] = $paidon;
			$this->request->data['User']['from_user'] = $id[1];
			$this->request->data['User']['to_user'] = $this->Session->read('Auth.User.id');
			$this->request->data['User']['message'] = "Your ticket number for the Funnel is " . $this->request->data['Transaction']['ticket'];
			$this->Transaction->create();
		 	if($this->Transaction->save($this->request->data)){
				$this->Session->setFlash(__('Funnel has been updated successfully.', true),'default', array('class' => 'success'));
		 		$this->Message->create();
				if($this->Message->save($this->request->data['User'])){
				}
		 		$this->redirect('/users/dashboard/');
		 	}
		 	else{
		 		$this->Session->setFlash(__('ERROR :: Funnel could not be updated. Please, try again.', true));
		 	}
		}
		exit;
	}
	/*archive*/
	public function archive($id=null){
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		$uid = $this->Session->read('Auth.User.id');
		$curdate = date('Y-m-d h:i:s');
		$this->Transaction->recursive = 3;
		$reg_infos = $this->Transaction->find('all', array('conditions' => array('Transaction.type' => '2', 'Transaction.status' => 'Completed')));
		$get_user = $this->User->find('first', array('conditions' => array('User.id' => $uid)));
		$dates = $this->Funnel->find('all', array('conditions' => array('Funnel.user_id' => $id, 'Funnel.status' => '1')));
		
		
		
		
		$archives = $this->Funnel->find('all',
													array(
													'conditions' => array('Funnel.user_id'=>$uid),
													'fields'=>array('DATE_FORMAT(Funnel.web_date, \'%Y %M\') AS  arch','count(Funnel.id) AS numblogs'),
													'order' => array('Funnel.web_date'=>'ASC'),
													'group'=>array('arch')
													));
		
		//pr($archives);exit;
		
		
		
		$this->set(compact('funnels', 'id', 'uid', 'get_user', 'curdate', 'reg_infos','archives'));
	}
	function view_funnel($id = null ,$user_id = null){
		
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		
		$uid = $this->Session->read('Auth.User.id');
		$get_user_detail2 = $this->User->find('first',array('conditions' => array('User.id' => $user_id)));
		$my_user_detail = $this->User->find('first',array('conditions' => array('User.id' => $uid)));
		$funnel = $this->Funnel->find('first', array('conditions' => array('Funnel.id' => $id, 'Funnel.status' => '1')));
		//pr($funnel);exit;
		$this->set(compact('funnel', 'id','my_user_detail', 'get_user_detail2'));
	
	
	}
	
	function show_funnel($id = null ,$user_id = null){
		
		$funnel = $this->Funnel->find('first', array('conditions' => array('Funnel.id' => $id, 'Funnel.status' => '1')));
		//pr($funnel);exit;
		$this->set(compact('funnel', 'id','my_user_detail', 'get_user_detail2'));
	
	
	}

	public function delete($id = null){
			$this->Funnel->id = $id;
			if (!$this->Funnel->exists()){
				throw new NotFoundException(__('Invalid product'));
			}
			$report = $this->Funnel->read(null, $id);
	
			if ($this->Funnel->delete()){
				$this->Session->setFlash(sprintf(__('The Funnel has been deleted successfully.', true), ''), 'default', array('class' => 'success'));
			}
			
			$this->Session->setFlash(__('Funnel was not deleted'));
			$this->redirect(array('controller' => 'users', 'action' => 'funnel', $this->Session->read('Auth.User.id')));
		}
	
	}