<?php
App::uses('AppController', 'Controller');
/**
* Products Controller
*
* @property Product $Product
*/
class MessagesController extends AppController {
	public $uses = array('Message', 'User', 'Approval');
	/* --------------------------------------------------------------- START :: ADMIN PANEL FUNCTIONS --------------------------------------- */
/**
* index method
*
* @return void
*/
	public function admin_index(){
		if($this->Session->read('Auth.User.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		$this->set('messages',$this->paginate());
	}
	public function admin_add(){
		if($this->Session->read('Auth.User.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		if(!empty($this->request->data)){
			$from=$this->User->find('first',array('fields'=>array('User.id'),'conditions'=>array('User.email'=>$this->request->data['Message']['from_user1'])));
			$to=$this->User->find('first',array('fields'=>array('User.id'),'conditions'=>array('User.email'=>$this->request->data['Message']['to_user1'],'User.user_type !='=>1)));
			if(!$from){
				$this->Session->setFlash(__('Invalid Sender.', true));
			}elseif(!$to){
				$this->Session->setFlash(__('Invalid reciever.', true));
			}else{
				$this->request->data['Message']['from_user']=$from['User']['id'];
				$this->request->data['Message']['to_user']=$to['User']['id'];
				$this->request->data['Message']['send_date']=date('Y-m-d h:i:s');
				$this->Message->create();
				if($this->Message->save($this->request->data)){
					$this->Session->setFlash(sprintf(__('The message has been successfully saved.', true), ''), 'default', array('class' => 'success'));
					$this->redirect('/admin/messages');
				}
			}
		}
		$this->set(compact('users'));
	}
	public function searchuser($keyword=null,$id=null){
		if($keyword){
			$cond=array();
			$etx=explode(' ',$keyword);
			//var $i=0;
			for($i=0;$i<count($etx);$i++){
				array_push($cond,'User.email LIKE '."'".$etx[$i]."%'");
			}
			//print_r($cond);exit;
			//echo implode(' OR ',$cond); exit;
			$user=$this->User->find('all',array('conditions'=>array(implode(' OR ',$cond).($id=='MessageToUser1' ? ' AND User.user_type!=1':''))));
			$div='';
			if($user){
			$arr=array();
			foreach($user as $u){
				array_push($arr,'<a href="javascript:void(0)" onclick="javascript:test('."'".$u['User']['email']."','".$id."'".')">
				<div style="clear:both;height:10px;"></div>
				<div class="opt">
						<div style="height:auto;width:100%;word-wrap:break-word;padding:10px;"><img src="'.Router::URL('/'.($u['User']['photo'] ? 'user_image/'.$u['User']['photo'] : 'img/blankuser.png'),true).'" height="20" width="20" style="float:left;"/><i class"email" style="float:left;margin-left:10px;">'.$u['User']['email'].'</i></div><div style="clear:both;"></div></div></a>');
			}
			$div=implode('<div style="clear:both;border-bottom:1px solid #ababab;width:70%;height:10px;"></div>',$arr);
			}else{
				$div.='<div style="width:90%;color:#ababab"><i>No user found</i></div>';
			}
			echo $div;
		}
		exit;
	}
	public function admin_edit($id=0){
		if($this->Session->read('Auth.User.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		$message=$this->Message->read(null,$id);
		if(!$message){
			$this->Session->setFlash(__('ERROR :: Invalid Request', true));
			$this->redirect(array('action'=>'index'));
		}
		$users=$this->User->find('list',array('fields'=>array('User.id','User.email'),'conditions'=>array('User.user_type !='=>1)));
		if(!empty($this->request->data)){
			if($this->Message->save($this->request->data)){
				$this->Session->setFlash(sprintf(__('The message has been successfully saved.', true), ''), 'default', array('class' => 'success'));
				$this->redirect('/admin/messages');
			}
		}
		if(empty($this->request->data)){
			$this->request->data=$message;
			//pr($this->request->data);exit;
			$this->request->data['Message']['from_user1']=$this->request->data['Sender']['email'];
			$this->request->data['Message']['to_user1']=$this->request->data['Reciever']['email'];
		}
		$this->set(compact('users'));
		//$this->redirect(array(''))
		//pr($this->paginate());exit;
	}
	public function admin_activate($id=null){
		$report = $this->Product->read(null, $id);
		$this->Product->id = $id;
		if($this->Product->saveField('blocked','0')){
			$this->Session->setFlash(sprintf(__('The product has been successfully activated.', true), ''), 'default', array('class' => 'success'));
			//$this->redirect(array('controller' => 'abuse_reports'));
			$mail_To = $report['User']['email'];
			$mail_From = $this->Session->read('Auth.User.email');
			$mail_subject = "Product has been activated.";
			$mail_Body1 = "Dear ".$report['User']['first_name'].",<br>Your product has been activated.<br/>Product id : ".$report['Product']['id']."<br>Product name : ".$report['Product']['product_name'];
			$mail_Body =nl2Br($mail_Body1);
			$this->Send_HTML_Mail($mail_To, $mail_From,'', $mail_subject, $mail_Body);
			$this->redirect(array('controller' => 'products', 'action' => 'admin_index'));
		}
		else{
			$this->Session->setFlash(sprintf(__('The product could not be activated. Please try again!', true), ''), 'default', array('class' => ''));
			//$this->redirect(array('controller' => 'abuse_reports'));
			$this->redirect(array('controller' => 'products', 'action' => 'admin_index'));
		}
	}
	function contact_me($id=0,$property_id=0){
		//echo $property_id; exit;
		if(!$this->Session->read('Auth.User.id')){
				$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
				$this->redirect('/');
		}
		//pr($_REQUEST);
		if(!empty($this->request->data)){
		//pr($this->request->data);
		$property=$this->Property->find('first',array('conditions'=>array('Property.id'=>$property_id)));
		//pr($property);exit;
		echo $start = $this->request->data['Order']['from_date']=$this->request->data['Message']['from_date'];
		echo $end = $this->request->data['Order']['to_date']=$this->request->data['Message']['to_date'];
		$start = new DateTime(date('Y-m-d',strtotime($this->request->data['Message']['from_date'])));
		$end = new DateTime(date('Y-m-d',strtotime($this->request->data['Message']['to_date'])));
		$interval = $end->diff($start);
		$nights=$interval->format('%d');
		$this->request->data['Order']['currency']=$property['Property']['currency'];
		$this->request->data['Order']['property_id']=$property_id;
			$this->request->data['Order']['user_id']=$this->Session->read('Auth.User.id');
			$this->request->data['Order']['total_price']=$property['Property']['amount']*$nights;
			$this->request->data['Order']['nights']=$nights;
			$this->request->data['Order']['from_date']=$this->request->data['Message']['from_date'];
			$this->request->data['Order']['to_date']=$this->request->data['Message']['to_date'];
			$this->Order->create();
			if($this->Order->save($this->request->data['Order'])){
				$this->request->data['Message']['send_date']=date('Y-m-d h:i:s');
				$this->request->data['Message']['property_id']=$property_id;
				$this->request->data['Message']['to_user']=$id;
				$this->request->data['Message']['from_user']=$this->Session->read('Auth.User.id');
				$this->request->data['Message']['order_id']=$this->Order->id;
				$from_email=$this->Session->read('Auth.User.email');
				$to=$this->User->find('first',array('fields'=>array('User.email'),'conditions'=>array('User.id'=>$this->request->data['Message']['to_user'])));
					$to_email=$to['User']['email'];
					$this->Message->create();
					if($this->Message->save($this->request->data['Message'])){
					$msg=$this->request->data['Message']['message'];
					//mail
					$mail_Body = '<table cellspacing="0" cellpadding="0" style="background-color:#fcfcfc; width:560px; height:410px; border-collapse:collapse; border:1px solid #c0c0c0;">
									<tr>
											<td style="height:50px; padding:5px;" valign="top" align="left">
													<a href="'.Router::URL('/', true).'"><img src="'.Router::URL('/', true).'img/login_admin.png" width="95" border="0" alt="'.Router::URL('/', true).'" /></a>
											</td>
									</tr>
									<tr>
											<td align="center" valign="top" style="height:3px;">
													<div style="border-top:2px solid #0094c3; width:544px; height:3px;"></div>
											</td>
									</tr>
									<tr>
											<td style="height:25px; padding-left:15px; padding-top:25px; font-family:Arial; font-size:13px;" valign="top" align="left">Dear '.$to_email.',</td>
									</tr>
									<tr>
										<td style="height:70px; padding-left:15px; padding-right:15px; padding-top:25px; font-family:Arial; font-size:13px;" valign="top" align="left">Welcome to <b>HOP Explorer!</b> <a href="<?php echo $this->Html->url("/"); ?>">Click Here To Go To Hop Explorer</a></td>
									</tr>
									<tr>
										<td style="height:70px; padding-left:15px; padding-right:15px; padding-top:25px; font-family:Arial; font-size:13px;" valign="top" align="left">'.$from_email.' has sent you a message.</a></td>
									</tr>
									<tr>
										<td style="height:70px; padding-left:15px; padding-right:15px; padding-top:25px; font-family:Arial; font-size:13px;" valign="top" align="left">'.$msg.'</a></td>
									</tr>
									<tr>
										<td style="height:25px; padding-left:15px; padding-top:25px; font-family:Arial; font-size:13px;" valign="top" align="left"><b>HOP Explorer</b> Staff</td>
									</tr>
									<tr>
										<td align="center" valign="top" style="height:20px;">
											<div style="border-bottom:1px solid #c0c0c0; width:544px; height:15px; margin-top:5px;"></div>
										</td>
									</tr>
									<tr height="4"><td style="height:4px;"></td></tr>
									<tr>
										<td align="center" valign="top" style="height:3px;">
											<div style="border-top:1px solid #c0c0c0; width:544px; height:3px; margin-top:5px;"></div>
										</td>
									</tr>
									<tr>
										<td style="padding-left:10px; padding-top:5px; font-family:Arial; font-size:9px; color:#9F9F9F;" valign="top" align="left">
											&nbsp;&nbsp;&copy;&nbsp;2014 Hopexplorer.com. All Rights Reserved.
										</td>
									</tr>
									<tr height="8"><td style="height:8px;"></td></tr>
								</table>';
					@$this->Send_HTML_Mail($to_email, $from_email, '', 'Hop Registration', $mail_Body);
					$this->Session->setFlash(sprintf(__('The message has been successfully sent.', true), ''), 'default', array('class' => 'success'));
					$this->redirect('/manage_list');
				}
			}
		}
		$user=$this->User->read(null, $id);
		$this->set(compact('user'));
	}
}