<?php
App::uses('AppController', 'Controller');

class NewslettersController extends AppController {

	public $name = 'Newsletters';

	public $uses = array('Newsletter', 'User', 'SiteSetting');

	/* --------------------------------------------------------------- START :: ADMIN PANEL FUNCTIONS --------------------------------------- */

	public function admin_index(){
		$this->Newsletter->recursive = 0;
		$this->set('newsletters', $this->paginate());
	}

	public function admin_add(){
		if (!empty($this->request->data)){
			$this->Newsletter->create();
			if ($this->Newsletter->save($this->request->data)){
				$this->Session->setFlash(sprintf(__('The Newsletter has been saved', true), 'newsletter'), 'default', array('class' => 'success'));
				$this->redirect(array('action' => 'index'));
			} 
			else{
				$this->Session->setFlash(sprintf(__('The Newsletter could not be saved. Please, try again.', true), 'newsletter'));
			}
		}
	}

	public function admin_edit($id = null){
		if (!$id && empty($this->request->data)){
			$this->Session->setFlash(sprintf(__('ERROR :: Invalid Newsletter', true), 'newsletter'));
			$this->redirect(array('action' => 'index'));
		}
		if (!empty($this->request->data)){
			if ($this->Newsletter->save($this->request->data)){
				$this->Session->setFlash(sprintf(__('The Newsletter has been saved', true), 'newsletter'), 'default', array('class' => 'success'));
				$this->redirect(array('action' => 'index'));
			}
			else{
				$this->Session->setFlash(sprintf(__('ERROR :: The Newsletter could not be saved. Please, try again.', true), 'newsletter'));
			}
		}
		if (empty($this->request->data)){
			$this->request->data = $this->Newsletter->read(null, $id);
		}
	}

	public function admin_delete($id = null){
		if (!$id){
			$this->Session->setFlash(sprintf(__('ERROR :: Invalid id for Newsletter', true), 'newsletter'));
			$this->redirect(array('action'=>'index'));
		}
		if ($this->Newsletter->delete($id)){
			$this->Session->setFlash(sprintf(__('Newsletter deleted', true), 'Newsletter'), 'default', array('class' => 'success'));
			$this->redirect(array('action'=>'index'));
		}
		$this->Session->setFlash(sprintf(__('ERROR :: Newsletter was not deleted', true), 'Newsletter'));
		$this->redirect(array('action' => 'index'));
	}

	public function admin_send(){
		$siteSetting = $this->SiteSetting->find('first');
		if (!empty($this->request->data)){
			if($this->request->data['Newsletter']['newsletter_content'] == ''){
				$this->Session->setFlash(sprintf(__('ERROR :: Please select newsletter content', true)));
			}
			else if($this->request->data['Newsletter']['email_list']){
				foreach($this->request->data['Newsletter']['email_list'] as $data){
					$flag = true;
					if($data != '0'){
						$flag = false;
						break;
					}
				}
				if($flag == true){
					$this->Session->setFlash(sprintf(__('ERROR :: Please select atleast one email id', true)));
				}
				else{
					$getContent = $this->Newsletter->find('first', array('conditions' => array('Newsletter.id' => $this->request->data['Newsletter']['newsletter_content'])));					
					$subject = $getContent['Newsletter']['newsletter_category'];
					foreach($this->request->data['Newsletter']['email_list'] as $email_list){
						if($email_list != '0'){
							 $mail_From = $siteSetting['SiteSetting']['site_general_email'];
							 $mail_To = $email_list;
							 $mail_subject = $subject;
							 $mail_Body = nl2br($getContent['Newsletter']['content']);
							 $mail_CC = '';							 
							 //@$this->Send_HTML_Mail($mail_To, $mail_From, $mail_CC, $mail_subject, $mail_Body);
							 $this->Send_HTML_Mail($mail_To, $mail_From,'', $mail_subject, $mail_Body);
						}
					}
					$this->Session->setFlash(sprintf(__('Newsletter send successfully', true), 'Newsletter'), 'default', array('class' => 'success'));
					$this->redirect(array('action'=>'send'));
				}
			}
		}
		$getNewsletterContents = $this->Newsletter->find('list', array('fields' => array('Newsletter.id', 'Newsletter.newsletter_category'), 'order' => array('Newsletter.newsletter_category' => 'asc')));
		$this->set('newsletterContents', $getNewsletterContents);
		$this->paginate = array('conditions' => array('User.status' => 1, 'User.id <>' => $this->Session->read('Auth.User.id')), 'limit' => 100);
		$newsletterEmails = $this->paginate('User');
		$this->set('newsletterEmails', $newsletterEmails);
	}

	/* --------------------------------------------------------------- END :: ADMIN PANEL FUNCTIONS --------------------------------------- */
}
?>