<?php
App::uses('AppController', 'Controller');
/**
* Products Controller
*
* @property Product $Product
*/
class NewsroomsController extends AppController {
	public $uses = array('Service',  'User', 'Transaction', 'Message','Section','Sectioncontent','Comment','Funnel','Newsroom');
/* --------------------------------------------------------------- START :: ADMIN PANEL FUNCTIONS --------------------------------------- */
/*	function beforeFilter(){
    	$this->myRandomNumber = rand();
	}*/
/**
* index method
*
* @return void
*/
	public function admin_index(){
		$this->layout = 'admin';
		if($this->Session->read('Auth.Admin.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		$this->Newsroom->recursive = 0;
					if (!empty($this->request->data)){
			$conditions=array();
						
			if(isset($this->request->data['Newsroom']['search']) && $this->request->data['Newsroom']['search']){
				$temp=explode(' ',trim($this->request->data['Newsroom']['search']));
				
				$whereClause="";
				for($i=0;$i<count($temp);$i++){
					$whereClause.='Course.title like '."'%".$temp[$i]."%'";
					if($i!=count($temp)-1){
						$whereClause.=" OR ";
					}
				}
			    $courses=$this->Course->find('list',array('conditions'=>array($whereClause)));
			    if(empty($courses)){
				$course=array('0'=>'0');
			   }
				$conditions=array_merge($conditions,array('Course.title IN ("'.implode(',',$courses).'")'));
			}
			//$this->paginate = array('conditions' =>$conditions, 'order' => array('Product.id' => 'ASC'));
			$this->paginate = array('conditions' => array($conditions, 'Course.status'=>array(0,1)), 'order' => array('Course.id' => 'ASC'));
			//pr($this->paginate);exit;
			$this->set('courses', $this->paginate());
		} else{
		$courses = $this->Course->find('all');
		$this->set('courses', $this->paginate());
		}
		//pr($courses);
		
	}
	
		public function admin_edit($id = null){
	if($this->Session->read('Auth.Admin.user_type')!=1)
		{
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		$this->layout = 'admin';
		$this->Newsroom->id = $id;
		if(!$this->Newsroom->exists()){
			throw new NotFoundException(__('Invalid product'));
		}

		$fileName = '';
		if(!empty($this->request->data)){
			$flag = true;
			//pr($this->request->data);exit;
			
			
		
			
			
			$prev_video = $this->request->data['Newsroom']['pre_video'];
			
			if(isset($this->request->data['Newsroom']['video_file']['tmp_name']) && $this->request->data['Newsroom']['video_file']['tmp_name']!='' && is_uploaded_file($this->request->data['Newsroom']['video_file']['tmp_name'])){
				$extentioni = strtolower(strrchr($this->request->data['Course']['video_file']['name'], "."));
				$fileDetaili = $this->request->data['Newsroom']['video_file'];
				$this->request->data['Newsroom']['video_file'] = '';					
				if(!in_array($extentioni, $this->validVideoFormats)){
					$this->request->data['Newsroom']['pre_video'] = $prev_video;
					$flag = false;
					$this->Session->setFlash(sprintf(__('ERROR :: Please upload photo only having %s extensions.', true), implode(", ", $this->validImageFormats)));
				}
				
			} else {
				$this->request->data['Newsroom']['video_file'] = $this->request->data['Newsroom']['pre_video'];
			}			
			
			//pr($this->request->data);exit;
		
			if($flag){
				$this->Newsroom->create();
				if($this->Newsroom->save($this->request->data)){
					if(isset($fileDetaili) && is_uploaded_file($fileDetaili['tmp_name'])){
						$fileNamei = $this->request->data['Newsroom']['user_id'].$this->request->data['Newsroom']['title'].$extentioni;
						move_uploaded_file($fileDetaili['tmp_name'], COURSE_FILES . $fileNamei);
						$this->Seminar->saveField('video_file', $fileNamei);
						if($this->request->data['Newsroom']['pre_video'] != '' && $this->request->data['Newsroom']['pre_video'] != $fileNamei){
							if(file_exists(COURSE_FILES . $this->request->data['Newsroom']['prev_video'])){
								unlink(COURSE_FILES . $this->request->data['Newsroom']['prev_video']);
							}
						}
						$this->request->data['Newsroom']['video_file'] = $fileNamei;
					} 
					
						$this->Session->setFlash(__('Newsroom has been edited successfully.', true),'default', array('class' => 'success'));
						$this->redirect(array('action' => 'edit',1));
				} else {
				  $this->Session->setFlash(__('ERROR :: Newsroom could not be edited. Please, try again.', true));
				}
			}
		} 
			$this->request->data = $this->Newsroom->read(null, $id);
			$this->request->data['Newsroom']['pre_video'] = $this->request->data['Newsroom']['video_file'];

	}	
	
	
	public function admin_activate($id=null){
if($this->Session->read('Auth.Admin.user_type')!=1)
		{
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		$report = $this->Course->read(null, $id);
		
		$this->Course->id = $id;
		if($this->Course->saveField('status','1')){

				$this->Session->setFlash(sprintf(__('The Course has been successfully activated.', true), ''), 'default', array('class' => 'success'));
				$this->redirect(array('controller' => 'courses', 'action' => 'index'));

		} else {
				$this->Session->setFlash(sprintf(__('The Course could not be deactivated.Please try again!', true), ''), 'default', array('class' => ''));
				$this->redirect(array('controller' => 'courses', 'action' => 'index'));
	
		}
	}

	public function admin_deactivate($id=null){
		
		if($this->Session->read('Auth.Admin.user_type')!=1)
		{
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		$report = $this->Course->read(null, $id);
		//echo $id;exit;
		$this->Course->id = $id;
		if($this->Course->saveField('status','0')){
			$this->Session->setFlash(sprintf(__('The Course has been successfully deactivated.', true), ''), 'default', array('class' => 'success'));
			$this->redirect(array('controller' => 'courses', 'action' => 'index'));
		} else {
			$this->Session->setFlash(sprintf(__('The Course could not be deactivated.Please try again!', true), ''), 'default', array('class' => ''));
			$this->redirect(array('controller' => 'courses', 'action' => 'index'));
		}
	}	
	
	public function admin_delete($id = null){
		//echo $id;
		if($this->Session->read('Auth.Admin.user_type')!=1)
		{
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		
		/*if (!$this->request->is('post')){
			throw new MethodNotAllowedException();
		}*/
		$this->Course->id = $id;
		if (!$this->Course->exists()){
			throw new NotFoundException(__('Invalid product'));
		}
		
		
		$report = $this->Course->read(null, $id);
		//pr($report); exit;
		if ($this->Course->delete()){

			if($report['Course']['video_file'] != ""){
				if(file_exists(COURSE_FILES . $report['Course']['video_file'])){
					unlink(COURSE_FILES . $report['Course']['video_file']);
				}
			}
			
				$this->Session->setFlash(sprintf(__('The Course has been deleted successfully.', true), ''), 'default', array('class' => 'success'));
				$this->redirect(array('controller' => 'courses', 'action' => 'index'));
		
		}
		
		$this->Session->setFlash(__('Seminar was not deleted'));
		$this->redirect(array('action' => 'index'));
	}
	
	 	public function admin_add(){
		
		$this->layout = 'admin';
		if($this->Session->read('Auth.Admin.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
			if(!empty($this->request->data)){
			$flag = true;
			
			if(isset($this->request->data['Course']['video_file']['tmp_name']) && is_uploaded_file($this->request->data['Course']['video_file']['tmp_name'])){
					$extention = strtolower(strrchr($this->request->data['Course']['video_file']['name'],"."));
					$fileDetail = $this->request->data['Course']['video_file'];
					$this->request->data['Course']['video_file'] = "";
					if(!in_array($extention, $this->validVideoFormats)){
						$flag = false;
						$this->Session->setFlash(sprintf(__('ERROR :: Please upload Video only .', true), implode(", ", $this->validVideoFormats)));
					}
			} else {
				$this->request->data['Course']['video_file'] = '';
			}
			
			if($flag){
			  
				$this->Course->create();
				if($this->Course->save($this->request->data)){
					 
						if(isset($fileDetail) && is_uploaded_file($fileDetail['tmp_name'])){
							$fileName = $this->request->data['Course']['user_id']."_".$this->request->data['Course']['title'].$extention;
							move_uploaded_file($fileDetail['tmp_name'], COURSE_FILES . $fileName);
							$this->Course->saveField('video_file', $fileName);
						}
				
					$this->Session->setFlash(__('Course has been updated successfully.', true),'default', array('class' => 'success'));
					$this->redirect(array('action' => 'index'));
				}
				else{
					$this->Session->setFlash(__('ERROR :: Course could not be updated. Please, try again.', true));
				}
			}			
			
		}
		
		$users=$this->User->find('list',array('conditions'=>array('User.status'=>1,'User.user_type'=>2),'fields'=>array('User.id','User.first_name')));
		
		//$users = $this->User->find('superlist', array('fields'=>array('User.id', 'User.first_name', 'User.last_name'), 
													//  'conditions' => array('User.user_type'=>2, 'User.suspend'=>0, 'User.status'=>1)));

		$this->set(compact('users'));
	}
	
	
		

	
	


   

   
   
   



   

   
	
/* --------------------------------------------------------------- END :: ADMIN PANEL FUNCTIONS --------------------------------------- */
	function add(){
		$this->layout = 'default';
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		
		if(!empty($this->request->data)){
			
			//pr($this->request->data);exit;
			
			     //$flag_video=true;$flag_pdf=true;$flag_ppt=true;
			     $flag = true;
				if(isset($this->request->data['Ehr']['file']['tmp_name']) && is_uploaded_file($this->request->data['Ehr']['file']['tmp_name'])){
				 $extention_img = strtolower(strrchr($this->request->data['Ehr']['file']['name'],"."));
					$fileDetail_img = $this->request->data['Ehr']['file'];
					$this->request->data['Ehr']['file'] = "";					
				
			      } else {
				       $this->request->data['Ehr']['file'] = '';
					  
				  }
				  
		

				  
				  
			
			if($flag){
				
			$this->request->data['Ehr']['did'] = $this->Session->read('Auth.User.id');
			//pr($this->request->data);exit;
			$this->Ehr->create();
			if($this->Ehr->save($this->request->data)){
				

						
						if(isset($fileDetail_img) && is_uploaded_file($fileDetail_img['tmp_name'])){
							$fileName_img = rand(0,9999).$this->request->data['Ehr']['did']."_".$this->request->data['Ehr']['file'].$extention_img;
							move_uploaded_file($fileDetail_img['tmp_name'], SERVICE_FILES . $fileName_img);
							$this->Ehr->saveField('file', $fileName_img);
						}
						
				$this->Session->setFlash(__('Ehr has been added successfully.', true),'default', array('class' => 'success'));
				$this->redirect('/users/ehr/'.$this->Session->read('Auth.User.id'));
			}
			else{
				$this->Session->setFlash(__('ERROR :: Service could not be updated. Please, try again.', true));
			}
		}
	}
$funnels = $this->Funnel->find('all', array('conditions' => array( 'Funnel.status' => '1')));
		$this->set(compact('funnels'));
	}
	
	

	
	
		
	
		function edit($id = null){
		$this->layout = 'default';
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		$flag = true;
		$fileName = '';
		if(!empty($this->request->data)){
			$flag = true;
			//pr($this->request->data);exit;

				  
				if(isset($this->request->data['Ehr']['file']['tmp_name']) && is_uploaded_file($this->request->data['Ehr']['file']['tmp_name'])){
				$extention_video = strtolower(strrchr($this->request->data['Ehr']['file']['name'], "."));
				$fileDetail_video = $this->request->data['Ehr']['file'];
				$this->request->data['Ehr']['file'] = '';					
				/*if(!in_array($extention_video, $this->validVideoFormats)){
					$flag = false;
					$this->Session->setFlash(sprintf(__('ERROR :: Please upload video only having %s extensions.', true), implode(", ", $this->validVideoFormats)));
				}*/
			}
			else{
				$this->request->data['Ehr']['file'] = $this->request->data['Ehr']['pre_file'];
			}				
			
				  
				  
				
			
			
			
			
			$this->request->data['Ehr']['did'] = $this->Session->read('Auth.User.id');

						
			if($flag){
			
				if($this->Ehr->save($this->request->data)){

					
						if(isset($fileDetail_video) && is_uploaded_file($fileDetail_video['tmp_name'])){
						$fileName_video = rand().$this->Session->read('Auth.User.id').$this->request->data['Ehr']['title'].$extention_video;
						move_uploaded_file($fileDetail_video['tmp_name'], SERVICE_FILES . $fileName_video);
						$this->Ehr->saveField('file', $fileName_video);
						if($this->request->data['Ehr']['pre_file'] != '' && $this->request->data['Ehr']['pre_file'] != $fileName_video){
							if(file_exists(SERVICE_FILES . $this->request->data['Ehr']['pre_file'])){
								unlink(SERVICE_FILES . $this->request->data['Ehr']['pre_file']);
							}
						}
						$this->request->data['Ehr']['file'] = $fileName_video;
					} 
					
						$this->Session->setFlash(__('Ehr has been edited successfully.', true),'default', array('class' => 'success'));
						$this->redirect(array('controller' => 'users', 'action' => 'ehr', $this->Session->read('Auth.User.id')));
						//$this->redirect(array('action' => ''));
				} else {
				  $this->Session->setFlash(__('ERROR :: Ehr could not be edited. Please, try again.', true));
				}
			}
		} else {
		
			$this->request->data = $this->Ehr->read(null, $id);
			$this->request->data['Ehr']['pre_file'] = $this->request->data['Ehr']['file'];
			
$funnels = $this->Funnel->find('all', array('conditions' => array('Funnel.status' => '1')));
$this->set(compact('funnels'));
		}		
		
	}
	
	
	
	function view_ehr($id = null , $did = null){
		
		
		$uid = $this->Session->read('Auth.User.id');
		
		
		$get_user_detail2 = $this->User->find('first',array('conditions' => array('User.id' => $did)));
		$my_user_detail = $this->User->find('first',array('conditions' => array('User.id' => $uid)));
		
		
		$ehrs = $this->Ehr->find('first', array('conditions' => array('Ehr.id' => $id, 'Ehr.status' => '1')));
		$this->request->data = $this->Ehr->read(null, $id);
$funnel = $this->Funnel->find('first', array('conditions' => array('Funnel.id' => $ehrs['Ehr']['funnel_id'], 'Funnel.status' => '1')));
			$this->set(compact('my_user_detail', 'get_user_detail2','funnel'));
	}
	
	

	function ehr_details($id = null , $did = null){
		
		
		$uid = $this->Session->read('Auth.User.id');
		
		
		$get_user_detail2 = $this->User->find('first',array('conditions' => array('User.id' => $did)));
		$my_user_detail = $this->User->find('first',array('conditions' => array('User.id' => $uid)));
		
		
		
		$this->request->data = $this->Ehr->read(null, $id);
			$this->set(compact('my_user_detail', 'get_user_detail2'));
	}
	
	


   
   
public function delete($id = null){
		
		$this->Ehr->id = $id;
		if (!$this->Ehr->exists()){
			throw new NotFoundException(__('Invalid product'));
		}
		
		
		$report = $this->Ehr->read(null, $id);
		//pr($report); exit;
		if ($this->Ehr->delete()){

			if($report['Ehr']['video_file'] != ""){
				if(file_exists(COURSE_FILES . $report['Ehr']['video_file'])){
					unlink(COURSE_FILES . $report['Ehr']['video_file']);
				}
			}
			
				$this->Session->setFlash(sprintf(__('The Ehr has been deleted successfully.', true), ''), 'default', array('class' => 'success'));
				//$this->redirect(array('controller' => 'courses', 'action' => 'index'));
		
		}
		else{
		$this->Session->setFlash(__('Ehr was not deleted'));
}
	$this->redirect(array('controller' => 'users', 'action' => 'ehr', $this->Session->read('Auth.User.id')));	


	}
		
	
	






	
}