<?php
App::uses('AppController', 'Controller');
/**
 * Products Controller
 *
 * @property Product $Product
 */
class OrdersController extends AppController {
	public $uses = array('Order', 'User', 'Product', 'OrderItem');

	/* --------------------------------------------------------------- START :: ADMIN PANEL FUNCTIONS --------------------------------------- */
/**
 * index method
 *
 * @return void
 */
	public function admin_index(){
		if($this->Session->read('Auth.Admin.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		
		//$this->backup_tables('localhost', 'websiuq4_iaii', 'pass@1234', 'websiuq4_iaii', '*');
		/*$this->Order->recursive = 2;
		if(!empty($this->request->data)){
			$temp = $this->request->data['Order']['search'];			
			$this->paginate = array('conditions' =>array('Order.created' => $temp, 'Order.order_status' => 1), 'Order'=> array('Order.payment_date' => 'ASC'));			
		}
		else{
			$this->paginate = array('conditions' => array('Order.order_status' => 1));			
		}		
		$this->set('orders', $this->paginate());*/
		
		
		$this->paginate = array('conditions' => array('Order.order_status' => 1),'group' => array('Order.transaction_id'));		
		$this->set('payment', $this->paginate());		
				
	}
	
	public function admin_payment(){
		if($this->Session->read('Auth.Admin.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		
		
		//pr($payment);exit;
		$this->paginate = array('conditions' => array('Order.order_status' => 1),'group' => array('Order.transaction_id'));		
		$this->set('payment', $this->paginate());
		
		
		
		/*$payment = $this->Order->find('all', array(
													'conditions' => array('Order.order_status' => 1), //array of conditions
													'group' => array('Order.transaction_id'), //fields to GROUP BY
												));
		pr($payment);exit;*/
		
		
	}	
	
			
	
	public function admin_view_order($tran_id = null){
		if($this->Session->read('Auth.Admin.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}

		$this->Order->recursive = 2;
		$this->paginate = array('conditions' => array('Order.order_status' => 1, 'Order.transaction_id' => $tran_id));			
		$this->set('orders', $this->paginate());
				
	}	
	
	public function admin_view_payment(){
		if($this->Session->read('Auth.Admin.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}

		$this->Order->recursive = 2;
		$this->paginate = array('conditions' => array('Order.order_status' => 1));			
		$this->set('orders', $this->paginate());
				
	}	
	
	
	
	
	
	
	
	
	
	
	public function admin_add(){
		if($this->Session->read('Auth.Admin.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}		
		$property=$this->Property->find('list',array('fields'=>array('Property.id','Property.property_title')));
		//pr($users);exit;		
		$currency=$this->Currency->find('list',array('fields'=>array('Currency.currency_id','Currency.currency_name')));
		//pr($currency);exit;
		$users=$this->User->find('list',array('fields'=>array('User.id','User.email'),'conditions'=>array('User.user_type !='=>1)));		
		if(!empty($this->request->data)){
			$this->request->data['Order']['send_date']=date('Y-m-d h:i:s');
			$this->Order->create();
			if($this->Order->save($this->request->data)){
				$this->Session->setFlash(sprintf(__('The Order has been successfully saved.', true), ''), 'default', array('class' => 'success'));
				$this->redirect('/admin/orders/');
			}
		}
		$this->set(compact('users'));
		$this->set(compact('currency'));
		$this->set(compact('property'));
		//pr($this->paginate());exit;
	}

	public function admin_edit($id = 0){
	    // echo 44;exit;
		if($this->Session->read('Auth.Admin.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		$order=$this->Order->read(null, $id);
		if (!$order){
			$this->Session->setFlash(__('ERROR :: Invalid Id.', true));
			$this->redirect(array('action'=>'index'));
		}
		$fileName = '';
		if (!empty($this->request->data)){
			//pr($this->request->data);exit;
			if ($this->Order->save($this->request->data)){					
				$this->Session->setFlash(__('Order has been updated successfully.', true), 'default', array('class' => 'success'));
				$this->redirect('/admin/orders/');
			} 
			else{
				$this->Session->setFlash(__('ERROR :: Order could not be updated. Please, try again.', true));
			}	
		}
		$product=$this->Product->find('first', array('conditions'=>array($whereClause)));
		//$currency=$this->Currency->find('list',array('fields'=>array('Currency.currency_id','Currency.currency_name')));
		$users=$this->User->find('list',array('fields'=>array('User.id','User.email')));
		$status=array('0'=>'Pending','1'=>'Confirmed','2'=>'Rejected');
		$this->set(compact('products','users','id','status'));		
		if(empty($this->request->data)){
			$this->request->data = $order;
			$temp=explode('-',$this->request->data['Order']['to_date']);			
			$temp2=explode('-',$this->request->data['Order']['from_date']);
			$this->request->data['Order']['to_date1']['year']=$temp[0];
			$this->request->data['Order']['to_date1']['month']=$temp[1];
			$this->request->data['Order']['to_date1']['day']=$temp[2];
			$this->request->data['Order']['from_date1']['year']=$temp2[0];
			$this->request->data['Order']['from_date1']['month']=$temp2[1];
			$this->request->data['Order']['from_date1']['day']=$temp2[2];
		}
	}

	public function admin_delete($id = 0){
	    // echo 44;exit;
		if($this->Session->read('Auth.Admin.user_type')!=1)
		{
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		$order=$this->Order->read(null, $id);

		if (!$order) 
		{
			$this->Session->setFlash(__('ERROR :: Invalid Id.', true));
			$this->redirect(array('action'=>'index'));
		}

		if($this->Order->delete($id)){
			$this->Session->setFlash(sprintf(__('ERROR :: Order deleted successfully', true), ''));
			$this->redirect('/admin/orders/');
		}
	}

	/* --------------------------------------------------------------- END :: ADMIN PANEL FUNCTIONS --------------------------------------- */

}
