<?php

/**

 * Static content controller.

 *

 * This file will render views from views/pages/

 *

 * PHP 5

 *

 * CakePHP(tm) : Rapid Development Framework (http://cakephp.org)

 * Copyright 2005-2012, Cake Software Foundation, Inc. (http://cakefoundation.org)

 *

 * Licensed under The MIT License

 * Redistributions of files must retain the above copyright notice.

 *

 * @copyright     Copyright 2005-2012, Cake Software Foundation, Inc. (http://cakefoundation.org)

 * @link          http://cakephp.org CakePHP(tm) Project

 * @package       app.Controller

 * @since         CakePHP(tm) v 0.2.9

 * @license       MIT License (http://www.opensource.org/licenses/mit-license.php)

 */



App::uses('AppController', 'Controller');



/**

 * Static content controller

 *

 * Override this controller by placing a copy in controllers directory of an application

 *

 * @package       app.Controller

 * @link http://book.cakephp.org/2.0/en/controllers/pages-controller.html

 */

class PagesController extends AppController {



/**

 * Controller name

 *

 * @var string

 */

	public $name = 'Pages';



/**

 * This controller does not use a model

 *

 * @var array

 */

	public $uses = array('Cms','Speciality','Testimonial','Eventshome','EventDelegate','OtherMenu','OtherMenuUrl','Article','Newsroom');



/**

 * Displays a view

 *

 * @param mixed What page to display

 * @return void

 */
 
 /////////////////////////////////////////////////////////////// Admin Logic /////////////////////////////////////////////////////////////////////////////////////////////////////////////
 
 /////////////////////////////////////////////////////////////////////// Listing Page ///////////////////////////////////////////////////////////////////////////////////////////////////
 
 public function admin_index(){
		$this->layout = 'admin';
		if($this->Session->read('Auth.Admin.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
//,9,10,11,12,13
					if (!empty($this->request->data)){} else{
	 	                     $this->paginate= array('conditions' => array('Cms.id !=' => array(1,2,3,4)));
		                     $this->set('cms', $this->paginate());
		                   }
	}
 
 /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
 
 //////////////////////////////////////////////////////////////////////// Add Cms Page //////////////////////////////////////////////////////////////////////////////////////////////////////
 
 public function admin_add(){
		
		$this->layout = 'admin';
		if($this->Session->read('Auth.Admin.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
			if(!empty($this->request->data)){
			$flag = true;
			
			if($flag){
			 
				$this->Cms->create();
				if($this->Cms->save($this->request->data)){
				      if($this->request->data['Cms']['cat']!=0){
				             $this->Cms->id ;
				             $this->Cms->saveField('parent_id',$this->request->data['Cms']['cat']);
				             }else{
				             $this->request->data['Cms']['parent_id'] = 0;
				             }
					 
					$this->Session->setFlash(__('Cms page  has been updated successfully.', true),'default', array('class' => 'success'));
					$this->redirect(array('action' => 'index'));
				}
				else{
					$this->Session->setFlash(__('ERROR :: Pages could not be updated. Please, try again.', true));
				}
			}			
			
		}
		
	}
 
 
 ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
 
 
 //////////////////////////////////////////////////////////////////////////////// Pasge Edit ////////////////////////////////////////////////////////////////////////////////////////////////
 public function admin_edit($id = null){
	if($this->Session->read('Auth.Admin.user_type')!=1)
		{
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		$this->layout = 'admin';
		$this->Cms->id = $id;
		if(!$this->Cms->exists()){
			throw new NotFoundException(__('Invalid product'));
		}

		$fileName = '';
		if(!empty($this->request->data)){
			$flag = true;

			if($flag){
				$this->Cms->create();
				if($this->Cms->save($this->request->data)){
				
				          if($this->request->data['Cms']['parent_id']!=0){
				             $this->Cms->id ;
				             $this->Cms->saveField('parent_id',$this->request->data['Cms']['parent_id']);
				             }else{
				             $this->request->data['Cms']['parent_id'] = 0;
				             }
					
					
						$this->Session->setFlash(__('Course has been edited successfully.', true),'default', array('class' => 'success'));
						$this->redirect(array('action' => 'index'));
				} else {
				  $this->Session->setFlash(__('ERROR :: Seminar could not be edited. Please, try again.', true));
				}
			}
		} 
			$this->request->data = $this->Cms->read(null, $id);

	}	
	
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	
		public function admin_deactivate($id=null){
		
		if($this->Session->read('Auth.Admin.user_type')!=1)
		{
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		$report = $this->Cms->read(null, $id);
	
		$this->Cms->id = $id;
		if($this->Cms->saveField('status','0')){
			$this->Session->setFlash(sprintf(__('The Cms has been successfully deactivated.', true), ''), 'default', array('class' => 'success'));
			$this->redirect(array('controller' => 'pages', 'action' => 'index'));
		} else {
			$this->Session->setFlash(sprintf(__('The Cms could not be deactivated.Please try again!', true), ''), 'default', array('class' => ''));
			$this->redirect(array('controller' => 'pages', 'action' => 'index'));
		}
	}	
	
	
		public function admin_activate($id=null){
		
		if($this->Session->read('Auth.Admin.user_type')!=1)
		{
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		$report = $this->Cms->read(null, $id);
	
		$this->Cms->id = $id;
		if($this->Cms->saveField('status','1')){
			$this->Session->setFlash(sprintf(__('The Cms has been successfully activated.', true), ''), 'default', array('class' => 'success'));
			$this->redirect(array('controller' => 'pages', 'action' => 'index'));
		} else {
			$this->Session->setFlash(sprintf(__('The Cms could not be activated.Please try again!', true), ''), 'default', array('class' => ''));
			$this->redirect(array('controller' => 'pages', 'action' => 'index'));
		}
	}
	
	
	public function admin_delete($id = null){
		//echo $id;
		if($this->Session->read('Auth.Admin.user_type')!=1)
		{
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		
		/*if (!$this->request->is('post')){
			throw new MethodNotAllowedException();
		}*/
		$this->Cms->id = $id;
		if (!$this->Cms->exists()){
			throw new NotFoundException(__('Invalid product'));
		}
		
		
		$report = $this->Cms->read(null, $id);
		//pr($report); exit;
		if ($this->Cms->delete()){

	
			
				$this->Session->setFlash(sprintf(__('The Page has been deleted successfully.', true), ''), 'default', array('class' => 'success'));
				$this->redirect(array('controller' => 'pages', 'action' => 'index'));
		
		}
		
		$this->Session->setFlash(__('Pages was not deleted'));
		$this->redirect(array('action' => 'index'));
	}
	
	/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	public function Info($id = null , $idd = null){
	    //echo $idd;
		$content = $this->Cms->find('first', array('conditions' => array('Cms.page_name' => $idd)));
		//pr($content);
		$delegate = $this->EventDelegate->find('all',array('conditions'=>array('EventDelegate.is_active'=>'1')));
	$this->set(compact('content','delegate'));
			
	}
	public function Details($id = null ){
	    //echo $id ;
	   
		$content = $this->OtherMenu->find('first', array('conditions' => array('OtherMenu.menu_id' => $id)));
		//pr($content);
		$otherurl = $this->OtherMenuUrl->find('all',array('conditions'=>array('OtherMenuUrl.other_menu_id'=>$content['OtherMenu']['id'])));
	$this->set(compact('content','otherurl'));
$this->render('/Pages/othermenu');
			
	}
	
	public function delegate($url = null){
		$delegate = $this->EventDelegate->find('all',array('conditions'=>array('EventDelegate.is_active'=>'1')));
		$del_content = $this->EventDelegate->find('first', array('conditions' => array('EventDelegate.del_seo_url' => $url)));
		//pr($del_content);exit;
		$this->set(compact('del_content','delegate'));
	}
	
	public function display(){

		$path = func_get_args();

		$count = count($path);

		if (!$count){

			$this->redirect('/');

		}

		$page = $subpage = $title_for_layout = null;

		if (!empty($path[0])){

			$page = $path[0];

		}

		if (!empty($path[1])){

			$subpage = $path[1];

		}

		if (!empty($path[$count - 1])){

			$title_for_layout = Inflector::humanize($path[$count - 1]);

		}

		$this->Cms->recusrive = 0;

		$cms = $this->Cms->find('all', array('conditions' => array('page_name' => $page)));

		$cmsContent = '';

		if(isset($cms[0]['Cms']['content'])){

			$cmsContent = $cms[0]['Cms']['content'];

		}

		$this->set(compact('page', 'subpage', 'title_for_layout', 'cmsContent'));

		$this->render(implode('/', $path));

	}




	function home(){

		//$this->layout = 'home';

		$Speciality=$this->Speciality->find('list',array('conditions'=>array('Speciality.status'=>1),'fields'=>array('Speciality.name','Speciality.name')));
		$testimonial = $this->Testimonial->find('all', array('conditions' => array('Testimonial.status' => '1'),'order'=>array('Testimonial.created_date'=>'DESC'),'limit'=>2));
		$delegate = $this->EventDelegate->find('all',array('conditions'=>array('EventDelegate.is_active'=>'1')));
		//pr($delegate);exit;

$articles= $this->Article->find('all', array('conditions' => array('Article.status' => '1'),'order'=>array('Article.id'=>'DESC'),'limit'=>2));
	
		
		
		$content=$this->Cms->read(null,13);
		$content2=$this->Cms->read(null,12);
		$content3=$this->Cms->read(null,11);
		$content4=$this->Cms->read(null,9);
		$content5=$this->Cms->read(null,10);

		$this->set(compact('Speciality','content','content2','content3','content4','content5','testimonial','delegate','articles'));

		

	}



	function admin_content($id = null){

/*		if(($this->Session->read('Auth.User.user_type') == 2 && $this->request->url != 'admin/pages/content/2') || $this->Session->read('Auth.User.user_type') == 3){

			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));

			$this->redirect('/admin');

		}*/

		

		

	if($this->Session->read('Auth.Admin.user_type') !=1){

			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));

			$this->redirect('/admin');

		}

		

		

		if (!empty($this->request->data)){

			if ($this->Cms->save($this->request->data)){

				if($id=='1'){

					$pageName='How It Works';

				}

				else if($id=='2'){

					$pageName='Terms and Conditions';

				}

				else if($id=='3'){

					$pageName='Faq';

				}

				else if($id=='4'){

					$pageName='Membership';

				}

				else if($id=='5'){

					$pageName='Home';

				}
				
					else if($id=='6'){

					$pageName='Home Page Register Patients';

				}

				else if($id=='7'){

					$pageName='Home Page Register Providers';

				}

				else if($id=='8'){

					$pageName='Home Page Health Info 1';

				}

				else if($id=='9'){

					$pageName='Home Page Health Info 2';

				}
				
				

				$this->Session->setFlash(sprintf(__($pageName.' page content updated successfully.', true), $pageName), 'default', array('class' => 'success'));

				$this->redirect(array('controller' => 'pages', 'action' => 'content', $id));

			} else {

				$this->Session->setFlash(sprintf(__('ERROR :: The content could not be saved. Please, try again.', true), 'content'));

			}

		}

		$this->request->data = $this->Cms->read(null, $id);

	}

	

	public function makeImage($type=null,$newheight=0,$newwidth=0,$filename=null){

		$this->layout=false;

		switch($type){

			case 'banner':

				$filename=BANNER_IMAGES.$filename;

			break;

			case 'logo':

				$filename=LOGO_IMAGES.$filename;

			break;

			case 'group_image':

				$filename=GROUP_IMAGES.$filename;

			break;

			case 'user':

				$filename=USER_IMAGES.$filename;

			break;

			case 'group_post_image':

				$filename=GROUP_POST_IMAGES.$filename;

			break;

			case 'product':

				$filename=PROD_IMAGES.$filename;

			break;

			case 'sumhit':

				$filename=SUMHITS_IMAGES.$filename;

			break;

			case 'book_image':

				$filename=BOOKS_IMAGES.$filename;

			break;

			case 'dispensary_image':

				$filename=DISPENSERY_IMAGES.$filename;

			break;

		}

		$thumb = imagecreatetruecolor($newwidth, $newheight);

		list($width, $height) = getimagesize($filename);

		$extention = strtolower(strrchr($filename,"."));

		switch($extention){

			case '.jpeg':

				header('Content-Type: image/jpeg');

				$source = imagecreatefromjpeg($filename);

				imagecopyresized($thumb, $source, 0, 0, 0, 0, $newwidth, $newheight, $width, $height);

				imagejpeg($thumb);

				imagedestroy($thumb);

			break;

			case '.jpg':

				header('Content-Type: image/jpeg');

				$source = imagecreatefromjpeg($filename);

				imagecopyresized($thumb, $source, 0, 0, 0, 0, $newwidth, $newheight, $width, $height);

				imagejpeg($thumb);

				imagedestroy($thumb);

			break;

			case '.png':

				header('Content-Type: image/png');

				$source = imagecreatefrompng($filename);

				imagealphablending($source, false);

				imagesavealpha($source, true);

				imagecopyresized($thumb, $source, 0, 0, 0, 0, $newwidth, $newheight, $width, $height);

				imagepng($thumb);

			break;

			case '.gif':

				header('Content-Type: image/gif');

				$source = imagecreatefromgif($filename);

				imagealphablending($source, false);

				imagesavealpha($source, true);

				imagecopyresized($thumb, $source, 0, 0, 0, 0, $newwidth, $newheight, $width, $height);

				imagegif($thumb);

			break;

		}

		imagedestroy($thumb);

		exit;

	}
	
	
	
		public function newsrooms(){
	   
		$content = $this->Newsroom->find('first', array('conditions' => array('Newsroom.id' => 1)));
	//	pr($content);
		//exit;
	$this->set(compact('content'));
$this->render('/Pages/newsroom');
			
	}

	

}

?>