<?php
App::uses('AppController', 'Controller');
/**
 * Products Controller
 *
 * @property Product $Product
 */
class ProductsController extends AppController {

	public $uses = array('Product', 'User','Funnel');

	/* --------------------------------------------------------------- START :: ADMIN PANEL FUNCTIONS --------------------------------------- */

/**
 * index method
 *
 * @return void
 */




/**
 * delete method
 *
 * @throws MethodNotAllowedException
 * @throws NotFoundException
 * @param string $id
 * @return void
 */
	public function admin_delete($id = null,$type=null){
		
		if($this->Session->read('Auth.Admin.user_type')!=1)
		{
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		//echo $id;echo "==";echo $type;exit;
		
		
		/*if (!$this->request->is('post')){
			throw new MethodNotAllowedException();
		}*/
		$this->Product->id = $id;
		if (!$this->Product->exists()){
			throw new NotFoundException(__('Invalid product'));
		}
		
		
		$report = $this->Product->read(null, $id);
		//pr($report); exit;
		if ($this->Product->delete()){
			if($type ==1 ){
			
			if($report['Product']['image'] != ""){			
				if(file_exists(BOOKS_IMAGES . $report['Product']['image'])){
					unlink(BOOKS_IMAGES . $report['Product']['image']);
				}
			}
			
			if($report['Product']['pdf'] != ""){			
				if(file_exists(BOOKS_PDFS . $report['Product']['pdf'])){
					unlink(BOOKS_PDFS . $report['Product']['pdf']);
				}			
			}
			
				$this->Session->setFlash(sprintf(__('The Book has been deleted successfully.', true), ''), 'default', array('class' => 'success'));
				$this->redirect(array('controller' => 'products', 'action' => 'admin_books'));
			} else {
			
				if(file_exists(DISPENSERY_IMAGES . $report['Product']['image'])){
					unlink(DISPENSERY_IMAGES . $report['Product']['image']);
				}
			
				$this->Session->setFlash(sprintf(__('The Dispencery has been deleted successfully.', true), ''), 'default', array('class' => 'success'));
				$this->redirect(array('controller' => 'products', 'action' => 'admin_dispencery'));
			}			
		}
		
		$this->Session->setFlash(__('Product was not deleted'));
		$this->redirect(array('action' => 'index'));
	}


	public function admin_activate($id=null,$type=null){

   if($this->Session->read('Auth.Admin.user_type')!=1)
		{
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		$report = $this->Product->read(null, $id);
		
		$this->Product->id = $id;
		if($this->Product->saveField('blocked','0')){

			//$this->redirect(array('controller' => 'abuse_reports'));
			$mail_To = $report['User']['email'];
			$mail_From = $this->Session->read('Auth.User.email');
			$mail_subject = "Product has been activated.";
			$mail_Body1 = "Dear ".$report['User']['first_name'].",<br>Your product has been activated.<br/>Product id : ".$report['Product']['id']."<br>Product name : ".$report['Product']['product_name'];
			$mail_Body =nl2Br($mail_Body1);
			$this->Send_HTML_Mail($mail_To, $mail_From,'', $mail_subject, $mail_Body);
			if($type ==1 ){
				$this->Session->setFlash(sprintf(__('The Book has been successfully activated.', true), ''), 'default', array('class' => 'success'));
				$this->redirect(array('controller' => 'products', 'action' => 'admin_books'));
			} else {
				$this->Session->setFlash(sprintf(__('The Dispencery has been successfully activated.', true), ''), 'default', array('class' => 'success'));
				$this->redirect(array('controller' => 'products', 'action' => 'admin_dispencery'));
			}
		} else {
			if($type ==1 ){
				$this->Session->setFlash(sprintf(__('The Book could not be deactivated.Please try again!', true), ''), 'default', array('class' => ''));
				$this->redirect(array('controller' => 'products', 'action' => 'admin_books'));
			} else {
				$this->Session->setFlash(sprintf(__('The Dispencery could not be deactivated.Please try again!', true), ''), 'default', array('class' => ''));
				$this->redirect(array('controller' => 'products', 'action' => 'admin_dispencery'));
			}			
		}
	}

	public function admin_deactivate($id=null,$type=null){
		
		if($this->Session->read('Auth.Admin.user_type')!=1)
		{
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		
		$report = $this->Product->read(null, $id);
		//echo $id;exit;
		$this->Product->id = $id;
		if($this->Product->saveField('blocked','1')){
			
			//$this->redirect(array('controller' => 'abuse_reports'));
			$mail_To = $report['User']['email'];
			$mail_From = $this->Session->read('Auth.User.email');
			$mail_subject = "Product has been dectivated.";
			$mail_Body1 = "Dear ".$report['User']['first_name'].",<br>Your product has been deactivated.<br/>Product id : ".$report['Product']['id']."<br>Product name : ".$report['Product']['product_name'];
			$mail_Body =nl2Br($mail_Body1);
			$this->Send_HTML_Mail($mail_To, $mail_From,'', $mail_subject, $mail_Body);
			if($type ==1 ){
				$this->Session->setFlash(sprintf(__('The Book has been successfully deactivated.', true), ''), 'default', array('class' => 'success'));
				$this->redirect(array('controller' => 'products', 'action' => 'admin_books'));
			} else {
				$this->Session->setFlash(sprintf(__('The Dispencery has been successfully deactivated.', true), ''), 'default', array('class' => 'success'));
				$this->redirect(array('controller' => 'products', 'action' => 'admin_dispencery'));
			}
		} else {
			if($type ==1 ){
				$this->Session->setFlash(sprintf(__('The Book could not be deactivated.Please try again!', true), ''), 'default', array('class' => ''));
				$this->redirect(array('controller' => 'products', 'action' => 'admin_books'));
			} else {
				$this->Session->setFlash(sprintf(__('The Dispencery could not be deactivated.Please try again!', true), ''), 'default', array('class' => ''));
				$this->redirect(array('controller' => 'products', 'action' => 'admin_dispencery'));
			}			
		}
	}	

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	public function admin_books(){
		
		if($this->Session->read('Auth.Admin.user_type')!=1)
		{
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		$this->Product->recursive = 0;		
		if (!empty($this->request->data)){
			//pr($this->request->data);exit;
			$conditions=array();
						
			if(isset($this->request->data['Product']['search']) && $this->request->data['Product']['search']){
				$temp=explode(' ',trim($this->request->data['Product']['search']));
				$whereClause="";
				for($i=0;$i<count($temp);$i++){
					$whereClause.='User.first_name like '."'%".$temp[$i]."%'".' OR User.last_name like '."'%".$temp[$i]."%'";
					if($i!=count($temp)-1){
						$whereClause.=" OR ";
					}
				}
			    $users=$this->User->find('list',array('conditions'=>array($whereClause)));
			    if(empty($users)){
				$users=array('0'=>'0');
			   }
				$conditions=array_merge($conditions,array('Product.user_id IN ('.implode(',',$users).')'));
			}
			//$this->paginate = array('conditions' =>$conditions, 'order' => array('Product.id' => 'ASC'));
			$this->paginate = array('conditions' => array($conditions, 'Product.product_type_id'=>'1'), 'order' => array('Product.id' => 'ASC'));
		} 
		else{
			$this->paginate = array('conditions' => array('Product.product_type_id'=>'1'), 'order' => array('Product.id' => 'ASC'));
		}		
		$this->set('products', $this->paginate());
		//$cat_options = $this->Category->find('list', array('fields' => array('Category.id', 'Category.category_name')));
		//$user_options=$this->User->find('list', array('fields' => array('User.id', 'User.username'),'conditions'=>array('User.user_type'=>4)));
		$users=$this->User->find('all', array('fields' => array('User.id', 'User.first_name','User.last_name'),'conditions'=>array('User.user_type'=>2)));
		$user_options="";
		if($users){
			foreach($users as $u){
				$user_options[$u['User']['id']]=$u['User']['first_name'].' '.$u['User']['last_name'];
			}
		}
		$this->set(compact('users'));
	}
	
		function view_course($id = null){
		
		/*if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}*/
		$uid = $this->Session->read('Auth.User.id');
		$curdate = date('Y-m-d h:i:s');
		$courses = $this->Course->find('all', array('conditions' => array('Course.id' => $id, 'Course.status' => '1')));
		//pr($courses);exit;
		$this->set(compact('courses', 'id', 'uid', 'curdate'));
		$go = "";
		$uid = "";
		if(!empty($this->request->data)){
			$uid = $this->Session->read('Auth.User.id');
			$title = $this->request->data['Course']['title'];
			$reg_cost = $this->request->data['Course']['reg_cost'];
			$organizer = $this->request->data['Course']['user_id'];
			$go = 1;
			$id = $this->request->data['Course']['couid'];;
		}
		$this->set(compact('go', 'uid', 'id', 'title', 'reg_cost', 'organizer'));
	}
	
		function view_product($id = null ,$user_id = null){
		
		
		$uid = $this->Session->read('Auth.User.id');
		$curdate = date('Y-m-d h:i:s');
		$products = $this->Product->find('first', array('conditions' => array('Product.id' => $id, 'Product.blocked' => '0')));
	//	pr($products);
		$this->set(compact('products', 'id', 'uid', 'curdate'));
		$go = "";
		$uid = "";
		if(!empty($this->request->data)){
			$uid = $this->Session->read('Auth.User.id');
			$title = $this->request->data['Course']['title'];
			$reg_cost = $this->request->data['Course']['reg_cost'];
			$organizer = $this->request->data['Course']['user_id'];
			$go = 1;
			$id = $this->request->data['Course']['couid'];;
		}

//$get_user_detail = $this->User->find('first',array('conditions' => array('User.id' => $id)));
$get_user_detail2 = $this->User->find('first',array('conditions' => array('User.id' => $user_id)));
		//pr($get_user_detail);exit;
		$my_user_detail = $this->User->find('first',array('conditions' => array('User.id' => $uid)));
		
		//pr($my_user_detail);
		//pr($get_user_detail);exit;

		//$this->set(compact('my_user_detail', 'get_user_detail'));
		$this->set(compact('my_user_detail', 'get_user_detail2'));
$funnel = $this->Funnel->find('first', array('conditions' => array('Funnel.id' => $products['Product']['funnel_id'], 'Funnel.status' => '1')));

		$this->set(compact('go', 'uid', 'id', 'title', 'reg_cost', 'organizer','funnel'));
	}

 	public function admin_add_books(){
		if($this->Session->read('Auth.Admin.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		if ($this->request->is('post')){
			$flag = true;
			
			if($this->request->data['photo'] !=""){
				$file_basename= basename($this->request->data['photo']);
			}
			//pr($this->request->data);exit;
			//echo $file_basename;exit;
			
			$upc = $this->request->data['Product']['upc'];
			if(ctype_alnum($upc) !=1)
			{
				$this->Session->setFlash(sprintf(__('ERROR :: Upc field must with (A to Z or 1-9).', true)));
				$flag = false;
			}
			
			if (strlen($upc)>13) {
				$this->Session->setFlash(sprintf(__('ERROR :: Upc field maximum content 13 character.', true)));
				$flag = false;
			}			
			
			/*if(isset($this->request->data['Product']['image']['tmp_name']) && is_uploaded_file($this->request->data['Product']['image']['tmp_name'])){				
				$extentioni = strtolower(strrchr($this->request->data['Product']['image']['name'],"."));
				$fileDetaili = $this->request->data['Product']['image'];
				$this->request->data['Product']['image'] = "";				
				if(!in_array($extentioni, $this->validImageFormats)){
					$flag = false;
					$this->Session->setFlash(sprintf(__('ERROR :: Please upload photo only having %s extensions.', true), implode(", ", $this->validImageFormats)));
				}
			} else {
				$flag = false;
			}*/
			
			if(isset($this->request->data['Product']['pdf']['tmp_name']) && is_uploaded_file($this->request->data['Product']['pdf']['tmp_name'])){				
				$extentionp = strtolower(strrchr($this->request->data['Product']['pdf']['name'],"."));
				$fileDetailp = $this->request->data['Product']['pdf'];
				$this->request->data['Product']['pdf'] = "";				
				if(!in_array($extentionp, $this->validPdfFormats)){
					$flag = false;
					$this->Session->setFlash(sprintf(__('ERROR :: Please upload pdf only having %s extensions.', true), implode(", ", $this->validImageFormats)));
				}
			} else {
				$flag = false;
			}			
			if($flag){
				$this->Product->create();		
				if ($this->Product->save($this->request->data)){				
				
					/*if(isset($fileDetaili) && is_uploaded_file($fileDetaili['tmp_name'])){
						$fileNamei = $this->request->data['Product']['user_id'].$this->request->data['Product']['product_name'].$extentioni;
						move_uploaded_file($fileDetaili['tmp_name'], BOOKS_IMAGES . $fileNamei);
						$this->Product->saveField('image', $fileNamei);
					}*/					
					
					if($file_basename !=""){
						$this->Product->saveField('image', $file_basename);
					}
			
			
			
					
					
					if(isset($fileDetailp) && is_uploaded_file($fileDetailp['tmp_name'])){
						$fileNamep = $this->request->data['Product']['user_id'].$this->request->data['Product']['product_name'].$extentionp;
						move_uploaded_file($fileDetailp['tmp_name'], BOOKS_PDFS . $fileNamep);
						$this->Product->saveField('pdf', $fileNamep);
					}
								
					$this->Session->setFlash(__('The product has been saved successfully'));
					$this->redirect(array('action' => 'books'));
				} else {
					$this->Session->setFlash(__('The product could not be saved . Please, try again.'));
				}
			}
		}
		//$types = $this->Product->Type->find('list');
		//$categories = $this->Product->Category->find('list');
		
		$users = $this->User->find('superlist', array('fields'=>array('User.id', 'User.first_name', 'User.last_name'), 
													  'conditions' => array('User.user_type'=>2, 'User.suspend'=>0, 'User.status'=>1)));
		//$users = $this->User->find('list', array('fields' => array('User.id','User.first_name','User.last_name'), 'conditions' => array('User.user_type'=>2, 'User.suspend'=>0, 'User.status'=>1)));
		//pr($users);exit;
		//$tags = $this->Product->Tag->find('list');
		//$categories = $this->Category->find('list',array('fields'=>array('Category.id','Category.category_name')));
		$this->set(compact('users'));
	}


	public function admin_edit_books($id = null){
		
		if($this->Session->read('Auth.Admin.user_type')!=1)
		{
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		
		
		$this->Product->id = $id;
		if(!$this->Product->exists()){
			throw new NotFoundException(__('Invalid product'));
		}

		$fileName = '';
		if(!empty($this->request->data)){
			$flag = true;
			
			if($this->request->data['photo'] !=""){
				$file_basename= basename($this->request->data['photo']);
			}
			
			
			
			//pr($this->request->data);exit;
			$pre_image = $this->request->data['Product']['pre_image'];
			$pre_pdf = $this->request->data['Product']['pre_pdf'];
			
			$upc = $this->request->data['Product']['upc'];
			if(ctype_alnum($upc) !=1)
			{
				$this->Session->setFlash(sprintf(__('ERROR :: Upc field must with (A to Z or 1-9).', true)));
				$flag = false;
			}
			
			if (strlen($upc)>13) {
				$this->Session->setFlash(sprintf(__('ERROR :: Upc field maximum content 13 character.', true)));
				$flag = false;
			}
			
			/*if(isset($this->request->data['Product']['image']['tmp_name']) && $this->request->data['Product']['image']['tmp_name']!='' && 
			is_uploaded_file($this->request->data['Product']['image']['tmp_name'])){
				$extentioni = strtolower(strrchr($this->request->data['Product']['image']['name'], "."));
				$fileDetaili = $this->request->data['Product']['image'];
				$this->request->data['Product']['image'] = '';					
				if(!in_array($extentioni, $this->validImageFormats)){
					$this->request->data['Product']['pre_image'] = $pre_image;
					$flag = false;
					$this->Session->setFlash(sprintf(__('ERROR :: Please upload photo only having %s extensions.', true), implode(", ", $this->validImageFormats)));
				}
				
			} else {
				$this->request->data['Product']['image'] = $this->request->data['Product']['pre_image'];
			}*/			
			
			if(isset($this->request->data['Product']['pdf']['tmp_name']) && $this->request->data['Product']['pdf']['tmp_name']!='' && 
			is_uploaded_file($this->request->data['Product']['pdf']['tmp_name'])){
				$extentionp = strtolower(strrchr($this->request->data['Product']['pdf']['name'], "."));
				$fileDetailp = $this->request->data['Product']['pdf'];
				$this->request->data['Product']['pdf'] = '';					
				if(!in_array($extentionp, $this->validPdfFormats)){
					$this->request->data['Product']['pre_pdf'] = $pre_pdf;
					$flag = false;
					$this->Session->setFlash(sprintf(__('ERROR :: Please upload pdf only .', true), implode(", ", $this->validImageFormats)));
				}
				
			} else {
				$this->request->data['Product']['pdf'] = $this->request->data['Product']['pre_pdf'];
			}			
				
			$this->request->data['Product']['user_id'] = $this->request->data['Product']['user_id'];
			//$this->request->data['Product']['post_date'] = date('Y-m-d h:i:s');
			$this->request->data['Product']['blocked'] = 0;
			
			//pr($this->request->data);exit;
		
			if($flag){
				$this->Product->create();
				if($this->Product->save($this->request->data)){
					/*if(isset($fileDetaili) && is_uploaded_file($fileDetaili['tmp_name'])){
						$fileNamei = $this->request->data['Product']['user_id'].$this->request->data['Product']['product_name'].$extentioni;
						move_uploaded_file($fileDetaili['tmp_name'], BOOKS_IMAGES . $fileNamei);
						$this->Product->saveField('image', $fileNamei);
						if($this->request->data['Product']['pre_image'] != '' && $this->request->data['Product']['pre_image'] != $fileNamei){
							if(file_exists(BOOKS_IMAGES . $this->request->data['Product']['pre_image'])){
								unlink(BOOKS_IMAGES . $this->request->data['Product']['pre_image']);
							}
						}
						$this->request->data['Product']['image'] = $fileNamei;
					}*/ 
					
					if($file_basename !=""){
						$this->Product->saveField('image', $file_basename);
					}
					
					
					
					
					if(isset($fileDetailp) && is_uploaded_file($fileDetailp['tmp_name'])){
						$fileNamep = $this->request->data['Product']['user_id'].$this->request->data['Product']['product_name'].$extentionp;
						move_uploaded_file($fileDetailp['tmp_name'], BOOKS_PDFS . $fileNamep);
						$this->Product->saveField('pdf', $fileNamep);
						if($this->request->data['Product']['pre_pdf'] != '' && $this->request->data['Product']['pre_pdf'] != $fileNamep){
							if(file_exists(BOOKS_PDFS . $this->request->data['Product']['pre_pdf'])){
								unlink(BOOKS_PDFS . $this->request->data['Product']['pre_pdf']);
								}
							}
						$this->request->data['Product']['pre_pdf'] = $fileNamep;
					} 			
					
						$this->Session->setFlash(__('Books has been edited successfully.', true),'default', array('class' => 'success'));
						$this->redirect(array('action' => 'books'));
				} else {
				  $this->Session->setFlash(__('ERROR :: Books could not be edited. Please, try again.', true));
				}
			}
		} 
			$this->request->data = $this->Product->read(null, $id);
			$this->request->data['Product']['pre_pdf'] = $this->request->data['Product']['pdf'];
			$this->request->data['Product']['pre_image'] = $this->request->data['Product']['image'];			
			
			//pr($this->request->data);exit;
			
			$users = $this->User->find('superlist', array('fields'=>array('User.id', 'User.first_name', 'User.last_name'), 
													  'conditions' => array('User.user_type'=>2, 'User.suspend'=>0, 'User.status'=>1)));
			$this->set(compact('users'));

	}


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	public function admin_dispencery(){
		
		if($this->Session->read('Auth.Admin.user_type')!=1)
		{
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		
		
		$this->Product->recursive = 0;		
		if (!empty($this->request->data)){
			//pr($this->request->data);exit;
			$conditions=array();
						
			if(isset($this->request->data['Product']['search']) && $this->request->data['Product']['search']){
				$temp=explode(' ',trim($this->request->data['Product']['search']));
				$whereClause="";
				for($i=0;$i<count($temp);$i++){
					$whereClause.='User.first_name like '."'%".$temp[$i]."%'".' OR User.last_name like '."'%".$temp[$i]."%'";
					if($i!=count($temp)-1){
						$whereClause.=" OR ";
					}
				}
			    $users=$this->User->find('list',array('conditions'=>array($whereClause)));
			    if(empty($users)){
				$users=array('0'=>'0');
			   }
				$conditions=array_merge($conditions,array('Product.user_id IN ('.implode(',',$users).')'));
			}
			//$this->paginate = array('conditions' =>$conditions, 'order' => array('Product.id' => 'ASC'));
			$this->paginate = array('conditions' => array($conditions, 'Product.product_type_id'=>'2'), 'order' => array('Product.id' => 'ASC'));
		} 
		else{
			$this->paginate = array('conditions' => array('Product.product_type_id'=>'2'), 'order' => array('Product.id' => 'ASC'));
		}		
		$this->set('products', $this->paginate());
		//$cat_options = $this->Category->find('list', array('fields' => array('Category.id', 'Category.category_name')));
		//$user_options=$this->User->find('list', array('fields' => array('User.id', 'User.username'),'conditions'=>array('User.user_type'=>4)));
		$users=$this->User->find('all', array('fields' => array('User.id', 'User.first_name','User.last_name'),'conditions'=>array('User.user_type'=>2)));
		$user_options="";
		if($users){
			foreach($users as $u){
				$user_options[$u['User']['id']]=$u['User']['first_name'].' '.$u['User']['last_name'];
			}
		}
		$this->set(compact('users'));
	}

 	public function admin_add_dispencery(){
		if($this->Session->read('Auth.Admin.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		if ($this->request->is('post')){
			$flag = true;
			//pr($this->request->data);exit;
			if($this->request->data['photo'] !=""){
				$file_basename= basename($this->request->data['photo']);
			}
			
			
			
			$upc = $this->request->data['Product']['upc'];
			if(ctype_alnum($upc) !=1)
			{
				$this->Session->setFlash(sprintf(__('ERROR :: Upc field must with (A to Z or 1-9).', true)));
				$flag = false;
			}
			
			if (strlen($upc)>13) {
				$this->Session->setFlash(sprintf(__('ERROR :: Upc field maximum content 13 character.', true)));
				$flag = false;
			}			
			
			/*if(isset($this->request->data['Product']['image']['tmp_name']) && is_uploaded_file($this->request->data['Product']['image']['tmp_name'])){				
				$extentioni = strtolower(strrchr($this->request->data['Product']['image']['name'],"."));
				$fileDetaili = $this->request->data['Product']['image'];
				$this->request->data['Product']['image'] = "";				
				if(!in_array($extentioni, $this->validImageFormats)){
					$flag = false;
					$this->Session->setFlash(sprintf(__('ERROR :: Please upload photo only having %s extensions.', true), implode(", ", $this->validImageFormats)));
				}
			} else {
				$flag = false;
			}*/
			
			if($flag){
				$this->Product->create();		
				if ($this->Product->save($this->request->data)){				
					/*if(isset($fileDetaili) && is_uploaded_file($fileDetaili['tmp_name'])){
						$fileNamei = $this->request->data['Product']['user_id'].$this->request->data['Product']['product_name'].$extentioni;
						move_uploaded_file($fileDetaili['tmp_name'], DISPENSERY_IMAGES . $fileNamei);
						$this->Product->saveField('image', $fileNamei);
					}*/
					
					if($file_basename !=""){
						$this->Product->saveField('image', $file_basename);
					}
					
					
					
										
					$this->Session->setFlash(__('The product has been saved successfully'));
					$this->redirect(array('action' => 'dispencery'));
				} else {
					$this->Session->setFlash(__('The product could not be saved . Please, try again.'));
				}
			}
		}
		
		$users = $this->User->find('superlist', array('fields'=>array('User.id', 'User.first_name', 'User.last_name'), 
													  'conditions' => array('User.user_type'=>2, 'User.suspend'=>0, 'User.status'=>1)));

		$this->set(compact('users'));
	}


	public function admin_edit_dispensery($id = null){
		if($this->Session->read('Auth.Admin.user_type')!=1)
		{
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		
		$this->Product->id = $id;
		if(!$this->Product->exists()){
			throw new NotFoundException(__('Invalid product'));
		}

		$fileName = '';
		if(!empty($this->request->data)){
			$flag = true;
			//pr($this->request->data);exit;
			if($this->request->data['photo'] !=""){
				$file_basename= basename($this->request->data['photo']);
				$pre_image = $this->request->data['Product']['pre_image'];
				if($pre_image != ""){
					unlink(DISPENSERY_IMAGES . $this->request->data['Product']['pre_image']);
				}
				
			}
			
			
			
			
			
			
			$upc = $this->request->data['Product']['upc'];
			if(ctype_alnum($upc) !=1)
			{
				$this->Session->setFlash(sprintf(__('ERROR :: Upc field must with (A to Z or 1-9).', true)));
				$flag = false;
			}
			
			if (strlen($upc)>13) {
				$this->Session->setFlash(sprintf(__('ERROR :: Upc field maximum content 13 character.', true)));
				$flag = false;
			}
			
			/*if(isset($this->request->data['Product']['image']['tmp_name']) && $this->request->data['Product']['image']['tmp_name']!='' && 
			is_uploaded_file($this->request->data['Product']['image']['tmp_name'])){
				$extentioni = strtolower(strrchr($this->request->data['Product']['image']['name'], "."));
				$fileDetaili = $this->request->data['Product']['image'];
				$this->request->data['Product']['image'] = '';					
				if(!in_array($extentioni, $this->validImageFormats)){
					$this->request->data['Product']['pre_image'] = $pre_image;
					$flag = false;
					$this->Session->setFlash(sprintf(__('ERROR :: Please upload photo only having %s extensions.', true), implode(", ", $this->validImageFormats)));
				}
				
			} else {
				$this->request->data['Product']['image'] = $this->request->data['Product']['pre_image'];
			}*/			
			
			$this->request->data['Product']['user_id'] = $this->request->data['Product']['user_id'];
			//$this->request->data['Product']['post_date'] = date('Y-m-d h:i:s');
			$this->request->data['Product']['blocked'] = 0;
			
			//pr($this->request->data);exit;
		
			if($flag){
				$this->Product->create();
				if($this->Product->save($this->request->data)){
					/*if(isset($fileDetaili) && is_uploaded_file($fileDetaili['tmp_name'])){
						$fileNamei = $this->request->data['Product']['user_id'].$this->request->data['Product']['product_name'].$extentioni;
						move_uploaded_file($fileDetaili['tmp_name'], DISPENSERY_IMAGES . $fileNamei);
						$this->Product->saveField('image', $fileNamei);
						if($this->request->data['Product']['pre_image'] != '' && $this->request->data['Product']['pre_image'] != $fileNamei){
							if(file_exists(DISPENSERY_IMAGES . $this->request->data['Product']['pre_image'])){
								unlink(DISPENSERY_IMAGES . $this->request->data['Product']['pre_image']);
							}
						}
						$this->request->data['Product']['image'] = $fileNamei;
					}*/
					
					if($file_basename !=""){
						$this->Product->saveField('image', $file_basename);
					}
					
						$this->Session->setFlash(__('Books has been edited successfully.', true),'default', array('class' => 'success'));
						$this->redirect(array('action' => 'dispencery'));
				} else {
				  $this->Session->setFlash(__('ERROR :: Books could not be edited. Please, try again.', true));
				}
			}
		} 
			$this->request->data = $this->Product->read(null, $id);
			$this->request->data['Product']['pre_pdf'] = $this->request->data['Product']['pdf'];
			$this->request->data['Product']['pre_image'] = $this->request->data['Product']['image'];			
			
			//pr($this->request->data);exit;
			
			$users = $this->User->find('superlist', array('fields'=>array('User.id', 'User.first_name', 'User.last_name'), 
													  'conditions' => array('User.user_type'=>2, 'User.suspend'=>0, 'User.status'=>1)));
			$this->set(compact('users'));

	}


	/* --------------------------------------------------------------- END :: ADMIN PANEL FUNCTIONS --------------------------------------- */
	function add(){
		$this->layout = 'default';
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		$fileName = '';
		if(!empty($this->request->data)){
			$flag = true;
			if(isset($this->request->data['Product']['image']['tmp_name']) && is_uploaded_file($this->request->data['Product']['image']['tmp_name'])){
				$extention = strtolower(strrchr($this->request->data['Product']['image']['name'], "."));
				$fileDetail = $this->request->data['Product']['image'];
				$this->request->data['Product']['image'] = " ";					
				if(!in_array($extention, $this->validImageFormats)){
					$flag = false;
					$this->Session->setFlash(sprintf(__('ERROR :: Please upload photo only having %s extensions.', true), implode(", ", $this->validImageFormats)));
				}
			}
			else{
				$this->request->data['Product']['image'] = $this->request->data['Product']['image'];
			}				
			$this->request->data['Product']['user_id'] = $this->Session->read('Auth.User.id');
			$this->request->data['Product']['post_date'] = date('Y-m-d');
			$this->Product->create();
			if($this->Product->save($this->request->data)){
				if(isset($fileDetail) && is_uploaded_file($fileDetail['tmp_name'])){
					$fileName = $this->User->id.str_replace(' ', ' ', stripslashes(trim($fileDetail['name'])));
					move_uploaded_file($fileDetail['tmp_name'], PROD_IMAGES . $fileName);
					$this->Product->saveField('image', $fileName);
					if($this->request->data['Product']['image'] != ' ' && $this->request->data['Product']['image'] != $fileName){
						if(file_exists(PROD_IMAGES . $this->request->data['Product']['image'])){
							unlink(PROD_IMAGES . $this->request->data['Product']['image']);
							}
						}
					$this->request->data['Product']['image'] = $fileName;
				}
					$this->Session->setFlash(__('Product has been updated successfully.', true),'default', array('class' => 'success'));
					$this->redirect(array('action' => ''));
				} 
			else{
				$this->Session->setFlash(__('ERROR :: Product could not be updated. Please, try again.', true));
			}		
		}		
	}

	/*function tag_field($id=null){
		$this->layout=false;
		$inp="";
		if($id){
			$tags=$this->TagType->find('all',array('fields'=>array('TagType.tag_type','TagType.id'),'conditions'=>array('category_id'=>$id)));			
			if($tags){				
				foreach($tags as $tag){
					$inp.='<input type="text" id="ProductTag" name="data[Product][tags]['.$tag['TagType']['id'].']" class="name_field_bg placeholder validate[required]" placeholder="Add '.$tag['TagType']['tag_type'].'">';
				}
				$inp.='<div class="clr"></div>';
			}
		}
		echo $inp;
		exit;
	}*/
}
