<?php
App::uses('AppController', 'Controller');
/**
* Products Controller
*
* @property Product $Product
*/
class PublishingsController extends AppController {
	public $uses = array('Publishing', 'User', 'Transaction', 'Message','Funnel');
/* --------------------------------------------------------------- START :: ADMIN PANEL FUNCTIONS --------------------------------------- */
/*	function beforeFilter(){
    	$this->myRandomNumber = rand();
	}*/


	public function admin_delete($id = null,$type=null){
		//echo $id;
		
		if($this->Session->read('Auth.Admin.user_type')!=1)
		{
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		
		/*if (!$this->request->is('post')){
			throw new MethodNotAllowedException();
		}*/
		$this->Publishing->id = $id;
		if (!$this->Publishing->exists()){
			throw new NotFoundException(__('Invalid product'));
		}
		
		
		$report = $this->Publishing->read(null, $id);
		//pr($report); exit;
		if ($this->Publishing->delete()){

			if($report['Publishing']['pdf'] != ""){
				if(file_exists(PUBLISHING_FILE . $report['Publishing']['pdf'])){
					unlink(PUBLISHING_FILE . $report['Publishing']['pdf']);
				}
			}
			
				$this->Session->setFlash(sprintf(__('The Publishing has been deleted successfully.', true), ''), 'default', array('class' => 'success'));
				$this->redirect(array('controller' => 'publishings', 'action' => 'index'));
		
		}
		
		$this->Session->setFlash(__('Publishing was not deleted'));
		$this->redirect(array('action' => 'index'));
	}


	public function admin_activate($id=null){
		
		if($this->Session->read('Auth.Admin.user_type')!=1)
		{
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
						 
		$report = $this->Publishing->read(null, $id);
		
		$this->Publishing->id = $id;
		if($this->Publishing->saveField('status','1')){

				$this->Session->setFlash(sprintf(__('The Publishing has been successfully activated.', true), ''), 'default', array('class' => 'success'));
				$this->redirect(array('controller' => 'publishings', 'action' => 'index'));

		} else {
				$this->Session->setFlash(sprintf(__('The Publishing could not be deactivated.Please try again!', true), ''), 'default', array('class' => ''));
				$this->redirect(array('controller' => 'publishings', 'action' => 'index'));
	
		}
	}

	public function admin_deactivate($id=null){
		
		if($this->Session->read('Auth.Admin.user_type')!=1)
		{
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		
		$report = $this->Publishing->read(null, $id);
		//echo $id;exit;
		$this->Publishing->id = $id;
		if($this->Publishing->saveField('status','0')){
			$this->Session->setFlash(sprintf(__('The Publishing has been successfully deactivated.', true), ''), 'default', array('class' => 'success'));
			$this->redirect(array('controller' => 'publishings', 'action' => 'index'));
		} else {
			$this->Session->setFlash(sprintf(__('The Publishing could not be deactivated.Please try again!', true), ''), 'default', array('class' => ''));
			$this->redirect(array('controller' => 'publishings', 'action' => 'index'));
		}
	}	


	/*public function admin_index(){
		$this->layout = 'admin';
		if($this->Session->read('Auth.User.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		$seminars = $this->Seminar->find('all', array('conditions' => array('Seminar.status' => '1')));
		$this->set('seminars', $this->paginate());
	}*/
	
	public function admin_index_xx(){
		$this->layout = 'admin';
		if($this->Session->read('Auth.Admin.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		$publishings = $this->Publishing->find('all', array('conditions' => array('Publishing.status' => '1')));
		$this->set('publishings', $this->paginate());
	}	
	
	
	
	public function admin_index(){
		$this->layout = 'admin';
		if($this->Session->read('Auth.Admin.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
	
	
		$this->Publishing->recursive = 0;		
		if (!empty($this->request->data)){
			$conditions=array();
						
			if(isset($this->request->data['Publishing']['search']) && $this->request->data['Publishing']['search']){
				$temp=explode(' ',trim($this->request->data['Publishing']['search']));
				
				$whereClause="";
				for($i=0;$i<count($temp);$i++){
					$whereClause.='User.first_name like '."'%".$temp[$i]."%'".' OR User.last_name like '."'%".$temp[$i]."%'";
					if($i!=count($temp)-1){
						$whereClause.=" OR ";
					}
				}
			    $users=$this->User->find('list',array('conditions'=>array($whereClause)));
			    if(empty($users)){
				$users=array('0'=>'0');
			   }
				$conditions=array_merge($conditions,array('Publishing.user_id IN ('.implode(',',$users).')'));
			}
			//$this->paginate = array('conditions' =>$conditions, 'order' => array('Product.id' => 'ASC'));
			$this->paginate = array('conditions' => array($conditions, 'Publishing.status'=>array(0,1)), 'order' => array('Publishing.id' => 'ASC'));
		} else {
			$this->paginate = array('conditions' => array('Publishing.status'=>array(0,1)), 'order' => array('Publishing.id' => 'ASC'));
		}		
		$this->set('publish', $this->paginate());
		//$cat_options = $this->Category->find('list', array('fields' => array('Category.id', 'Category.category_name')));
		//$user_options=$this->User->find('list', array('fields' => array('User.id', 'User.username'),'conditions'=>array('User.user_type'=>4)));
		$users=$this->User->find('all', array('fields' => array('User.id', 'User.first_name','User.last_name'),'conditions'=>array('User.user_type'=>2)));
		$user_options="";
		if($users){
			foreach($users as $u){
				$user_options[$u['User']['id']]=$u['User']['first_name'].' '.$u['User']['last_name'];
			}
		}
		$this->set(compact('users'));
	}

 	public function admin_add(){
		
		$this->layout = 'admin';
		if($this->Session->read('Auth.Admin.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		if ($this->request->is('post')){
			$flag = true;
			//pr($this->request->data); exit;
								  
			$this->request->data['Publishing']['reg_cost'] = $this->request->data['Publishing']['price'];
			unset($this->request->data['Publishing']['price']);
			//pr($this->request->data);exit;
			
			
			if(isset($this->request->data['Publishing']['pdf']['tmp_name']) && is_uploaded_file($this->request->data['Publishing']['pdf']['tmp_name'])){
					$extention = strtolower(strrchr($this->request->data['Publishing']['pdf']['name'],"."));
					$fileDetail = $this->request->data['Publishing']['pdf'];
					$this->request->data['Publishing']['pdf'] = "";
					if(!in_array($extention, $this->validPdfFormats)){
						$flag = false;
						$this->Session->setFlash(sprintf(__('ERROR :: Please upload Pdf only .', true), implode(", ", $this->validPdfFormats)));
					}
			} else {
				$this->request->data['Publishing']['pdf'] = '';
			}
			
			if($flag){
				$this->Publishing->create();
				if($this->Publishing->save($this->request->data)){
					
						if(isset($fileDetail) && is_uploaded_file($fileDetail['tmp_name'])){
							$fileName = $this->request->data['Publishing']['user_id']."_".$this->request->data['Publishing']['title'].$extention;
							move_uploaded_file($fileDetail['tmp_name'], PUBLISHING_FILE . $fileName);
							$this->Publishing->saveField('pdf', $fileName);
						}
				
					$this->Session->setFlash(__('Publishing has been updated successfully.', true),'default', array('class' => 'success'));
					$this->redirect(array('action' => 'index'));
				}
				else{
					$this->Session->setFlash(__('ERROR :: Publishing could not be updated. Please, try again.', true));
				}
			}			
			
		}
		
		$users = $this->User->find('superlist', array('fields'=>array('User.id', 'User.first_name', 'User.last_name'), 
													  'conditions' => array('User.user_type'=>2, 'User.suspend'=>0, 'User.status'=>1)));

		$this->set(compact('users'));
	}


	public function admin_edit($id = null){
	if($this->Session->read('Auth.Admin.user_type')!=1)
		{
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		$this->layout = 'admin';
		$this->Publishing->id = $id;
		if(!$this->Publishing->exists()){
			throw new NotFoundException(__('Invalid product'));
		}

		$fileName = '';
		if(!empty($this->request->data)){
			$flag = true;
			//pr($this->request->data);exit;
			
			
			$this->request->data['Publishing']['reg_cost'] = $this->request->data['Publishing']['price'];
			unset($this->request->data['Publishing']['price']);
			
			$prev_pdf = $this->request->data['Publishing']['prev_pdf'];
			
			if(isset($this->request->data['Publishing']['pdf']['tmp_name']) && $this->request->data['Publishing']['pdf']['tmp_name']!='' && is_uploaded_file($this->request->data['Publishing']['pdf']['tmp_name'])){
				$extentioni = strtolower(strrchr($this->request->data['Publishing']['pdf']['name'], "."));
				$fileDetaili = $this->request->data['Publishing']['pdf'];
				$this->request->data['Publishing']['pdf'] = '';					
				if(!in_array($extentioni, $this->validPdfFormats)){
					$this->request->data['Publishing']['prev_pdf'] = $prev_pdf;
					$flag = false;
					$this->Session->setFlash(sprintf(__('ERROR :: Please upload pdf only having %s extensions.', true), implode(", ", $this->validPdfFormats)));
				}
				
			} else {
				$this->request->data['Publishing']['pdf'] = $this->request->data['Publishing']['prev_pdf'];
			}			
			
			//pr($this->request->data);exit;
		
			if($flag){
				$this->Publishing->create();
				if($this->Publishing->save($this->request->data)){
					if(isset($fileDetaili) && is_uploaded_file($fileDetaili['tmp_name'])){
						$fileNamei = $this->request->data['Publishing']['user_id'].$this->request->data['Publishing']['title'].$extentioni;
						move_uploaded_file($fileDetaili['tmp_name'], PUBLISHING_FILE . $fileNamei);
						$this->Publishing->saveField('pdf', $fileNamei);
						if($this->request->data['Publishing']['prev_pdf'] != '' && $this->request->data['Publishing']['prev_pdf'] != $fileNamei){
							if(file_exists(PUBLISHING_FILE . $this->request->data['Publishing']['prev_pdf'])){
								unlink(PUBLISHING_FILE . $this->request->data['Publishing']['prev_pdf']);
							}
						}
						$this->request->data['Publishing']['pdf'] = $fileNamei;
					} 
					
						$this->Session->setFlash(__('Publishing has been edited successfully.', true),'default', array('class' => 'success'));
						$this->redirect(array('action' => 'index'));
				} else {
				  $this->Session->setFlash(__('ERROR :: Publishing could not be edited. Please, try again.', true));
				}
			}
		} 
			$this->request->data = $this->Publishing->read(null, $id);
			$this->request->data['Publishing']['prev_pdf'] = $this->request->data['Publishing']['pdf'];
			$this->request->data['Publishing']['price'] = $this->request->data['Publishing']['reg_cost'];
			
			
			//pr($this->request->data);exit;
			
			$users = $this->User->find('superlist', array('fields'=>array('User.id', 'User.first_name', 'User.last_name'), 
													  'conditions' => array('User.user_type'=>2, 'User.suspend'=>0, 'User.status'=>1)));
			$this->set(compact('users'));

	}	









/* --------------------------------------------------------------- END :: ADMIN PANEL FUNCTIONS --------------------------------------- */
	function add(){
		$this->layout = 'default';
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		$fileName = '';
		$flag = true;
		if(!empty($this->request->data)){
			//pr($this->request->data);exit;
		
			if(isset($this->request->data['Publishing']['pdf']['tmp_name']) && is_uploaded_file($this->request->data['Publishing']['pdf']['tmp_name'])){
					$extention = strtolower(strrchr($this->request->data['Publishing']['pdf']['name'],"."));
					$fileDetail = $this->request->data['Publishing']['pdf'];
					$this->request->data['Publishing']['pdf'] = "";
					if(!in_array($extention, $this->validPdfFormats)){
						$flag = false;
						$this->Session->setFlash(sprintf(__('ERROR :: Please upload PDF only .', true), implode(", ", $this->validPdfFormats)));
					}
			}
			else{
				$flag = false;
				$this->request->data['Publishing']['pdf'] = '';
			}		
		
			if($flag){
			
				$this->request->data['Publishing']['pub_date'] = date('Y-m-d h:i:s');
				$this->request->data['Publishing']['user_id'] = $this->Session->read('Auth.User.id');
				$this->request->data['Publishing']['status'] = '1';
				$this->Publishing->create();
				if($this->Publishing->save($this->request->data)){
				
						if(isset($fileDetail) && is_uploaded_file($fileDetail['tmp_name'])){
							$fileName = $this->Session->read('Auth.User.id')."_".$this->request->data['Publishing']['title'].$extention;
							move_uploaded_file($fileDetail['tmp_name'], PUBLISHING_FILE . $fileName);
							$this->Publishing->saveField('pdf', $fileName);
						}			
				
				
					$this->Session->setFlash(__('Publishing has been updated successfully.', true),'default', array('class' => 'success'));
					$this->redirect('/users/publishing/');
				}
				else{
					$this->Session->setFlash(__('ERROR :: Publishing could not be updated. Please, try again.', true));
				}
				
			}
		}
$funnels = $this->Funnel->find('all', array('conditions' => array( 'Funnel.status' => '1')));
		$this->set(compact('funnels'));
	}
	
	
	function edit($id = null){
		$this->layout = 'default';
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		$fileName = '';
		$flag = true;
		if(!empty($this->request->data)){
			//pr($this->request->data);exit;
		
			if(isset($this->request->data['Publishing']['pdf']['tmp_name']) && is_uploaded_file($this->request->data['Publishing']['pdf']['tmp_name'])){
					$extention = strtolower(strrchr($this->request->data['Publishing']['pdf']['name'],"."));
					$fileDetail = $this->request->data['Publishing']['pdf'];
					$this->request->data['Publishing']['pdf'] = '';
					if(!in_array($extention, $this->validPdfFormats)){
						$flag = false;
						$this->Session->setFlash(sprintf(__('ERROR :: Please upload PDF only .', true), implode(", ", $this->validPdfFormats)));
					}

			} else {
				$this->request->data['Publishing']['pdf'] = $this->request->data['Publishing']['pre_pdf'];
			}		
			
			//pr($this->request->data);exit;
			if($flag){
			
				//$this->request->data['Publishing']['pub_date'] = date('Y-m-d h:i:s');
				$this->request->data['Publishing']['user_id'] = $this->Session->read('Auth.User.id');
				$this->request->data['Publishing']['status'] = '1';
				$this->Publishing->create();
				if($this->Publishing->save($this->request->data)){
				
						if(isset($fileDetail) && is_uploaded_file($fileDetail['tmp_name'])){
							$fileName = $this->Session->read('Auth.User.id')."_".$this->request->data['Publishing']['title'].$extention;
							move_uploaded_file($fileDetail['tmp_name'], PUBLISHING_FILE . $fileName);
							$this->Publishing->saveField('pdf', $fileName);
							if($this->request->data['Publishing']['pdf'] != ' ' && $this->request->data['Publishing']['pre_pdf'] != $fileName){
								if(file_exists(PUBLISHING_FILE . $this->request->data['Publishing']['pre_pdf'])){
									unlink(PUBLISHING_FILE . $this->request->data['Publishing']['pre_pdf']);
								}
							}
							$this->request->data['Publishing']['pdf'] = $fileName;
						}
				
				
					$this->Session->setFlash(__('Publishing has been updated successfully.', true),'default', array('class' => 'success'));
					$this->redirect('/users/publishing/');
				}
				else{
					$this->Session->setFlash(__('ERROR :: Publishing could not be updated. Please, try again.', true));
				}
				
			}
		
		
		
		
		} else {
		
			$this->request->data = $this->Publishing->read(null, $id);
			$this->request->data['Publishing']['pre_pdf'] = $this->request->data['Publishing']['pdf'];
$funnels = $this->Funnel->find('all', array('conditions' => array('Funnel.user_id' => $this->Session->read('Auth.User.id'), 'Funnel.status' => '1')));
$this->set(compact('funnels'));
		}
		
		
		
		
		
		
	}	
	
	
	
	public function delete($id = null,$type=null){
		//echo $id;
		
		
		$this->Publishing->id = $id;
		if (!$this->Publishing->exists()){
			throw new NotFoundException(__('Invalid product'));
		}
		
		
		$report = $this->Publishing->read(null, $id);
		//pr($report); exit;
		if ($this->Publishing->delete()){

			if($report['Publishing']['pdf'] != ""){
				if(file_exists(PUBLISHING_FILE . $report['Publishing']['pdf'])){
					unlink(PUBLISHING_FILE . $report['Publishing']['pdf']);
				}
			}
			
				$this->Session->setFlash(sprintf(__('The Publishing has been deleted successfully.', true), ''), 'default', array('class' => 'success'));
				//$this->redirect(array('controller' => 'publishings', 'action' => 'index'));
		
		}
		else{
		$this->Session->setFlash(__('Publishing was not deleted'));
}

$this->redirect(array('controller' => 'users', 'action' => 'publishing', $this->Session->read('Auth.User.id')));
		//$this->redirect(array('action' => 'index'));
	}

	
	
	
	
	

	function publishingdetail($id = null){
		$this->layout = 'default';
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		$uid = $this->Session->read('Auth.User.id');
		$curdate = date('Y-m-d h:i:s');
		$publishings = $this->Publishing->find('all', array('conditions' => array('Publishing.id' => $id, 'Publishing.status' => '1')));
		$this->set(compact('publishings', 'id', 'uid', 'curdate'));
		$go = "";
		$uid = "";
		if(!empty($this->request->data)){
			$uid = $this->Session->read('Auth.User.id');
			$title = $this->request->data['Publishing']['title'];
			$reg_cost = $this->request->data['Publishing']['reg_cost'];
			$organizer = $this->request->data['Publishing']['user_id'];
			$go = 1;
			$id = $this->request->data['Publishing']['pubid'];;
		}
		$this->set(compact('go', 'uid', 'id', 'title', 'reg_cost', 'organizer'));
	}
	public function thankyou(){
		if(!empty($_GET)){
			$id = explode("@", $_GET['cm']);
			$transaction = $_GET['tx'];
			$status = $_GET['st'];
			$paidon = date('Y-m-d h:i:s');
			$this->request->data['Transaction']['sem_id'] = '0';
			$this->request->data['Transaction']['web_id'] = '0';
			$this->request->data['Transaction']['work_id'] = '0';
			$this->request->data['Transaction']['cou_id'] = '0';
			$this->request->data['Transaction']['pub_id'] = $id[0];
			$this->request->data['Transaction']['ticket'] = $this->myRandomNumber;
			$this->request->data['Transaction']['type'] = '4';
			$this->request->data['Transaction']['user_id'] = $this->Session->read('Auth.User.id');
			$this->request->data['Transaction']['transaction_id'] = $transaction;
			$this->request->data['Transaction']['status'] = $status;
			$this->request->data['Transaction']['paidon'] = $paidon;
			$this->request->data['Transaction']['amount'] = $_GET['amt'];
			$this->request->data['User']['send_date'] = $paidon;
			$this->request->data['User']['from_user'] = $id[1];
			$this->request->data['User']['to_user'] = $this->Session->read('Auth.User.id');
			$this->request->data['User']['message'] = "Your ticket number for the Publishing is " . $this->request->data['Transaction']['ticket'];
			$this->Transaction->create();
		 	if($this->Transaction->save($this->request->data)){
				$this->Session->setFlash(__('Publishing has been updated successfully.', true),'default', array('class' => 'success'));
		 		$this->Message->create();
				if($this->Message->save($this->request->data['User'])){
				}
		 		$this->redirect('/users/dashboard/');
		 	}
		 	else{
		 		$this->Session->setFlash(__('ERROR :: Publishing could not be updated. Please, try again.', true));
		 	}
		}
	}
	public function notify(){
		$this->layout = false;
		if(!empty($_GET)){
			$id = explode("@", $_GET['cm']);
			$transaction = $_GET['tx'];
			$status = $_GET['st'];
			$paidon = date('Y-m-d h:i:s');
			$this->request->data['Transaction']['sem_id'] = '0';
			$this->request->data['Transaction']['web_id'] = '0';
			$this->request->data['Transaction']['work_id'] = '0';
			$this->request->data['Transaction']['cou_id'] = '0';
			$this->request->data['Transaction']['pub_id'] = $id[0];
			$this->request->data['Transaction']['type'] = '5';
			$this->request->data['Transaction']['user_id'] = $this->Session->read('Auth.User.id');
			$this->request->data['Transaction']['transaction_id'] = $transaction;
			$this->request->data['Transaction']['status'] = $status;
			$this->request->data['Transaction']['paidon'] = $paidon;
			$this->request->data['Transaction']['amount'] = $_GET['amt'];
			$this->request->data['User']['send_date'] = $paidon;
			$this->request->data['User']['from_user'] = $id[1];
			$this->request->data['User']['to_user'] = $this->Session->read('Auth.User.id');
			$this->request->data['User']['message'] = "Your ticket number for the Publishing is " . $this->request->data['Transaction']['ticket'];
			$this->Transaction->create();
		 	if($this->Transaction->save($this->request->data)){
				$this->Session->setFlash(__('Publishing has been updated successfully.', true),'default', array('class' => 'success'));
		 		$this->Message->create();
				if($this->Message->save($this->request->data['User'])){
				}
		 		$this->redirect('/users/dashboard/');
		 	}
		 	else{
		 		$this->Session->setFlash(__('ERROR :: Publishing could not be updated. Please, try again.', true));
		 	}
		}
		exit;
	}
	/*archive*/
	public function archive($id=null){
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		$uid = $this->Session->read('Auth.User.id');
		$curdate = date('Y-m-d h:i:s');
		$this->Transaction->recursive = 3;
		$reg_infos = $this->Transaction->find('all', array('conditions' => array('Transaction.type' => '4', 'Transaction.status' => 'Completed')));
		$get_user = $this->User->find('first', array('conditions' => array('User.id' => $uid)));
		$dates = $this->Publishing->find('all', array('conditions' => array('Publishing.user_id' => $id, 'Publishing.status' => '1')));
		
		
		$archives = $this->Publishing->find('all',
													array(
													'conditions' => array('Publishing.user_id'=>$uid),
													'fields'=>array('DATE_FORMAT(Publishing.pub_date, \'%Y %M\') AS  arch','count(Publishing.id) AS numblogs'),
													'order' => array('Publishing.pub_date'=>'ASC'),
													'group'=>array('arch')
													));
				
		$this->set(compact('publishings', 'id', 'uid', 'get_user', 'curdate', 'reg_infos','archives'));
	}
	/*detail*/
	public function detail($id = null){
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		
		$date_var = explode("-", $id);
				if($date_var[1] == "January"){
					$d = $date_var[0]."-01";
				} else if($date_var[1] == "February"){
					$d = $date_var[0]."-02";
				} else if($date_var[1] == "March"){
					$d = $date_var[0]."-03";
				} else if($date_var[1] == "April"){
					$d = $date_var[0]."-04";
				} else if($date_var[1] == "May"){
					$d = $date_var[0]."-05";
				} else if($date_var[1] == "June"){
					$d = $date_var[0]."-06";
				} else if($date_var[1] == "July"){
					$d = $date_var[0]."-07";
				} else if($date_var[1] == "August"){
					$d = $date_var[0]."-08";
				} else if($date_var[1] == "September"){
					$d = $date_var[0]."-09";
				} else if($date_var[1] == "October"){
					$d = $date_var[0]."-10";
				} else if($date_var[1] == "November"){
					$d = $date_var[0]."-11";
				} else if($date_var[1] == "December"){
					$d = $date_var[0]."-12";
				}		

		$uid = $this->Session->read('Auth.User.id');
		$curdate = date('Y-m-d h:i:s');
		$this->Transaction->recursive = 3;
		$reg_infos = $this->Transaction->find('all', array('conditions' => array('Transaction.type' => '4', 'Transaction.status' => 'Completed')));
		$get_user = $this->User->find('first', array('conditions' => array('User.id' => $uid)));
		
		
		$dts = $this->Publishing->find('all', array('conditions' => array('Publishing.user_id' => $uid, 'Publishing.pub_date LIKE' => $d.'%')));
		$this->set(compact('publishings', 'id', 'uid', 'get_user', 'curdate', 'reg_infos', 'dts', 'd'));
	}
	/*registrants*/
	public function registrants($id=null){
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		$uid = $this->Session->read('Auth.User.id');
		$curdate = date('Y-m-d h:i:s');
		$this->Transaction->recursive = 3;
		$reg_infos = $this->Transaction->find('all', array('conditions' => array('Transaction.type' => '4', 'Transaction.status' => 'Completed')));
		$get_user = $this->User->find('first', array('conditions' => array('User.id' => $uid)));
		$publishings = $this->Publishing->find('all', array('conditions' => array('Publishing.user_id' => $id,'Publishing.status' => '1')));
		$this->set(compact('publishings', 'id', 'uid', 'get_user', 'curdate', 'reg_infos'));
	}
	/*payments*/
	public function payments($id=null){
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		$uid = $this->Session->read('Auth.User.id');
		$curdate = date('Y-m-d h:i:s');
		$reg_infos = $this->Transaction->find('all', array('conditions' => array('Transaction.type' => '4', 'Transaction.status' => 'Completed')));
		$total = $this->Transaction->find('list', array('fields' => 'Transaction.amount', 'conditions' => array('Transaction.type' => '4', 'Transaction.status' => 'Completed')));
		$get_user = $this->User->find('first', array('conditions' => array('User.id' => $uid)));
		$publishings = $this->Publishing->find('all', array('conditions' => array('Publishing.user_id' => $id,'Publishing.status' => '1')));
		$this->set(compact('publishings', 'id', 'uid', 'get_user', 'curdate', 'reg_infos', 'total'));
	}
	
	function view_publishing($id = null ,$user_id = null){
		
		
		
		$uid = $this->Session->read('Auth.User.id');
		$get_user_detail2 = $this->User->find('first',array('conditions' => array('User.id' => $user_id)));
		$my_user_detail = $this->User->find('first',array('conditions' => array('User.id' => $uid)));
		
		$publishing = $this->Publishing->find('first', array('conditions' => array('Publishing.id' => $id, 'Publishing.status' => '1')));
		//pr($publishing);exit;
$funnel = $this->Funnel->find('first', array('conditions' => array('Funnel.id' => $publishing['Publishing']['funnel_id'], 'Funnel.status' => '1')));
		$this->set(compact('publishing', 'id','my_user_detail', 'get_user_detail2','funnel'));
	
	
	}

}