<?php
App::uses('AppController', 'Controller');
/**
* Products Controller
*
* @property Product $Product
*/
class SeminarsController extends AppController {
	public $uses = array('Seminar', 'User', 'Transaction', 'Message','Funnel');
/* --------------------------------------------------------------- START :: ADMIN PANEL FUNCTIONS --------------------------------------- */
/*	function beforeFilter(){
    	$this->myRandomNumber = rand();
	}*/

	public function admin_delete($id = null,$type=null){
		//echo $id;
		if($this->Session->read('Auth.Admin.user_type')!=1)
		{
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		
		/*if (!$this->request->is('post')){
			throw new MethodNotAllowedException();
		}*/
		$this->Seminar->id = $id;
		if (!$this->Seminar->exists()){
			throw new NotFoundException(__('Invalid product'));
		}
		
		
		$report = $this->Seminar->read(null, $id);
		//pr($report); exit;
		if ($this->Seminar->delete()){

			if($report['Seminar']['video'] != ""){
				if(file_exists(SEMINER_VIDEO . $report['Seminar']['video'])){
					unlink(SEMINER_VIDEO . $report['Seminar']['video']);
				}
			}
			
				$this->Session->setFlash(sprintf(__('The Seminar has been deleted successfully.', true), ''), 'default', array('class' => 'success'));
				$this->redirect(array('controller' => 'seminars', 'action' => 'index'));
		
		}
		
		$this->Session->setFlash(__('Seminar was not deleted'));
		$this->redirect(array('action' => 'index'));
	}


	public function admin_activate($id=null){
if($this->Session->read('Auth.Admin.user_type')!=1)
		{
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		$report = $this->Seminar->read(null, $id);
		
		$this->Seminar->id = $id;
		if($this->Seminar->saveField('status','1')){

				$this->Session->setFlash(sprintf(__('The Seminar has been successfully activated.', true), ''), 'default', array('class' => 'success'));
				$this->redirect(array('controller' => 'seminars', 'action' => 'index'));

		} else {
				$this->Session->setFlash(sprintf(__('The Seminar could not be deactivated.Please try again!', true), ''), 'default', array('class' => ''));
				$this->redirect(array('controller' => 'seminars', 'action' => 'index'));
	
		}
	}

	public function admin_deactivate($id=null){
		
		if($this->Session->read('Auth.Admin.user_type')!=1)
		{
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		$report = $this->Seminar->read(null, $id);
		//echo $id;exit;
		$this->Seminar->id = $id;
		if($this->Seminar->saveField('status','0')){
			$this->Session->setFlash(sprintf(__('The Seminar has been successfully deactivated.', true), ''), 'default', array('class' => 'success'));
			$this->redirect(array('controller' => 'seminars', 'action' => 'index'));
		} else {
			$this->Session->setFlash(sprintf(__('The Seminar could not be deactivated.Please try again!', true), ''), 'default', array('class' => ''));
			$this->redirect(array('controller' => 'seminars', 'action' => 'index'));
		}
	}	


	/*public function admin_index(){
		$this->layout = 'admin';
		if($this->Session->read('Auth.User.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		$seminars = $this->Seminar->find('all', array('conditions' => array('Seminar.status' => '1')));
		$this->set('seminars', $this->paginate());
	}*/
	
	public function admin_index(){
		$this->layout = 'admin';
		if($this->Session->read('Auth.Admin.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
	
	
		$this->Seminar->recursive = 0;		
		if (!empty($this->request->data)){
			$conditions=array();
						
			if(isset($this->request->data['Seminar']['search']) && $this->request->data['Seminar']['search']){
				$temp=explode(' ',trim($this->request->data['Seminar']['search']));
				
				$whereClause="";
				for($i=0;$i<count($temp);$i++){
					$whereClause.='User.first_name like '."'%".$temp[$i]."%'".' OR User.last_name like '."'%".$temp[$i]."%'";
					if($i!=count($temp)-1){
						$whereClause.=" OR ";
					}
				}
			    $users=$this->User->find('list',array('conditions'=>array($whereClause)));
			    if(empty($users)){
				$users=array('0'=>'0');
			   }
				$conditions=array_merge($conditions,array('Seminar.user_id IN ('.implode(',',$users).')'));
			}
			//$this->paginate = array('conditions' =>$conditions, 'order' => array('Product.id' => 'ASC'));
			$this->paginate = array('conditions' => array($conditions, 'Seminar.status'=>array(0,1)), 'order' => array('Seminar.id' => 'ASC'));
		} else {
			$this->paginate = array('conditions' => array('Seminar.status'=>array(0,1)), 'order' => array('Seminar.id' => 'ASC'));
		}		
		$this->set('seminer', $this->paginate());
		//$cat_options = $this->Category->find('list', array('fields' => array('Category.id', 'Category.category_name')));
		//$user_options=$this->User->find('list', array('fields' => array('User.id', 'User.username'),'conditions'=>array('User.user_type'=>4)));
		$users=$this->User->find('all', array('fields' => array('User.id', 'User.first_name','User.last_name'),'conditions'=>array('User.user_type'=>2)));
		$user_options="";
		if($users){
			foreach($users as $u){
				$user_options[$u['User']['id']]=$u['User']['first_name'].' '.$u['User']['last_name'];
			}
		}
		$this->set(compact('users'));
	}

 	public function admin_add(){
		
		$this->layout = 'admin';
		if($this->Session->read('Auth.Admin.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		if ($this->request->is('post')){
			$flag = true;
			//pr($this->request->data);//exit;
			
			$this->request->data['Seminar']['topic'] 	= $this->request->data['Seminar']['youtube_link'];
			$this->request->data['Seminar']['reg_cost'] = $this->request->data['Seminar']['price'];
			unset($this->request->data['Seminar']['price']);
			unset($this->request->data['Seminar']['youtube_link']);
			//pr($this->request->data);exit;
			
			
			if(isset($this->request->data['Seminar']['video']['tmp_name']) && is_uploaded_file($this->request->data['Seminar']['video']['tmp_name'])){
					$extention = strtolower(strrchr($this->request->data['Seminar']['video']['name'],"."));
					$fileDetail = $this->request->data['Seminar']['video'];
					$this->request->data['Seminar']['video'] = "";
					if(!in_array($extention, $this->validVideoFormats)){
						$flag = false;
						$this->Session->setFlash(sprintf(__('ERROR :: Please upload Video only .', true), implode(", ", $this->validVideoFormats)));
					}
			} else {
				$this->request->data['Seminar']['video'] = '';
			}
			
			if($flag){
				$this->Seminar->create();
				if($this->Seminar->save($this->request->data)){
					
						if(isset($fileDetail) && is_uploaded_file($fileDetail['tmp_name'])){
							$fileName = $this->request->data['Seminar']['user_id']."_".$this->request->data['Seminar']['title'].$extention;
							move_uploaded_file($fileDetail['tmp_name'], SEMINER_VIDEO . $fileName);
							$this->Seminar->saveField('video', $fileName);
						}
				
					$this->Session->setFlash(__('Seminar has been updated successfully.', true),'default', array('class' => 'success'));
					$this->redirect(array('action' => 'index'));
				}
				else{
					$this->Session->setFlash(__('ERROR :: Seminar could not be updated. Please, try again.', true));
				}
			}			
			
		}
		
		$users = $this->User->find('superlist', array('fields'=>array('User.id', 'User.first_name', 'User.last_name'), 
													  'conditions' => array('User.user_type'=>2, 'User.suspend'=>0, 'User.status'=>1)));

		$this->set(compact('users'));
	}


	public function admin_edit($id = null){
	if($this->Session->read('Auth.Admin.user_type')!=1)
		{
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		$this->layout = 'admin';
		$this->Seminar->id = $id;
		if(!$this->Seminar->exists()){
			throw new NotFoundException(__('Invalid product'));
		}

		$fileName = '';
		if(!empty($this->request->data)){
			$flag = true;
			//pr($this->request->data);exit;
			
			
			$this->request->data['Seminar']['topic'] 	= $this->request->data['Seminar']['youtube_link'];
			$this->request->data['Seminar']['reg_cost'] = $this->request->data['Seminar']['price'];
			unset($this->request->data['Seminar']['price']);
			unset($this->request->data['Seminar']['youtube_link']);			
			
			
			$prev_video = $this->request->data['Seminar']['prev_video'];
			
			if(isset($this->request->data['Seminar']['video']['tmp_name']) && $this->request->data['Seminar']['video']['tmp_name']!='' && is_uploaded_file($this->request->data['Seminar']['video']['tmp_name'])){
				$extentioni = strtolower(strrchr($this->request->data['Seminar']['video']['name'], "."));
				$fileDetaili = $this->request->data['Seminar']['video'];
				$this->request->data['Seminar']['video'] = '';					
				if(!in_array($extentioni, $this->validVideoFormats)){
					$this->request->data['Seminar']['prev_video'] = $prev_video;
					$flag = false;
					$this->Session->setFlash(sprintf(__('ERROR :: Please upload photo only having %s extensions.', true), implode(", ", $this->validImageFormats)));
				}
				
			} else {
				$this->request->data['Seminar']['video'] = $this->request->data['Seminar']['prev_video'];
			}			
			
			//pr($this->request->data);exit;
		
			if($flag){
				$this->Seminar->create();
				if($this->Seminar->save($this->request->data)){
					if(isset($fileDetaili) && is_uploaded_file($fileDetaili['tmp_name'])){
						$fileNamei = $this->request->data['Seminar']['user_id'].$this->request->data['Seminar']['title'].$extentioni;
						move_uploaded_file($fileDetaili['tmp_name'], SEMINER_VIDEO . $fileNamei);
						$this->Seminar->saveField('video', $fileNamei);
						if($this->request->data['Seminar']['prev_video'] != '' && $this->request->data['Seminar']['prev_video'] != $fileNamei){
							if(file_exists(SEMINER_VIDEO . $this->request->data['Seminar']['prev_video'])){
								unlink(SEMINER_VIDEO . $this->request->data['Seminar']['prev_video']);
							}
						}
						$this->request->data['Seminar']['video'] = $fileNamei;
					} 
					
						$this->Session->setFlash(__('Seminar has been edited successfully.', true),'default', array('class' => 'success'));
						$this->redirect(array('action' => 'index'));
				} else {
				  $this->Session->setFlash(__('ERROR :: Seminar could not be edited. Please, try again.', true));
				}
			}
		} 
			$this->request->data = $this->Seminar->read(null, $id);
			$this->request->data['Seminar']['pre_video'] = $this->request->data['Seminar']['video'];
			$this->request->data['Seminar']['youtube_link'] = $this->request->data['Seminar']['topic'];
			$this->request->data['Seminar']['price'] = $this->request->data['Seminar']['reg_cost'];
			
			
			//pr($this->request->data);exit;
			
			$users = $this->User->find('superlist', array('fields'=>array('User.id', 'User.first_name', 'User.last_name'), 
													  'conditions' => array('User.user_type'=>2, 'User.suspend'=>0, 'User.status'=>1)));
			$this->set(compact('users'));

	}	
	
	
	
	
	
	
	
	
	
	
	
/* --------------------------------------------------------------- END :: ADMIN PANEL FUNCTIONS --------------------------------------- */
	function add(){
		$this->layout = 'default';
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		$fileName = '';
		$flag = true;
		if(!empty($this->request->data)){
			//pr($this->request->data);exit;
			
			
			if(isset($this->request->data['Seminar']['video']['tmp_name']) && is_uploaded_file($this->request->data['Seminar']['video']['tmp_name'])){
					$extention = strtolower(strrchr($this->request->data['Seminar']['video']['name'],"."));
					$fileDetail = $this->request->data['Seminar']['video'];
					$this->request->data['Seminar']['video'] = "";
					if(!in_array($extention, $this->validVideoFormats)){
						$flag = false;
						$this->Session->setFlash(sprintf(__('ERROR :: Please upload Video only .', true), implode(", ", $this->validVideoFormats)));
					}
			} else {
				$this->request->data['Seminar']['video'] = '';
			}
			
			if($flag){
				$this->request->data['Seminar']['sem_date'] = date('Y-m-d h:i:s');
				$this->request->data['Seminar']['user_id'] = $this->Session->read('Auth.User.id');
				$this->request->data['Seminar']['status'] = '1';
				$this->Seminar->create();
				if($this->Seminar->save($this->request->data)){
					
						if(isset($fileDetail) && is_uploaded_file($fileDetail['tmp_name'])){
							$fileName = $this->Session->read('Auth.User.id')."_".$this->request->data['Seminar']['title'].$extention;
							move_uploaded_file($fileDetail['tmp_name'], SEMINER_VIDEO . $fileName);
							$this->Seminar->saveField('video', $fileName);
						}
				
					$this->Session->setFlash(__('Seminar has been updated successfully.', true),'default', array('class' => 'success'));
					$this->redirect('/users/seminar/');
				}
				else{
					$this->Session->setFlash(__('ERROR :: Seminar could not be updated. Please, try again.', true));
				}
			}
		}

$funnels = $this->Funnel->find('all', array('conditions' => array('Funnel.user_id' => $this->Session->read('Auth.User.id'), 'Funnel.status' => '1')));
//print_r($funnels);
		$this->set(compact('funnels'));
	}


	function edit($id = null){
		$this->layout = 'default';
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		$flag = true;
		$fileName = '';
		if(!empty($this->request->data)){
			$flag = true;
			//pr($this->request->data);exit;
			
			if(isset($this->request->data['Seminar']['video']['tmp_name']) && is_uploaded_file($this->request->data['Seminar']['video']['tmp_name'])){
				$extention = strtolower(strrchr($this->request->data['Seminar']['video']['name'], "."));
				$fileDetail = $this->request->data['Seminar']['video'];
				$this->request->data['Seminar']['video'] = '';					
				if(!in_array($extention, $this->validVideoFormats)){
					$flag = false;
					$this->Session->setFlash(sprintf(__('ERROR :: Please upload video only having %s extensions.', true), implode(", ", $this->validImageFormats)));
				}
			}
			else{
				$this->request->data['Seminar']['video'] = $this->request->data['Seminar']['pre_video'];
			}				
			
			$this->request->data['Seminar']['user_id'] = $this->Session->read('Auth.User.id');
			//$this->request->data['Product']['post_date'] = date('Y-m-d h:i:s');
			$this->request->data['Seminar']['status'] = 1;
						
			if($flag){
				$this->Seminar->create();
				if($this->Seminar->save($this->request->data)){
					if(isset($fileDetail) && is_uploaded_file($fileDetail['tmp_name'])){
						$fileName = $this->Session->read('Auth.User.id').$this->request->data['Seminar']['title'].$extention;
						move_uploaded_file($fileDetail['tmp_name'], SEMINER_VIDEO . $fileName);
						$this->Seminar->saveField('video', $fileName);
						if($this->request->data['Seminar']['video'] != ' ' && $this->request->data['Seminar']['pre_video'] != $fileName){
							if(file_exists(SEMINER_VIDEO . $this->request->data['Seminar']['pre_video'])){
								unlink(SEMINER_VIDEO . $this->request->data['Seminar']['pre_video']);
							}
						}
						$this->request->data['Seminar']['video'] = $fileName;
					} 
					
						$this->Session->setFlash(__('Seminar has been edited successfully.', true),'default', array('class' => 'success'));
						$this->redirect(array('controller' => 'users', 'action' => 'seminar', $this->Session->read('Auth.User.id')));
						//$this->redirect(array('action' => ''));
				} else {
				  $this->Session->setFlash(__('ERROR :: Seminar could not be edited. Please, try again.', true));
				}
			}
		} else {
		
			$this->request->data = $this->Seminar->read(null, $id);
		//	pr($this->request->data);exit;
			$this->request->data['Seminar']['pre_video'] = $this->request->data['Seminar']['video'];
			
			//pr($book);exit;
			//$this->set(compact('prod'));
$funnels = $this->Funnel->find('all', array('conditions' => array('Funnel.user_id' => $this->Session->read('Auth.User.id'), 'Funnel.status' => '1')));
//print_r($funnels);
		$this->set(compact('funnels'));
		}		

		
	}





public function delete($id = null){
		//echo $id;
		
		$this->Seminar->id = $id;
		if (!$this->Seminar->exists()){
			throw new NotFoundException(__('Invalid product'));
		}
		
		
		$report = $this->Seminar->read(null, $id);
		//pr($report); exit;
		if ($this->Seminar->delete()){

			if($report['Seminar']['video'] != ""){
				if(file_exists(SEMINER_VIDEO . $report['Seminar']['video'])){
					unlink(SEMINER_VIDEO . $report['Seminar']['video']);
				}
			}
			
				$this->Session->setFlash(sprintf(__('The Seminar has been deleted successfully.', true), ''), 'default', array('class' => 'success'));
				//$this->redirect(array('controller' => 'seminars', 'action' => 'index'));
		
		}
		else{
		$this->Session->setFlash(__('Seminar was not deleted'));
}
		$this->redirect(array('controller' => 'users', 'action' => 'seminar', $this->Session->read('Auth.User.id')));
	}












	function seminardetail($id = null){
		$this->layout = 'default';
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		$uid = $this->Session->read('Auth.User.id');
		$curdate = date('Y-m-d h:i:s');
		$seminars = $this->Seminar->find('all', array('conditions' => array('Seminar.id' => $id, 'Seminar.status' => '1')));
		$this->set(compact('seminars', 'id', 'uid', 'curdate'));
		$go = "";
		$uid = "";									
		if(!empty($this->request->data)){
			$uid = $this->Session->read('Auth.User.id');
			$title = $this->request->data['Seminar']['title'];
			$reg_cost = $this->request->data['Seminar']['reg_cost'];
			$organizer = $this->request->data['Seminar']['user_id'];
			$go = 1;
			$id = $this->request->data['Seminar']['semid'];
		}
		$this->set(compact('go', 'uid', 'id', 'title', 'reg_cost', 'organizer'));
	}
	public function thankyou(){
		if(!empty($_GET)){
			$id = explode("@", $_GET['cm']);
			$transaction = $_GET['tx'];
			$status = $_GET['st'];
			$paidon = date('Y-m-d h:i:s');
			$this->request->data['Transaction']['sem_id'] = $id[0];
			$this->request->data['Transaction']['web_id'] = '0';
			$this->request->data['Transaction']['work_id'] = '0';
			$this->request->data['Transaction']['cou_id'] = '0';
			$this->request->data['Transaction']['pub_id'] = '0';
			$this->request->data['Transaction']['ticket'] = $this->myRandomNumber;
			$this->request->data['Transaction']['type'] = '1';
			$this->request->data['Transaction']['user_id'] = $this->Session->read('Auth.User.id');
			$this->request->data['Transaction']['transaction_id'] = $transaction;
			$this->request->data['Transaction']['status'] = $status;
			$this->request->data['Transaction']['paidon'] = $paidon;
			$this->request->data['Transaction']['amount'] = $_GET['amt'];
			$this->request->data['User']['send_date'] = $paidon;
			$this->request->data['User']['from_user'] = $id[1];
			$this->request->data['User']['to_user'] = $this->Session->read('Auth.User.id');
			$this->request->data['User']['message'] = "Your ticket number for the Seminar is " . $this->request->data['Transaction']['ticket'];
			$this->Transaction->create();
		 	if($this->Transaction->save($this->request->data)){
				$this->Session->setFlash(__('Seminar has been updated successfully.', true),'default', array('class' => 'success'));
				$this->Message->create();
				if($this->Message->save($this->request->data['User'])){
				}
		 		$this->redirect('/users/dashboard/');
		 	}
		 	else{
		 		$this->Session->setFlash(__('ERROR :: Seminar could not be updated. Please, try again.', true));
		 	}
		}
	}
	public function notify(){
		$this->layout = false;
		if(!empty($_GET)){
			$id = explode("@", $_GET['cm']);
			$transaction = $_GET['tx'];
			$status = $_GET['st'];
			$paidon = date('Y-m-d h:i:s');
			$this->request->data['Transaction']['sem_id'] = $id[0];
			$this->request->data['Transaction']['web_id'] = '0';
			$this->request->data['Transaction']['work_id'] = '0';
			$this->request->data['Transaction']['cou_id'] = '0';
			$this->request->data['Transaction']['pub_id'] = '0';
			$this->request->data['Transaction']['type'] = '1';
			$this->request->data['Transaction']['user_id'] = $this->Session->read('Auth.User.id');
			$this->request->data['Transaction']['transaction_id'] = $transaction;
			$this->request->data['Transaction']['status'] = $status;
			$this->request->data['Transaction']['paidon'] = $paidon;
			$this->request->data['Transaction']['amount'] = $_GET['amt'];
			$this->request->data['User']['from_user'] = $id[1];
			$this->request->data['User']['to_user'] = $this->Session->read('Auth.User.id');
			$this->request->data['User']['message'] = "Your ticket number for the Seminar is " . $this->request->data['Transaction']['ticket'];
			$this->Transaction->create();
		 	if($this->Transaction->save($this->request->data)){
				$this->Session->setFlash(__('Seminar has been updated successfully.', true),'default', array('class' => 'success'));
		 		$this->Message->create();
				if($this->Message->save($this->request->data['User'])){
				}
		 		$this->redirect('/users/dashboard/');
		 	}
		 	else{
		 		$this->Session->setFlash(__('ERROR :: Seminar could not be updated. Please, try again.', true));
		 	}
		}
		exit;
	}
	/*archive*/
	public function archive($id=null){
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		$uid = $this->Session->read('Auth.User.id');
		$curdate = date('Y-m-d h:i:s');
		$this->Transaction->recursive = 3;
		$reg_infos = $this->Transaction->find('all', array('conditions' => array('Transaction.type' => '1', 'Transaction.status' => 'Completed')));
		$get_user = $this->User->find('first', array('conditions' => array('User.id' => $uid)));
		$dates = $this->Seminar->find('all', array('conditions' => array('Seminar.user_id' => $id, 'Seminar.status' => '1')));
		
		$archives = $this->Seminar->find('all',
													array(
													'conditions' => array('Seminar.user_id'=>$uid),
													'fields'=>array('DATE_FORMAT(Seminar.sem_date, \'%Y %M\') AS  arch','count(Seminar.id) AS numblogs'),
													'order' => array('Seminar.sem_date'=>'ASC'),
													'group'=>array('arch')
													));
		
		
		
		
		$this->set(compact('seminars', 'id', 'uid', 'get_user', 'curdate', 'reg_infos','archives'));
	}
	/*detail*/
	public function detail($id = null){
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		
				$date_var = explode("-", $id);
				if($date_var[1] == "January"){
					$d = $date_var[0]."-01";
				} else if($date_var[1] == "February"){
					$d = $date_var[0]."-02";
				} else if($date_var[1] == "March"){
					$d = $date_var[0]."-03";
				} else if($date_var[1] == "April"){
					$d = $date_var[0]."-04";
				} else if($date_var[1] == "May"){
					$d = $date_var[0]."-05";
				} else if($date_var[1] == "June"){
					$d = $date_var[0]."-06";
				} else if($date_var[1] == "July"){
					$d = $date_var[0]."-07";
				} else if($date_var[1] == "August"){
					$d = $date_var[0]."-08";
				} else if($date_var[1] == "September"){
					$d = $date_var[0]."-09";
				} else if($date_var[1] == "October"){
					$d = $date_var[0]."-10";
				} else if($date_var[1] == "November"){
					$d = $date_var[0]."-11";
				} else if($date_var[1] == "December"){
					$d = $date_var[0]."-12";
				}
		
		
		
		$uid = $this->Session->read('Auth.User.id');
		$curdate = date('Y-m-d h:i:s');
		$this->Transaction->recursive = 3;
		$reg_infos = $this->Transaction->find('all', array('conditions' => array('Transaction.type' => '1', 'Transaction.status' => 'Completed')));
		$get_user = $this->User->find('first', array('conditions' => array('User.id' => $uid)));
		$dts = $this->Seminar->find('all', array('conditions' => array('Seminar.sem_date LIKE' => $d.'%','Seminar.user_id' => $uid)));
		
		
		
		$this->set(compact('seminars', 'id', 'uid', 'get_user', 'curdate', 'reg_infos', 'dts', 'd'));
	}
	/*registrants*/
	public function registrants($id=null){
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		$uid = $this->Session->read('Auth.User.id');
		$curdate = date('Y-m-d h:i:s');
		$this->Transaction->recursive = 3;
		$reg_infos = $this->Transaction->find('all', array('conditions' => array('Transaction.type' => '1', 'Transaction.status' => 'Completed')));
		$get_user = $this->User->find('first', array('conditions' => array('User.id' => $uid)));
		$seminars = $this->Seminar->find('all', array('conditions' => array('Seminar.user_id' => $id, 'Seminar.status' => '1')));
		$this->set(compact('seminars', 'id', 'uid', 'get_user', 'curdate', 'reg_infos'));
	}
	/*payments*/
	public function payments($id=null){
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		$uid = $this->Session->read('Auth.User.id');
		$curdate = date('Y-m-d h:i:s');
		$reg_infos = $this->Transaction->find('all', array('conditions' => array('Transaction.type' => '1', 'Transaction.status' => 'Completed')));
		$total = $this->Transaction->find('list', array('fields' => 'Transaction.amount', 'conditions' => array('Transaction.type' => '1', 'Transaction.status' => 'Completed')));
		$get_user = $this->User->find('first', array('conditions' => array('User.id' => $uid)));
		$seminars = $this->Seminar->find('all', array('conditions' => array('Seminar.user_id' => $id, 'Seminar.status' => '1')));
		$this->set(compact('seminars', 'id', 'uid', 'get_user', 'curdate', 'reg_infos', 'total'));
	}
	
	function view_seminar($id = null ,$user_id = null){
		
		
		$uid = $this->Session->read('Auth.User.id');
		$seminars = $this->Seminar->find('first', array('conditions' => array('Seminar.id' => $id, 'Seminar.status' => '1')));
		$get_user_detail2 = $this->User->find('first',array('conditions' => array('User.id' => $user_id)));
		$my_user_detail = $this->User->find('first',array('conditions' => array('User.id' => $uid)));

$funnel = $this->Funnel->find('first', array('conditions' => array('Funnel.id' => $seminars['Seminar']['funnel_id'], 'Funnel.status' => '1')));
		
		//pr($funnel );exit;
		$this->set(compact('seminars', 'id','my_user_detail', 'get_user_detail2','funnel'));
	
	
	}

function funnel($id = null ,$user_id = null){
		
		$this->layout = 'funnel_layout';
		
		$seminars = $this->Seminar->find('first', array('conditions' => array('Seminar.id' => $id, 'Seminar.status' => '1')));	
		

$funnel = $this->Funnel->find('first', array('conditions' => array('Funnel.id' => $seminars['Seminar']['funnel_id'], 'Funnel.status' => '1')));
		
		//pr($funnel );exit;
		$this->set(compact('seminars','funnel'));
	
	
	}
}