<?php
App::uses('AppController', 'Controller');
/**
 * SiteSettings Controller
 *
 * @property SiteSetting $SiteSetting
 */
class SiteSettingsController extends AppController {
	/* --------------------------------------------------------------- START :: ADMIN PANEL FUNCTIONS --------------------------------------- */

	public function admin_general(){
		if($this->Session->read('Auth.Admin.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		if (!empty($this->request->data)){
			$flag = true;
			if(isset($this->request->data['SiteSetting']['site_logo']['tmp_name']) && is_uploaded_file($this->request->data['SiteSetting']['site_logo']['tmp_name'])){
                $extention = strtolower(strrchr($this->request->data['SiteSetting']['site_logo']['name'],"."));
				$fileDetail = $this->request->data['SiteSetting']['site_logo'];
				$this->request->data['SiteSetting']['site_logo'] = "blank";                
				if(!in_array($extention, $this->validImageFormats)){
					$flag = false;
					$this->Session->setFlash(sprintf(__('ERROR :: Please upload site_logo only having %s extensions.', true), implode(", ", $this->validImageFormats)));
				}
            } 
			else{
				$this->request->data['SiteSetting']['site_logo'] = $this->request->data['SiteSetting']['prevlogo'];
			}

			if ($this->SiteSetting->save($this->request->data)){
				if(isset($fileDetail) && is_uploaded_file($fileDetail['tmp_name'])){
					$fileName = $fileDetail['name'];
					move_uploaded_file($fileDetail['tmp_name'], LOGO_IMAGES . $fileName);
					$this->SiteSetting->saveField('site_logo', $fileName);
					if($this->request->data['SiteSetting']['prevlogo']!='' && $this->request->data['SiteSetting']['prevlogo']!=$fileName){
						if(file_exists(LOGO_IMAGES . $this->request->data['SiteSetting']['prevlogo'])){
							unlink(LOGO_IMAGES . $this->request->data['SiteSetting']['prevlogo']);
						}
					}
					$this->request->data['SiteSetting']['prevlogo'] = $fileName;
				}				
				$this->Session->setFlash(__('General site settings saved successfully', true), 'default', array('class' => 'success'));
				$this->redirect(array('action' => 'admin_general'));
			} 
			else{
				$this->Session->setFlash(__('ERROR :: The general site settings could not be saved. Please, try again.', true));
			}
		}
		if (empty($this->request->data)) {
			$this->request->data = $this->SiteSetting->read(null, 1);
			$this->request->data['SiteSetting']['prevlogo'] = $this->request->data['SiteSetting']['site_logo'];
		}
	}

	public function admin_social_links(){
		if($this->Session->read('Auth.Admin.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		if (!empty($this->request->data)){
			if ($this->SiteSetting->save($this->request->data)){
				$this->Session->setFlash(__('Social link site settings saved successfully', true), 'default', array('class' => 'success'));
				$this->redirect(array('action' => 'admin_social_links'));
			} 
			else{
				$this->Session->setFlash(__('Error :: The social link site setting could not be saved. Please, try again.', true));
			}
		}
		if (empty($this->request->data)){
			$this->request->data = $this->SiteSetting->read(null, 1);
		}
	}

	public function admin_social_login_api(){
		if($this->Session->read('Auth.Admin.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		if (!empty($this->request->data)){
			if ($this->SiteSetting->save($this->request->data)){
				$this->Session->setFlash(__('Social login api site settings saved successfully', true), 'default', array('class' => 'success'));
				$this->redirect(array('action' => 'admin_social_login_api'));
			} 
			else{
				$this->Session->setFlash(__('Error :: The social login api site setting could not be saved. Please, try again.', true));
			}
		}
		if (empty($this->request->data)){
			$this->request->data = $this->SiteSetting->read(null, 1);
		}
	}

	public function admin_google_analytics(){
		if($this->Session->read('Auth.Admin.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		if (!empty($this->request->data)){
			if ($this->SiteSetting->save($this->request->data)){
				$this->Session->setFlash(__('The site setting has been saved', true), 'default', array('class' => 'success'));
				$this->redirect(array('action' => 'admin_google_analytics'));
			} else{
				$this->Session->setFlash(__('Error :: The site setting could not be saved. Please, try again.', true));
			}
		}
		if (empty($this->request->data)){
			$this->request->data = $this->SiteSetting->read(null, 1);
		}
	}
	
	/* --------------------------------------------------------------- END :: ADMIN PANEL FUNCTIONS --------------------------------------- */
}