<?php
App::uses('AppController', 'Controller');

class TagTypesController extends AppController {

	public $uses = array('TagType', 'Category');  

	/* --------------------------------------------------------------- START :: ADMIN PANEL FUNCTIONS --------------------------------------- */

	public function admin_index()
	{
		if($this->Session->read('Auth.Admin.user_type')!=1)
		{
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}

		$this->set('tagTypes',$this->paginate());
	}

	public function admin_add()
	{
		if($this->Session->read('Auth.Admin.user_type')!=1)
		{
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}

		$this->Category->recursive=0;
		$categories=$this->Category->find('list',array('fields'=>array('Category.id','Category.category_name')));
		$this->set(compact('categories'));
		if(!empty($this->request->data)){
			$this->TagType->recursive=0;
			$tagTypeExist=$this->TagType->find('first',array('conditions'=>array('TagType.tag_type'=>$this->request->data['TagType']['tag_type'],'TagType.category_id'=>$this->request->data['TagType']['category_id'])));
			if($tagTypeExist){
				$this->Session->setFlash(__('ERROR :: Tag type already exist.', true));
			}else{
				$this->TagType->create();
				if($this->TagType->save($this->request->data)){
					$this->Session->setFlash(__('The tag type has been saved successfully.', true), 'default', array('class' => 'success'));
					$this->redirect(array('action' => 'index'));
				}else{
					$this->Session->setFlash(__('ERROR ::Tag type does not saved. Please try again', true));
					$this->redirect(array('action' => 'index'));
				}
			}
		}

	}

	public function admin_edit($id=null)
	{
		if($this->Session->read('Auth.Admin.user_type')!=1)
		{
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}

		if (!$id && empty($this->request->data)) 
		{
			$this->Session->setFlash(__('ERROR :: Invalid Tag Type.', true));
			$this->redirect(array('action' => 'index'));
		}

		$this->Category->recursive=0;
		$categories=$this->Category->find('list',array('fields'=>array('Category.id','Category.category_name')));
		$this->set(compact('categories'));
		if(!empty($this->request->data)){
			
			$this->TagType->recursive=0;
			$tagTypeExist=$this->TagType->find('first',array('conditions'=>array('TagType.id <>'=>$this->request->data['TagType']['id'],'TagType.tag_type'=>$this->request->data['TagType']['tag_type'],'TagType.category_id'=>$this->request->data['TagType']['category_id'])));
			if($tagTypeExist){
				$this->Session->setFlash(__('ERROR ::Same Tag type already exist.', true));
			}else{
				
				if($this->TagType->save($this->request->data)){
					$this->Session->setFlash(__('The tag type has been saved successfully.', true), 'default', array('class' => 'success'));
					$this->redirect(array('action' => 'index'));
				}else{
					$this->Session->setFlash(__('ERROR ::Tag type does not saved. Please try again', true));
					$this->redirect(array('action' => 'index'));
				}
			}
		}
		if(empty($this->request->data)){
			$this->TagType->recursive=0;
			$this->request->data=$this->TagType->read(null,$id);

		}
	}
	
	/* --------------------------------------------------------------- END :: ADMIN PANEL FUNCTIONS --------------------------------------- */
}
?>