<?php
App::uses('AppController', 'Controller');
/**
* UserReviews Controller
*
* @property UserReview $UserReview
*/
	   
//class UserReviewsController extends AppController{
class UserReviewsController extends AppController{
	public $uses = array('UserReview', 'User', 'Product');
	/* --------------------------------------------------------------- START :: ADMIN PANEL FUNCTIONS --------------------------------------- */
/**
* index method
*
* @return void
*/
	public function admin_index(){
		
		if($this->Session->read('Auth.Admin.user_type')!=1)
		{
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		
		
		if (!empty($this->request->data)){
			$conditions = '';
			if(isset($this->request->data['UserReview']['product_id']) && $this->request->data['UserReview']['product_id']){
				$conditions['UserReview.product_id'] = $this->request->data['UserReview']['product_id'];
			}
			if(isset($this->request->data['UserReview']['search']) && $this->request->data['UserReview']['search']){
				$temp=explode(' ', trim($this->request->data['UserReview']['search']));
				$whereClause="";
				for($i=0; $i<count($temp); $i++){
					$whereClause.='User.first_name like '."'%".$temp[$i]."%'".' OR User.last_name like '."'%".$temp[$i]."%'";
					if($i != count($temp)-1){
						$whereClause.=" OR ";
					}
				}
				$users=$this->User->find('list',array('conditions'=>array($whereClause)));
				if(empty($users)){
					$users=array('0'=>'0');
				}
				$conditions='UserReview.'.$this->request->data['UserReview']['user'].' IN ('.implode(',',$users).')';
			}
			$this->paginate = array('conditions' => $conditions, 'order' => array('UserReview.given_date' => 'DESC'));
		}
		else{
			$this->paginate = array('order' => array('UserReview.given_date' => 'DESC'));
		}
		$this->set('userReviews', $this->paginate());
		$prod_options = $this->Product->find('list', array('fields' => array('Product.id', 'Product.product_name')));
		$this->set('prod_options', $prod_options);
		$user_options = $this->User->find('superlist', array('fields' => array('User.id', 'User.first_name', 'User.last_name'), 'separator' => ' ', 'conditions' => array('User.user_type' => 4)));
		$this->set('user_options', $user_options);
	}
/**
* view method
*
* @throws NotFoundException
* @param string $id
* @return void
*/
	/*public function view($id = null) {
		$this->UserReview->id = $id;
		if (!$this->UserReview->exists()) {
			throw new NotFoundException(__('Invalid user review'));
		}
		$this->set('userReview', $this->UserReview->read(null, $id));
	}*/
/**
* add method
*
* @return void
*/
	public function add() {
		if ($this->request->is('post')) {
			$this->UserReview->create();
			if ($this->UserReview->save($this->request->data)) {
				$this->Session->setFlash(__('The user review has been saved'));
				$this->redirect(array('action' => 'index'));
			} else {
				$this->Session->setFlash(__('The user review could not be saved. Please, try again.'));
			}
		}
		$users = $this->UserReview->User->find('list');
		$this->set(compact('users'));
	}
/**
* edit method
*
* @throws NotFoundException
* @param string $id
* @return void
*/
	/*public function edit($id = null) {
		$this->UserReview->id = $id;
		if (!$this->UserReview->exists()) {
			throw new NotFoundException(__('Invalid user review'));
		}
		if ($this->request->is('post') || $this->request->is('put')) {
			if ($this->UserReview->save($this->request->data)) {
				$this->Session->setFlash(__('The user review has been saved'));
				$this->redirect(array('action' => 'index'));
			} else {
				$this->Session->setFlash(__('The user review could not be saved. Please, try again.'));
			}
		} else {
			$this->request->data = $this->UserReview->read(null, $id);
		}
		$users = $this->UserReview->User->find('list');
		$this->set(compact('users'));
	}*/
/**
* delete method
*
* @throws MethodNotAllowedException
* @throws NotFoundException
* @param string $id
* @return void
*/
	public function admin_delete($id = null){
		
		if($this->Session->read('Auth.Admin.user_type')!=1)
		{
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		
		
		if (!$id){
			$this->Session->setFlash(__('ERROR :: Invalid Id for User Review', true));
			$this->redirect(array('action'=>'index'));
		}
		$this->request->data = $this->UserReview->read(null, $id);
		if ($this->UserReview->delete($id)){
			$this->Session->setFlash(__('The user review has been deleted successfully.', true), 'default', array('class' => 'success'));
			$this->redirect(array('action'=>'index'));
		}
		$this->Session->setFlash(__('ERROR :: The user review was not deleted.', true));
		$this->redirect(array('action' =>'index'));
	}
	/* --------------------------------------------------------------- END :: ADMIN PANEL FUNCTIONS --------------------------------------- */

	public function post_review($id = null){
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: Please Login to Give Review', true));
			$this->redirect('/users/login/user_reviews/post_review/'.$id);
			//$this->redirect('/');
		}
		//echo "Development";exit;
		$uid = $this->Session->read('Auth.User.id');
		$this->User->recursive = 1;
		$get_user_detail = $this->User->find('first',array('conditions' => array('User.id' => $id)));
		$my_user_detail = $this->User->find('first',array('conditions' => array('User.id' => $uid)));		
		
		
		//pr($my_user_detail);
		//pr($get_user_detail);exit;
		
		if(!empty($this->request->data)){
			//pr($this->request->data);exit;
			$flag = true;
			if($this->request->data['UserReview']['rating'] == "" && $this->request->data['UserReview']['review'] == ""){
				$this->Session->setFlash(__('ERROR :: Rating and Review both cannot be Blank', true), 'default');
				$flag = false;
			} else {
			
				if($this->request->data['UserReview']['rating'] == ""){
					$this->request->data['UserReview']['rating'] = 0;
				}
				
				if($this->request->data['UserReview']['review'] ==""){
					$this->request->data['UserReview']['review'] = "";
				}			
			
				$pid = $this->Session->read('Auth.User.id');
				//$this->request->data['UserReview']['user_id'] = $id;
				$this->request->data['UserReview']['given_by'] = $pid;
				$this->request->data['UserReview']['given_date'] = date('Y-m-d h:i:s');
			}
			
			if($flag){
				$this->UserReview->create();
				if($this->UserReview->save($this->request->data)){
					$this->Session->setFlash(__('Review has been saved successfully.', true), 'default', array('class' => 'success'));
					$this->redirect('/users/view_search_user_detail/'.$id);
				}
			}
		}
		

		$this->set(compact('my_user_detail', 'get_user_detail'));		
	}
	
	
	
		public function admin_activate($id = null){
		
		if($this->Session->read('Auth.Admin.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		
		$report = $this->UserReview->read(null, $id);
		if(!$report)
		{
			 $this->Session->setFlash(__('ERROR :: Invalid Group', true));
			 $this->redirect('/user_reviews');
		}
		
		$this->UserReview->id = $id;
		if($this->UserReview->saveField('status',1-$report['UserReview']['status'])){
			$this->Session->setFlash(sprintf(__('The Review has been successfully '.($report['UserReview']['status'] ? 'deactivated' : 'activated') , true), ''), 'default', array('class' => 'success'));
			
		}
		else{
			$this->Session->setFlash(sprintf(__('The Review could not be '.($report['UserReview']['status'] ? 'deactivated' : 'activated').'. Please try again!', true), ''), 'default', array('class' => ''));
			//$this->redirect(array('controller' => 'abuse_reports'));
			
		}
		$this->redirect(array('controller' => 'user_reviews', 'action' => 'admin_index'));
	}
	
		public function admin_view($id = null){
		if($this->Session->read('Auth.Admin.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}




		$this->UserReview->recursive = 1;
		$this->UserReview->id = $id;
		if (!$this->UserReview->exists()){
			throw new NotFoundException(__('Invalid review'));
		}
		
		$group = $this->UserReview->find('first', array('conditions'=>array('UserReview.id'=>$id)));
		
	
		
		
		$this->set(compact('group'));


	}
}