<?php
App::uses('AppController', 'Controller');
/**
* Users Controller
*
* @property User $User
*/
class UsersController extends AppController{
	var $uses = array('User', 'Phone', 'Message', 'UserReview', 'Approval', 'Product', 'Order', 'Publishing', 'Seminar', 'Webinar', 'Workshop', 'Course', 'Transaction', 'Group', 'Groupapproval', 'Groupmember');
	/* --------------------------------------------------------------- START :: ADMIN PANEL FUNCTIONS --------------------------------------- */
	public function admin_login(){
		if($this->request->is('post')){
			//pr($this->request->data);exit;
			if($this->Auth->login()){
			
				//pr($this->Session->read('Auth.User.id'));exit;
				
				$this->Session->setFlash(__('You are successfully logged in', true));
				$this->redirect($this->Auth->redirect());
			}
			else{
				$this->Session->setFlash(__('ERROR :: Invalid username and password, try again', true));
			}
		}
	}
	public function admin_logout(){
		if($this->Auth->logout()){
			$this->Session->setFlash(__('You are successfully logged out', true));
		$this->redirect('/admin');
		}
	}
	
	public function admin_home(){
		//pr($this);
		//pr($this->Session->read('Auth.User')); exit;
		//echo "<pre>"; print_r($this->Session->read('Auth.User')); echo "<pre>"; exit;
	}
	
	
	public function admin_change_password(){
		$id = $this->Session->read('Auth.User.id');
		if($this->Session->read('Auth.User.id')){
			$flag = true;
			if (!$id && empty($this->request->data)){
				$this->Session->setFlash(__('Invalid admin', true));
				$this->redirect(array('action' => 'admin_home'));
			}
			if (!empty($this->request->data)){
				//echo $id;
				//pr($this->request->data);exit;
				if($this->request->data['User']['old_password']!= '' || $this->request->data['User']['new_password']!='' || $this->request->data['User']['confirm_password']!=''){
					if($this->request->data['User']['old_password']==''){
						$this->Session->setFlash(__('ERROR :: Please enter old password.', true));
						$flag = false;
					}
					else if($this->request->data['User']['new_password']==''){
						$this->Session->setFlash(__('ERROR :: Please enter new password.', true));
						$flag = false;
					}
					else if($this->request->data['User']['confirm_password']==''){
						$this->Session->setFlash(__('ERROR :: Please enter confirm password.', true));
						$flag = false;
					}
					else if($this->request->data['User']['new_password'] != $this->request->data['User']['confirm_password']){
						$this->Session->setFlash(__("ERROR :: Password and Confirm password does not match. Please try again.", true));
						$flag = false;
					} else {
						$oldPassword = $this->User->find('first', array('conditions' => 
														array("User.password" => Security::hash(Configure::read('Security.salt').$this->request->data['User']['old_password']),
															  "User.id" => $id)));
						
						if(isset($oldPassword['User']['password'])){			   
							if($oldPassword['User']['password'] != Security::hash(Configure::read('Security.salt').$this->request->data['User']['old_password'])){
								$this->Session->setFlash(__("ERROR :: Old password does not match. Please try again.", true));
								$flag = false;
							} else {
								$this->Session->setFlash(__("ERROR :: Old password does not match. Please try again.", true));
								$flag = false;
							}
						}
						else{
							$this->request->data['User']['password'] = Security::hash(Configure::read('Security.salt').$this->request->data['User']['new_password']);
							$this->request->data['User']['id'] = $this->Session->read('Auth.User.id');
							$flag = true;
						}
					}
				}
				if ($flag){
					if ($this->User->save($this->request->data)){
						$this->Session->setFlash(__('The change password has been saved', true), 'default', array('class' => 'success'));
						$this->redirect(array('action' => 'change_password'));
					}
					else{
						$this->Session->setFlash(__('The user could not be saved. Please, try again.', true));
					}
				}
			}
		} else{
			$this->Session->setFlash(__('You are not authorized to access that location.', true));
			$this->redirect(array('controller' => 'users', 'action' => 'admin_home'));
		}
	}
	public function admin_export($id = null){
		if($this->Session->read('Auth.User.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		$this->User->recursive = 0;
		$this->layout = false;
		$this->autoLayout = false;
		$users = $this->User->find('all', array('fields' => array('User.username', 'User.first_name', 'User.last_name', 'User.email', 'User.registration_date', 'User.phone_number'), 'conditions' => array('User.user_type' => $id)));
		header("Content-type: application/csv");
		if($id==2){
			$fileName = 'doctors_'.date("Ymd");
		}
		else if($id==3){
			$fileName = 'platinum_patients_'.date("Ymd");
		}
		else if($id==4){
			$fileName = 'gold_patients_'.date("Ymd");
		}
		else if($id==5){
			$fileName = 'free_patients_'.date("Ymd");
		}
		header("Content-Disposition: attachment; filename=".$fileName.".csv");
		$this->set('users', $users);
	}
	
	function admin_delete($id = null, $rd = null){
		if($this->Session->read('Auth.User.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		if($rd == 2){
			$ut = "Doctors";
			$rd = "index";
		}
		else if($rd == 3){
			$ut = "Platinaum Patient";
			$rd = "patient";
		}
		else if($rd == 4){
			$ut = "Gold Patient";
			$rd = "patient";
		}
		else if($rd == 5){
			$ut = "Free Patient";
			$rd = "patient";
		}
		if (!$id){
			$this->Session->setFlash(__('ERROR :: Invalid Id for '.$ut.'.', true));
			$this->redirect(array('controller'=>'users','action'=>$rd));
		}
		$this->request->data = $this->User->read(null, $id);
		if ($this->User->delete($id)){
			if($this->request->data['User']['photo']!=''){
				if(file_exists(USER_IMAGES . $this->request->data['User']['photo'])){
					unlink(USER_IMAGES . $this->request->data['User']['photo']);
				}
			}
			
			if($this->request->data['User']['document']!=''){
				if(file_exists(USER_DOCS . $this->request->data['User']['document'])){
					unlink(USER_DOCS . $this->request->data['User']['document']);
				}
			}			
			
			$this->Session->setFlash(__('The '.$ut.' has been deleted successfully.', true), 'default', array('class' => 'success'));
			$this->redirect(array('action'=>$rd));
		}
		$this->Session->setFlash(__('ERROR :: The '.$ut.' was not deleted.', true));
		$this->redirect(array('action' => $rd));
	}
	public function admin_suspend($id = null, $type = null){
		if($this->Session->read('Auth.User.user_type') != 1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		if($type == 2){
			$type = "index";
		}
		else if($type == 3){
			$type = "patient";
		}
		else if($type == 4){
			$type = "patient";
		}
		else if($type == 5){
			$type = "patient";
		}
		if (!$id){
			$this->Session->setFlash(__('ERROR :: Invalid Id.', true));
			$this->redirect(array('action'=>$type));
		}
		$this->User->recursive = 0;
		$report = $this->User->read(null, $id);
		$this->User->id = $id;
		if($this->User->saveField('suspend','1')){
			$this->Session->setFlash(sprintf(__('The user has been successfully suspended.', true), ''), 'default', array('class' => 'success'));
			$mail_To = $report['User']['email'];
			$mail_From = $this->Session->read('Auth.User.email');
			$mail_subject = "Account has been suspended.";
			$mail_Body1 = "Dear ".$report['User']['first_name'].",<br>Your account has been suspended";
			$mail_Body = nl2Br($mail_Body1);
			$this->Send_HTML_Mail($mail_To, $mail_From, '', $mail_subject, $mail_Body);
			$this->redirect(array('controller' => 'users', 'action' => $type));
		}
		else{
			$this->Session->setFlash(sprintf(__('The user could not be suspended. Please try again!', true), ''), 'default', array('class' => ''));
			$this->redirect(array('controller' => 'users', 'action' => $type));
		}
	}
	public function admin_activate($id = null, $type = null){
		if($this->Session->read('Auth.User.user_type') != 1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		if($type == 2){
			$type = "index";
		}
		else if($type == 3){
			$type = "patient";
		}
		else if($type == 4){
			$type = "patient";
		}
		else if($type == 5){
			$type = "patient";
		}
		if (!$id){
			$this->Session->setFlash(__('ERROR :: Invalid Id.', true));
			$this->redirect(array('action'=>$type));
		}
		$this->User->recursive = 0;
		$report = $this->User->read(null, $id);
		$this->User->id = $id;
		if($this->User->saveField('suspend','0')){
			$this->Session->setFlash(sprintf(__('The user has been successfully activated.', true), ''), 'default', array('class' => 'success'));
			$mail_To = $report['User']['email'];
			$mail_From = $this->Session->read('Auth.User.email');
			$mail_subject = "Account has been activated.";
			$mail_Body1 = "Dear ".$report['User']['first_name'].",<br>Your account has been activated.";
			$mail_Body =nl2Br($mail_Body1);
			$this->Send_HTML_Mail($mail_To, $mail_From,'', $mail_subject, $mail_Body);
			$this->redirect(array('controller' => 'users', 'action' => $type));
		}
		else{
			$this->Session->setFlash(sprintf(__('The user could not be activated.Please try again!', true), ''), 'default', array('class' => ''));
			$this->redirect(array('controller' => 'users', 'action' => $type));
		}
	}

	/*for Doctors Start Here         #############################################################################################################*/

	public function admin_index(){
		if($this->Session->read('Auth.User.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}

		//pr($this->Session->read('Auth.User.id'));exit;
		$this->User->recursive = 0;
		if(!empty($this->request->data)){
			$temp=explode(' ',trim($this->request->data['User']['search']));
			$whereClause="";
			for($i=0;$i<count($temp);$i++){
				$whereClause.='User.first_name like '."'%".$temp[$i]."%'".' OR User.last_name like '."'%".$temp[$i]."%'";
				if($i != count($temp) - 1){
					$whereClause.=" OR ";
				}
			}
			$this->paginate = array('conditions' =>array('('.$whereClause.')',array('User.user_type' => 2)),'order' => array('id' => 'desc'),'limit'=>20);
		}else{
			$this->paginate = array('order' => array('id' => 'desc'), 'conditions' => array('User.user_type' => array(2)),'limit'=>20);
		}
		$this->set('users', $this->paginate());
	}
	public function admin_add(){
		if($this->Session->read('Auth.User.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		$fileName = '';
		if (!empty($this->request->data)){
			
			$get_username = $this->User->find('first', array('conditions' => array('User.username' => $this->request->data['User']['username'])));
			$get_email = $this->User->find('first', array('conditions' => array('User.email' => $this->request->data['User']['email'])));
			if($get_username){
				$this->Session->setFlash(__('ERROR :: Same username already exists.', true));
			}
			else if($get_email){
				$this->Session->setFlash(__('ERROR :: Same email address already exists.', true));
			}
			else if($this->request->data['User']['user_password'] != $this->request->data['User']['confirm_password']){
				$this->Session->setFlash(__('ERROR :: Password missmatched.', true));
			}
			else{
				$flag = true;
				if(isset($this->request->data['User']['photo']['tmp_name']) && is_uploaded_file($this->request->data['User']['photo']['tmp_name'])){
					$extention = strtolower(strrchr($this->request->data['User']['photo']['name'],"."));
					$fileDetail = $this->request->data['User']['photo'];
					$this->request->data['User']['photo'] = "";
					if(!in_array($extention, $this->validImageFormats)){
						$flag = false;
						$this->Session->setFlash(sprintf(__('ERROR :: Please upload photo only having %s extensions.', true), implode(", ", $this->validImageFormats)));
					}
				}
				else{
					$this->request->data['User']['photo'] = '';
				}
				$this->request->data['User']['password'] = Security::hash(Configure::read('Security.salt').$this->request->data['User']['user_password']);
				$this->User->create();
				if ($this->User->save($this->request->data)){
					if(isset($fileDetail) && is_uploaded_file($fileDetail['tmp_name'])){
						$fileName = $this->User->id.str_replace(' ', '', stripslashes(trim($fileDetail['name'])));
						move_uploaded_file($fileDetail['tmp_name'], USER_IMAGES . $fileName);
						$this->User->saveField('photo', $fileName);
					}
					$this->Session->setFlash(__('User has been saved successfully.', true), 'default', array('class' => 'success'));
					$this->redirect(array('action' => 'index'));
				}
				else{
					$this->Session->setFlash(__('ERROR :: The '.$ut.' could not be saved. Please, try again.', true));
				}
			}
		}
	}
	public function admin_edit($id = null){
		if($this->Session->read('Auth.User.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		if (!$id){
			$this->Session->setFlash(__('ERROR :: Invalid Id.', true));
			$this->redirect(array('action'=>'index'));
		}
		$fileName = '';
		if (!empty($this->request->data)){
			$get_email = $this->User->find('first', array('conditions' => array('User.email' => $this->request->data['User']['email'], 'User.id <>' => $id)));
			if($get_email){
				$this->Session->setFlash(__('ERROR :: Same email address already exists.', true));
			}
			
			
			else if($this->request->data['User']['user_password']=='' && $this->request->data['User']['confirm_password']!=''){
				$this->Session->setFlash(__('ERROR :: Please enter password.', true));
			}
			else if($this->request->data['User']['user_password']!='' && $this->request->data['User']['confirm_password']==''){
				$this->Session->setFlash(__('ERROR :: Please enter confirm password.', true));
			}
			else if($this->request->data['User']['user_password']!='' && $this->request->data['User']['confirm_password']!='' &&
			($this->request->data['User']['user_password'] != $this->request->data['User']['confirm_password'])){
				$this->Session->setFlash(__('ERROR :: Password missmatched.', true));
			}
			else{
				$flag = true;
				if(isset($this->request->data['User']['photo']['tmp_name']) && is_uploaded_file($this->request->data['User']['photo']['tmp_name'])){
					$extention = strtolower(strrchr($this->request->data['User']['photo']['name'],"."));
					$fileDetail = $this->request->data['User']['photo'];
					$this->request->data['User']['photo'] = "";
					if(!in_array($extention, $this->validImageFormats)){
						$flag = false;
						$this->Session->setFlash(sprintf(__('ERROR :: Please upload photo only having %s extensions.', true), implode(", ", $this->validImageFormats)));
					}
				}
				else{
					$this->request->data['User']['photo'] = $this->request->data['User']['prev_photo'];
				}
				if($this->request->data['User']['user_password']!=''){
					$this->request->data['User']['password'] = Security::hash(Configure::read('Security.salt').$this->request->data['User']['user_password']);
				}
				else{
					$this->request->data['User']['password'] = $this->request->data['User']['user_password'];
				}
				$this->User->create();
				if ($this->User->save($this->request->data)){
					if(isset($fileDetail) && is_uploaded_file($fileDetail['tmp_name'])){
						$fileName = $this->User->id.str_replace(' ', '', stripslashes(trim($fileDetail['name'])));
						move_uploaded_file($fileDetail['tmp_name'], USER_IMAGES . $fileName);
						$this->User->saveField('photo', $fileName);
						if($this->request->data['User']['prev_photo']!='' && $this->request->data['User']['prev_photo']!=$fileName){
							if(file_exists(USER_IMAGES . $this->request->data['User']['prev_photo'])){
								unlink(USER_IMAGES . $this->request->data['User']['prev_photo']);
							}
						}
						$this->request->data['User']['prev_photo'] = $fileName;
					}
					$this->Session->setFlash(__('Doctor has been updated successfully.', true),'default', array('class' => 'success'));
					$this->redirect(array('action' => 'index'));
				}
				else{
					$this->Session->setFlash(__('ERROR :: Doctor could not be updated. Please, try again.', true));
				}
			}
		}
		if (empty($this->request->data)){
			$this->request->data = $this->User->read(null, $id);
			$this->request->data['User']['user_password'] = $this->request->data['User']['password'];
			$this->request->data['User']['prev_photo'] = $this->request->data['User']['photo'];
		}
	}
	/*for Patients Start Here         #############################################################################################################*/
	public function admin_patient(){
		if($this->Session->read('Auth.User.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		$this->User->recursive = 0;
		if(!empty($this->request->data)){
			$temp=explode(' ',trim($this->request->data['User']['search']));
			$whereClause="";
			for($i=0;$i<count($temp);$i++){
				$whereClause.='User.first_name like '."'%".$temp[$i]."%'".' OR User.last_name like '."'%".$temp[$i]."%'";
				if($i!=count($temp)-1){
					$whereClause.=" OR ";
				}
			}
			$this->paginate = array('conditions' =>array('('.$whereClause.')',array('User.user_type' => array(3,4,5))),'order' => array('id' => 'desc'),'limit'=>20);
		}else{
			$this->paginate = array('order' => array('id' => 'desc'), 'conditions' => array('User.user_type' => array(3,4,5)),'limit'=>20);
		}
		$this->set('users', $this->paginate());
	}
	
	public function admin_add_patient(){
		if($this->Session->read('Auth.User.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		$fileName = '';
		if (!empty($this->request->data)){
			//pr($this->request->data);exit;
			
			$flag = true;
			$get_username = $this->User->find('first', array('conditions' => array('User.username' => $this->request->data['User']['username'])));
			$get_email = $this->User->find('first', array('conditions' => array('User.email' => $this->request->data['User']['email'])));
			if($get_username){
				$this->Session->setFlash(__('ERROR :: Same username already exists.', true));
				$flag = false;
			}
			else if($get_email){
				$this->Session->setFlash(__('ERROR :: Same email address already exists.', true));
				$flag = false;
			}
			
			else if($this->request->data['User']['user_password'] != $this->request->data['User']['confirm_password']){
				$this->Session->setFlash(__('ERROR :: Password missmatched.', true));
			}
			else{
			
				if(isset($this->request->data['User']['photo']['tmp_name']) && is_uploaded_file($this->request->data['User']['photo']['tmp_name'])){
					$extentionp = strtolower(strrchr($this->request->data['User']['photo']['name'],"."));
					$fileDetailp = $this->request->data['User']['photo'];
					$this->request->data['User']['photo'] = "";
					if(!in_array($extentionp, $this->validImageFormats)){
						$flag = false;
						$this->Session->setFlash(sprintf(__('ERROR :: Please upload photo only having %s extensions.', true), implode(", ", $this->validImageFormats)));
					}
				} else {
					$this->request->data['User']['photo'] = '';
				}
				
				if(isset($this->request->data['User']['document']['tmp_name']) && is_uploaded_file($this->request->data['User']['document']['tmp_name'])){
					$extentiond = strtolower(strrchr($this->request->data['User']['document']['name'],"."));
					$fileDetaild = $this->request->data['User']['document'];
					$this->request->data['User']['document'] = "";
					if(!in_array($extentiond, $this->validDocsFormats)){
						$flag = false;
						$this->Session->setFlash(sprintf(__('ERROR :: Please upload Document only having %s extensions.', true), implode(", ", $this->validDocsFormats)));
					}
				} else {
					$this->request->data['User']['document'] = '';
				}
				
				
				$this->request->data['User']['password'] = Security::hash(Configure::read('Security.salt').$this->request->data['User']['user_password']);
				$this->User->create();
				if ($this->User->save($this->request->data)){
				
						if(isset($fileDetailp) && is_uploaded_file($fileDetailp['tmp_name'])){
							$fileNamep = $this->User->id.str_replace(' ', '', stripslashes(trim($fileDetailp['name'])));
							move_uploaded_file($fileDetailp['tmp_name'], USER_IMAGES . $fileNamep);
							$this->User->saveField('photo', $fileNamep);
						}
						
						
						if(isset($fileDetaild) && is_uploaded_file($fileDetaild['tmp_name'])){
							$fileNamed = $this->User->id.str_replace(' ', '', stripslashes(trim($fileDetaild['name'])));
							move_uploaded_file($fileDetaild['tmp_name'], USER_DOCS . $fileNamed);
							$this->User->saveField('document', $fileNamed);
						}
					
					$this->Session->setFlash(__('User has been saved successfully.', true), 'default', array('class' => 'success'));
					$this->redirect(array('action' => 'patient'));
				} else {
					$this->Session->setFlash(__('ERROR :: The '.$ut.' could not be saved. Please, try again.', true));
				}
			}
		}
	}
	
	public function admin_edit_patient($id = null){
		if($this->Session->read('Auth.User.user_type')!=1){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/admin');
		}
		if (!$id){
			$this->Session->setFlash(__('ERROR :: Invalid Id.', true));
			$this->redirect(array('action'=>'index'));
		}
		$fileName = '';
		if (!empty($this->request->data)){
			//pr($this->request->data);exit;
			$get_email = $this->User->find('first', array('conditions' => array('User.email' => $this->request->data['User']['email'], 'User.id <>' => $id)));
			if($get_email){
				$this->Session->setFlash(__('ERROR :: Same email address already exists.', true));
			}
			else if($this->request->data['User']['user_password']=='' && $this->request->data['User']['confirm_password']!=''){
				$this->Session->setFlash(__('ERROR :: Please enter password.', true));
			}
			else if($this->request->data['User']['user_password']!='' && $this->request->data['User']['confirm_password']==''){
				$this->Session->setFlash(__('ERROR :: Please enter confirm password.', true));
			}
			else if($this->request->data['User']['user_password']!='' && $this->request->data['User']['confirm_password']!='' && 
			($this->request->data['User']['user_password'] != $this->request->data['User']['confirm_password'])){
				$this->Session->setFlash(__('ERROR :: Password missmatched.', true));
			}
			else{
				$flag = true;
				if(isset($this->request->data['User']['photo']['tmp_name']) && is_uploaded_file($this->request->data['User']['photo']['tmp_name'])){
					$extentionp = strtolower(strrchr($this->request->data['User']['photo']['name'],"."));
					$fileDetailp = $this->request->data['User']['photo'];
					$this->request->data['User']['photo'] = "";
					if(!in_array($extentionp, $this->validImageFormats)){
						$flag = false;
						$this->Session->setFlash(sprintf(__('ERROR :: Please upload photo only having %s extensions.', true), implode(", ", $this->validImageFormats)));
					}
				} else {
					$this->request->data['User']['photo'] = $this->request->data['User']['prev_photo'];
				}
				
				
				if(isset($this->request->data['User']['document']['tmp_name']) && is_uploaded_file($this->request->data['User']['document']['tmp_name'])){
					$extentiond = strtolower(strrchr($this->request->data['User']['document']['name'],"."));
					$fileDetaild = $this->request->data['User']['document'];
					$this->request->data['User']['document'] = "";
					if(!in_array($extentiond, $this->validDocsFormats)){
						$flag = false;
						$this->Session->setFlash(sprintf(__('ERROR :: Please upload Documents only having %s extensions.', true), implode(", ", $this->validDocsFormats)));
					}
				} else {
					$this->request->data['User']['document'] = $this->request->data['User']['prev_doc'];
				}				
				
				if($this->request->data['User']['user_password']!=''){
					$this->request->data['User']['password'] = Security::hash(Configure::read('Security.salt').$this->request->data['User']['user_password']);
				}
				else{
					$this->request->data['User']['password'] = $this->request->data['User']['user_password'];
				}
				$this->User->create();
				if ($this->User->save($this->request->data)){
				
				
					if(isset($fileDetailp) && is_uploaded_file($fileDetailp['tmp_name'])){
						$fileNamep = $this->User->id.str_replace(' ', '', stripslashes(trim($fileDetailp['name'])));
						move_uploaded_file($fileDetailp['tmp_name'], USER_IMAGES . $fileNamep);
						$this->User->saveField('photo', $fileNamep);
						if($this->request->data['User']['prev_photo']!='' && $this->request->data['User']['prev_photo']!=$fileNamep){
							if(file_exists(USER_IMAGES . $this->request->data['User']['prev_photo'])){
								unlink(USER_IMAGES . $this->request->data['User']['prev_photo']);
							}
						}
						$this->request->data['User']['prev_photo'] = $fileNamep;
					}
					
					
					if(isset($fileDetaild) && is_uploaded_file($fileDetaild['tmp_name'])){
						$fileNamed = $this->User->id.str_replace(' ', '', stripslashes(trim($fileDetaild['name'])));
						move_uploaded_file($fileDetaild['tmp_name'], USER_DOCS . $fileNamed);
						$this->User->saveField('document', $fileNamed);
						if($this->request->data['User']['prev_doc']!='' && $this->request->data['User']['prev_doc']!=$fileNamed){
							if(file_exists(USER_DOCS . $this->request->data['User']['prev_doc'])){
								unlink(USER_DOCS . $this->request->data['User']['prev_doc']);
							}
						}
						$this->request->data['User']['prev_doc'] = $fileNamed;
					}					
					
					
					$this->Session->setFlash(__('Patient has been updated successfully.', true),'default', array('class' => 'success'));
					$this->redirect(array('action' => 'patient'));
				}
				else{
					$this->Session->setFlash(__('ERROR :: Patient could not be updated. Please, try again.', true));
				}
			}
		}
		if (empty($this->request->data)){
			$this->request->data = $this->User->read(null, $id);
			$this->request->data['User']['user_password'] = $this->request->data['User']['password'];
			$this->request->data['User']['prev_photo'] = $this->request->data['User']['photo'];
			$this->request->data['User']['prev_doc'] = $this->request->data['User']['document'];
		}
	}
	/* --------------------------------------------------------------- END :: ADMIN PANEL FUNCTIONS --------------------------------------- */
	public function login(){
		$this->layout = "default";
		if($this->request->is('post')){
			if($this->Auth->login()){
				$this->Session->setFlash(sprintf(__('You have successfully logged in.',true),''), 'default', array('class' => ''));
				$this->redirect($this->Auth->redirect());
			}
			else{
				$this->Session->setFlash(__('ERROR :: Invalid username and password, try again', true));
			}
		}
	}
	public function logout(){
		/*session_destroy();
		$this->Session->setFlash(sprintf(__('You have successfully logged out.', true), ''), 'default', array('class' => ''));
		$this->redirect($this->Auth->logout());*/
		
		if($this->Auth->logout()){
			$this->Session->setFlash(__('You are successfully logged out', true));
		$this->redirect($this->Auth->logout());		
		}
		
		
		
		/*$this->layout = "default";
		$this_user_id = $this->Session->read('Auth.User.id');
		//session_destroy();
		if($this->Auth->logout()){
				$this->request->data['User']['id'] = $this_user_id;
				$this->request->data['User']['online_status'] = 0;
				$this->User->save($this->request->data);			
				$this->Session->setFlash(__('You are successfully logged out', true));
			//$notifyMessage = $this->Session->flash(); echo $notifyMessage; exit;
			$this->redirect($this->Auth->logout());
		}*/		
	}
	
	
	
	
	/*for doctors*/
	public function doctorsignup(){
		if($this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		$go = "";
		$id = "";
		if(!empty($this->request->data)){
			$get_email = $this->User->find('first', array('conditions' => array('User.email' => $this->request->data['User']['email'])));
			if($get_email){
				$this->Session->setFlash(sprintf(__('ERROR :: Same email address already exists.', true)));
			}
			else{
				$this->request->data['User']['password'] = Security::hash(Configure::read('Security.salt').$this->request->data['User']['password']);
				$this->request->data['User']['user_type'] = "2";
				$this->request->data['User']['registration_date'] = date('Y-m-d h:i:s');
				$this->User->create();
				if ($this->User->save($this->request->data)){
					$go = 1;
					$id = $this->User->id;
				}
			}
		}
		$this->set(compact('go','id'));
	}
	public function doctorthankyou(){
		if($this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		if(!empty($_GET)){
			$id = $_GET['cm'];
			$transaction = $_GET['tx'];
			$status = $_GET['st'];
			$paidon = date('Y-m-d h:i:s');
			$this->User->id = $id;
			$this->User->saveField("transaction_id",$transaction);
			$this->User->saveField("payment_status",$status);
			$this->User->saveField("paid_on",$paidon);
		}
	}
	public function doctornotify(){
		$this->layout = false;
		if(!empty($_GET)){
			$id = $_GET['cm'];
			$transaction = $_GET['tx'];
			$status = $_GET['st'];
			$paidon = date('Y-m-d h:i:s');
			$this->User->id = $id;
			$this->User->saveField("transaction_id",$transaction);
			$this->User->saveField("payment_status",$status);
			$this->User->saveField("paid_on",$paidon);
		}
		exit;
	}
	/*Doctors Store*/
	public function bookshelf($id = null){
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		$uid = $this->Session->read('Auth.User.id');
		$books = $this->Product->find('all', array('conditions' => array('Product.user_id' => $id, 'Product.product_type_id' => '1', 'Product.blocked' => '0')));
		$latests = $this->Product->find('all', array('limit' => 2, 'conditions' => array('Product.user_id' => $id, 'Product.product_type_id' => '1', 'Product.blocked' => '0')));
		$this->set(compact('books', 'latests'));
		$this->set(compact('id', 'uid'));
	}
	public function dispensary($id = null){
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		$uid = $this->Session->read('Auth.User.id');
		$dispensarys = $this->Product->find('all', array('conditions' => array('Product.user_id' => $id, 'Product.product_type_id' => '2', 'Product.blocked' => '0')));
		$latests = $this->Product->find('all', array('limit' => 2, 'conditions' => array('Product.user_id' => $id, 'Product.product_type_id' => '2', 'Product.blocked' => '0')));
		$this->set(compact('dispensarys', 'latests'));
		$this->set(compact('id', 'uid'));
	}
	public function order(){
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		$id = $this->Session->read('Auth.User.id');
		$this->loadModel("User");
		$orders = $this->User->query("SELECT * FROM `ss_products` , `ss_orders` , `ss_order_items` WHERE `ss_products`.`id` =
							`ss_order_items`.`product_id` AND `ss_order_items`.`order_id` = `ss_orders`.`id` AND
							`ss_products`.`user_id` = " . $id);
		$this->set(compact('orders', 'id'));
	}
	/*for patients*/
	public function patientsignup(){
		if($this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		$go = "";
		$id = "";
		$user_type="";
		if(!empty($this->request->data)){
			$user_type = $this->request->data['User']['user_type'];
			$get_email = $this->User->find('first', array('conditions' => array('User.email' => $this->request->data['User']['email'])));
			if($get_email){
				$this->Session->setFlash(__('ERROR :: Same email address already exists.', true));
			}
			else{
				$this->request->data['User']['password'] = Security::hash(Configure::read('Security.salt').$this->request->data['User']['password']);
				$this->request->data['User']['registration_date'] = date('Y-m-d h:i:s');
				$this->User->create();
				if ($this->User->save($this->request->data)){
					$go=1;
					$id=$this->User->id;
				}
			}
		}
		$this->set(compact('go', 'id', 'user_type'));
	}
	public function patientthankyou(){
		if($this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		if(!empty($_GET)){
			$id = $_GET['cm'];
			$transaction = $_GET['tx'];
			$status = $_GET['st'];
			$paidon = date('Y-m-d h:i:s');
			$this->User->id = $id;
			$this->User->saveField("transaction_id",$transaction);
			$this->User->saveField("payment_status",$status);
			$this->User->saveField("paid_on",$paidon);
		}
		if(empty($_GET)){
			$this->redirect('/');
		}
	}
	public function patientnotify(){
		$this->layout = false;
		if(!empty($_GET)){
			$id = $_GET['cm'];
			$transaction = $_GET['tx'];
			$status = $_GET['st'];
			$paidon = date('Y-m-d h:i:s');
			$this->User->id = $id;
			$this->User->saveField("transaction_id",$transaction);
			$this->User->saveField("payment_status",$status);
			$this->User->saveField("paid_on",$paidon);
		}
		exit;
	}
	public function signup(){
		if($this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		$this->layout = "default";
		if(!empty($this->request->data)){
			$get_email = $this->User->find('first', array('conditions' => array('User.email' => $this->request->data['User']['email'])));
			if($get_email){
				$this->Session->setFlash(sprintf(__('ERROR :: Same email address already exists.', true)));
			}
			else{
				$this->request->data['User']['password'] = Security::hash(Configure::read('Security.salt').$this->request->data['User']['password']);
				$this->request->data['User']['user_type'] = "2";
				$this->request->data['User']['registration_date'] = date('Y-m-d h:i:s');
				$this->User->create();
				if ($this->User->save($this->request->data)){
					$this->Session->setFlash(sprintf(__('You have been successfully signed up with us. Please Login.', true), ''), 'default', array('class' => ''));
					$this->redirect('/');
				}
			}
		}
	}
	public function forgot_password(){
		if($this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		$this->layout = 'default';
		if(!empty($this->request->data)){
		
		
		$this->loadModel('SiteSetting');		
		$my_site_setting = $this->SiteSetting->find('first');

		//pr($my_site_setting);exit;
		
		
			$user = $this->User->find('first', array('conditions' => array('User.email' => $this->request->data['User']['email'])));
			if($user){
				$new_password = $this->generate_password();
				$dt['User']['id'] = $user['User']['id'];
				$dt['User']['password'] = Security::hash(Configure::read('Security.salt').$new_password);
				if($this->User->save($dt)){
					$mail_Body = '
					<table cellspacing="0" cellpadding="0" style="background-color:#fcfcfc; width:560px; height:410px; border-collapse:collapse; border:1px solid #c0c0c0;">
						<tr>
							<td style="height:50px; padding:5px;" valign="top" align="left">
								<a href="'.Router::URL('/', true).'"><img src="'.Router::URL('/', true).'img/login_admin.png" width="95" border="0" alt="'.Router::URL('/', true).'" /></a>
							</td>
						</tr>
						<tr>
							<td align="center" valign="top" style="height:3px;">
								<div style="border-top:2px solid #0094c3; width:544px; height:3px;"></div>
							</td>
						</tr>
						<tr>
							<td style="height:25px; padding-left:15px; padding-top:25px; font-family:Arial; font-size:13px;" valign="top" align="left">Dear '.$user['User']['first_name'].',</td>
						</tr>
						<tr>
							<td style="height:70px; padding-left:15px; padding-right:15px; padding-top:25px; font-family:Arial; font-size:13px;" valign="top" align="left">Your new password is : <b>'.$new_password.'</b></td>
						</tr>
						<tr>
							<td style="height:25px; padding-left:15px; padding-top:25px; font-family:Arial; font-size:13px;" valign="top" align="left"><b>Swapscan</b> Staff</td>
						</tr>
						<tr>
							<td align="center" valign="top" style="height:20px;">
								<div style="border-bottom:1px solid #c0c0c0; width:544px; height:15px; margin-top:5px;"></div>
							</td>
						</tr>
						<tr height="30">
							<td align="center" style="height:20px; padding-top:9px; font-family:verdana; font-size:11px; color:#888888;" valign="top">
								<b><a href="'.DOMAIN_PATH.'" target="_blank">Click Here To Login</a></b>
							</td>
						</tr>
						<tr height="4"><td style="height:4px;"></td></tr>
						<tr>
							<td align="center" valign="top" style="height:3px;">
								<div style="border-top:1px solid #c0c0c0; width:544px; height:3px; margin-top:5px;"></div>
							</td>
						</tr>
						<tr>
							<td style="padding-left:10px; padding-top:5px; font-family:Arial; font-size:9px; color:#9F9F9F;" valign="top" align="left">
										&nbsp;&nbsp;&copy;&nbsp;2012 Swapscan.com. All Rights Reserved.
							</td>
						</tr>
						<tr height="8"><td style="height:8px;"></td></tr>
					</table>';
					//echo $mail_Body;exit;
					@$this->Send_HTML_Mail($email, 'IAIIM <admin@iaiim.com>', '', 'Swapscan Registration', $mail_Body);
					//@$this->Send_HTML_Mail($email, 'IAIIM <'.$my_site_setting["SiteSetting"]["site_general_mail"].'>', '', 'Swapscan Registration', $mail_Body);
					//$this->Send_HTML_Mail($mail_To, $mail_From, '', $mail_subject, $mail_Body);
					
					
					
					$this->Session->setFlash(sprintf(__('Password has been sent to your email address.', true), ''), 'default', array('class' => ''));
					/*echo '<script>window.parent.location.reload();parent.$.fn.colorbox.close();</script>';*/
					//exit;
				}
				else{
					$this->Session->setFlash(__('Error Occurred.', true));
				}
			}
			else{
				$this->Session->setFlash(__('ERROR :: Email address not exists.', true));
			}
		}
	}
	/*message*/
	public function compose_message($id = 0){
		if($this->Session->read('Auth.User.id') == ""){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/users/inbox');
		}
		$uid = $this->Session->read('Auth.User.id');
		$conditions['or'][] = array(
			'OR' => array(
				array('Approval.sent_to' => $uid),
				array('Approval.sent_from' => $uid)
				),
				'Approval.status' => '1'
			);
		$approved = $this->Approval->find('all', array('conditions' => $conditions));
		$this->set(compact('approved', 'uid'));
		$this->Message->id=$id;
		if(!empty($this->request->data)){
			$this->request->data['User']['send_date']=date('Y-m-d h:i:s');
			$this->request->data['User']['reply_of']=$id;
			$this->Message->create();
			if($this->Message->save($this->request->data['User'])){
				$this->redirect('/users/inbox');
			}
		}
		$this->set('message', $this->Message->read());
	}
	public function send_message($id = 0){
		if($this->Session->read('Auth.User.id') == ""){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/users/inbox');
		}
		$uid = $this->Session->read('Auth.User.id');
		// $conditions['or'][] = array(
		// 	'OR' => array(
		// 		array('Approval.sent_to' => $id),
		// 		array('Approval.sent_from' => $id)
		// 		),
		// 		'Approval.status' => '1'
		// 	);
		$approved = $this->User->find('first', array('conditions' => array('User.id' => $id)));
		$this->set(compact('approved', 'uid', 'id'));
		//$this->Message->id = $id;
		if(!empty($this->request->data)){
			$this->request->data['User']['send_date']=date('Y-m-d h:i:s');
			$this->request->data['User']['reply_of']=$id;
			$this->Message->create();
			if($this->Message->save($this->request->data['User'])){
				$this->redirect('/users/inbox');
			}
		}
		$this->set('message', $this->Message->read());
	}
	public function message_view($id = 0){
		if($this->Session->read('Auth.User.id') == ""){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/users/inbox');
		}
		$this->Message->id=$id;
		$this->Message->saveField('is_read', 1);
		$this->set('message',$this->Message->read());
	}
	public function inbox(){
		if($this->Session->read('Auth.User.id') == ""){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/users/inbox');
		}
		$message=$this->Message->find('all',array('conditions'=>array('Message.to_user'=>$this->Session->read('Auth.User.id'), 'Message.approval_id'=> '0'),'order'=>array('Message.send_date'=>'DESC')));
		$this->set(compact('message'));
	}
	public function notification(){
		if($this->Session->read('Auth.User.id') == ""){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		$id = $this->Session->read('Auth.User.id');
		$this->Approval->recursive = 2;
		$notification = $this->Approval->find('all',array('conditions'=>array('Approval.sent_to' => $id, 'Approval.status' => '0'), 'order'=>array('Approval.sent_on'=>'DESC')));
		$this->set(compact('notification'));
	}
	public function notification_view($id = 0){
		if($this->Session->read('Auth.User.id') == ""){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		$this->Approval->id=$id;
		$this->Approval->saveField('status', 1);
		$this->redirect('/users/dashboard');
	}
	/*profile*/
	public function dashboard(){
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		$id = $this->Session->read('Auth.User.id');
		$reviews = $this->UserReview->find('count', array('conditions' => array('UserReview.user_id' => $id)));
		$this->set(compact('reviews', 'id'));
		if(!empty($this->request->data)){
			$get_email = $this->User->find('first', array('conditions' => array('User.email' => $this->request->data['User']['email'], 'User.id <>' => $id)));
			if($get_email){
				$this->Session->setFlash(__('ERROR :: Same email address already exists.', true));
			}
			else{
			}
		}
		if (empty($this->request->data)){
			$this->request->data =  $this->User->read(null, $this->Session->read('Auth.User.id'));
			$this->request->data['User']['user_password'] = $this->request->data['User']['password'];
		}
	}
	public function editprofile($id = null){
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
		}
		$this->layout = "default";
		if(!$id){
			$this->Session->setFlash(__('ERROR :: Invalid Id.', true));
			$this->redirect(array('action'=>'home'));
		}
		if($id){
			$get_user = $this->User->find('first', array('conditions' => array('User.id' => $id)));
			if($get_user){
				$this->set(compact('get_user'));
				$this->Session->setFlash(__('ERROR :: Same email address already exists.', true));
			}
			else{
				$this->Session->setFlash(__('Error occurred. No Such User.', true));
			}
		}
		$fileName = '';
		if (!empty($this->request->data)){
			$get_email = $this->User->find('first', array('conditions' => array('User.email' => $this->request->data['User']['email'], 'User.id <>' => $id)));
			if($get_email){
				$this->Session->setFlash(__('ERROR :: Same email address already exists.', true));
			}
			else if($this->request->data['User']['user_password']=='' && $this->request->data['User']['confirm_password']!=''){
				$this->Session->setFlash(__('ERROR :: Please enter password.', true));
			}
			else if($this->request->data['User']['user_password']!='' && $this->request->data['User']['confirm_password']==''){
				$this->Session->setFlash(__('ERROR :: Please enter confirm password.', true));
			}
			else if($this->request->data['User']['user_password']!='' && $this->request->data['User']['confirm_password']!='' && ($this->request->data['User']['user_password'] != $this->request->data['User']['confirm_password'])){
				$this->Session->setFlash(__('ERROR :: Password missmatched.', true));
			}
			else{
				$flag = true;
				if(isset($this->request->data['User']['photo']['tmp_name']) && is_uploaded_file($this->request->data['User']['photo']['tmp_name'])){
					$extention = strtolower(strrchr($this->request->data['User']['photo']['name'],"."));
					$fileDetail = $this->request->data['User']['photo'];
					$this->request->data['User']['photo'] = "";
					if(!in_array($extention, $this->validImageFormats)){
						$flag = false;
						$this->Session->setFlash(sprintf(__('ERROR :: Please upload photo only having %s extensions.', true), implode(", ", $this->validImageFormats)));
					}
				}
				else{
					$this->request->data['User']['photo'] = $this->request->data['User']['prev_photo'];
				}
				if($this->request->data['User']['user_password']!=''){
					$this->request->data['User']['password'] = Security::hash(Configure::read('Security.salt').$this->request->data['User']['user_password']);
				}
				else{
					$this->request->data['User']['password'] = $this->request->data['User']['user_password'];
				}
				$this->User->create();
				if ($this->User->save($this->request->data)){
					if(isset($fileDetail) && is_uploaded_file($fileDetail['tmp_name'])){
						$fileName = $this->User->id.str_replace(' ', '', stripslashes(trim($fileDetail['name'])));
						move_uploaded_file($fileDetail['tmp_name'], USER_IMAGES . $fileName);
						$this->User->saveField('photo', $fileName);
						if($this->request->data['User']['prev_photo']!='' && $this->request->data['User']['prev_photo']!=$fileName){
							if(file_exists(USER_IMAGES . $this->request->data['User']['prev_photo'])){
								unlink(USER_IMAGES . $this->request->data['User']['prev_photo']);
							}
						}
						$this->request->data['User']['prev_photo'] = $fileName;
					}
					$this->Session->setFlash(__('Patient has been updated successfully.', true),'default', array('class' => 'success'));
					$this->redirect(array('action' => '/dashboard'));
				}
				else{
					$this->Session->setFlash(__('ERROR :: Patient could not be updated. Please, try again.', true));
				}
			}
		}
		if (empty($this->request->data)){
			$this->request->data = $this->User->read(null, $id);
			$this->request->data['User']['user_password'] = $this->request->data['User']['password'];
			$this->request->data['User']['prev_photo'] = $this->request->data['User']['photo'];
		}
	}
	public function profile($id = null){
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		if(!$id){
			$this->Session->setFlash(__('ERROR :: Invalid Id.', true));
			$this->redirect(array('action'=>'home'));
		}
		$reviews = $this->UserReview->find('count', array('conditions' => array('UserReview.user_id' => $id)));
		$this->set(compact('reviews', 'id'));
		if($id){
			$get_user = $this->User->find('first', array('conditions' => array('User.id' => $id)));
			if($get_user){
				$this->set(compact('get_user'));
				//$this->Session->setFlash(__('ERROR :: Same email address already exists.', true));
			}
			else{
				$this->Session->setFlash(__('Error occurred. No Such User.', true));
			}
		}
	}
	public function reports($id = null){
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		if(!$id){
			$this->Session->setFlash(__('ERROR :: Invalid Id.', true));
			$this->redirect(array('action'=>'home'));
		}
		$reviews = $this->UserReview->find('count', array('conditions' => array('UserReview.user_id' => $id)));
		$this->set(compact('reviews', 'id'));
		if($id){
			$get_user = $this->User->find('first', array('conditions' => array('User.id' => $id)));
			if($get_user){
				$this->set(compact('get_user'));
				//$this->Session->setFlash(__('ERROR :: Same email address already exists.', true));
			}
			else{
				$this->Session->setFlash(__('Error occurred. No Such User.', true));
			}
		}
	}
	public function update_document(){
		$this->layout = 'default';
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		$id = $this->Session->read('Auth.User.id');
		if (!empty($this->request->data)){
			//START :: photo uploading code.....
			$flag=true;
			$fileDetail ="";
			if (isset($this->request->data['User']['img']['tmp_name']) && is_uploaded_file($this->request->data['User']['img']['tmp_name'])){
				$extention = strtolower(strrchr($this->request->data['User']['img']['name'],"."));
				$fileDetail = $this->request->data['User']['img'];
				if(!in_array($extention, $this->validImageFormats)){
					$flag = false;
					$this->Session->setFlash(__('ERROR :: Please upload file only having '.implode(", ", $this->validImageFormats).' extensions.', true));
				}
				//USER_IMAGES_URL
			}
			else{
				$flag = false;
				$this->Session->setFlash(__('ERROR :: Please upload file', true));
			}
			if($flag && $fileDetail){
				if($this->request->data['User']['documents']){
					unlink(USER_IMAGES_URL. $this->request->data['User']['documents']);
				}
				$this->request->data['User']['document']=time().'_'.str_replace(' ', '', stripslashes(trim($fileDetail['name'])));
				if($this->User->save($this->request->data)){
					if(isset($fileDetail) && is_uploaded_file($fileDetail['tmp_name'])){
						move_uploaded_file($fileDetail['tmp_name'], USER_IMAGES_URL. $this->request->data['User']['document']);
					}
					$this->Session->setFlash(__('Your documents has been updated successfully.', true), 'default', array('class' => 'success'));
					$this->redirect(array('action' => '/dashboard'));
				}
				else{
					$this->Session->setFlash(__('ERROR :: Your documents could not saved.Please try again', true));
				}
				echo '<script>parent.$.fn.colorbox.close();</script>';
			}
			//END :: photo uploading code.....
		}
		if (empty($this->request->data)){
			$this->request->data['User'] =  $this->Session->read('Auth.User');
		}
	}
	public function approved(){
		if($this->Session->read('Auth.User.id') == ""){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		$id = $this->Session->read('Auth.User.id');
		$this->Approval->recursive = 2;
		$conditions['or'][] = array(
				'OR' => array(
					array('Approval.sent_to' => $id),
					array('Approval.sent_from' => $id)
					),
					'Approval.status' => '1'
				);
		$approved=$this->Approval->find('all', array('conditions' => $conditions));
		$this->set(compact('approved', 'id'));
	}
	/*profile_end*/
	/*search*/
	public function user_search(){
		$cond=array();
		if(!empty($this->request->data)){
			$type = $this->request->data['User']['user_type'];
			$firstname = $this->request->data['User']['first_name'];
			$location = $this->request->data['User']['location'];
			$speciality = $this->request->data['User']['speciality'];
			if($type == '0'){
				$conditions['or'][] = array(
				'OR' => array(
					array('User.first_name LIKE' => '%'.$firstname.'%'),
					array('User.last_name LIKE' => '%'.$firstname.'%'),
					array('User.location' => $location),
					array('User.speciality' => $speciality)
					),
					'User.user_type' => '2'
				);
				$users = $this->User->find('all', array('conditions'=> $conditions));
			}
			else if($type == '1'){
				$conditions['or'][] = array(
				'OR' => array(
					array('User.first_name LIKE' => '%'.$firstname.'%'),
					array('User.last_name LIKE' => '%'.$firstname.'%'),
					array('User.location' => $location),
					array('User.speciality' => $speciality),
					array('User.user_type' => '3'),
					array('User.user_type' => '4'),
					array('User.user_type' => '5')
					)
				);
				$users = $this->User->find('all', array('conditions' => $conditions));
			}
			$this->set(compact('users'));
		}
		if(empty($this->request->data)){
			$conditions = array('User.user_type' => '2, 3, 4, 5');
			$users = $this->User->find('all', array('conditions' => $conditions));
			$this->set('users', $this->paginate());
		}
		$id = $this->Session->read('Auth.User.id');
		$curuser = $this->User->find('first', array('conditions' => array('User.id' => $id)));
		$this->Approval->recursive = 2;
		$approvals = $this->Approval->find('all', array('conditions' => array('Approval.status' => '1', 'Approval.sent_from' => $id)));
		$this->set(compact('approvals', 'id', 'curuser'));
	}
	public function review($id = null){
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		$uid = $this->Session->read('Auth.User.id');
		$reviews = $this->UserReview->find('all', array('conditions' => array('UserReview.user_id' => $id)));
		$this->set(compact('reviews', 'id', 'uid'));
	}
	public function group($id = null){
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		$uid = $this->Session->read('Auth.User.id');
		$groups = $this->Group->find('all', array('conditions' => array('Group.user_id' => $id)));
		$userdetails = $this->User->find('first', array('fields' => 'User.user_type', 'conditions' => array('User.id' => $uid)));
		$this->set(compact('groups', 'id', 'uid', 'userdetails'));
	}
	public function groupnotification(){
	    if($this->Session->read('Auth.User.id')==""){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
	    $groupnotifications = $this->Groupapproval->find('all',array('conditions' => array('Groupapproval.sent_to' => $this->Session->read('Auth.User.id'), 'Groupapproval.status' => '0')));
	    //pr($groupnotifications);
	    //exit;
	    $this->set(compact('groupnotifications'));
	     if(!empty($this->request->data)){
		    	//pr($this->request->data);//exit;
			$gid = $this->request->data['Group']['id'];
			// $gstatus = $this->request->data['Groupapproval']['status'];
			// $orders=$this->Order->find('first',array('conditions'=>array('Order.id'=>$oid, 'Order.order_confirmation' =>$ostatus)));
			// //pr($orders);
			 if(array_key_exists('confirm', $this->request->data)) {
			 	$this->Groupapproval->updateAll(array('Groupapproval.status' => '1'), array('Groupapproval.id' => $gid));
			 	$this->Groupmember->updateAll(array('Groupmember.status' => '1'), array('Groupmember.id' => $gid));
			 }
			else if(array_key_exists('cancel', $this->request->data)) {
				$this->Groupapproval->updateAll(array('Groupapproval.status' => '2'), array('Groupapproval.id' => $gid));
				$this->Groupmember->updateAll(array('Groupmember.status' => '2'), array('Groupmember.id' => $gid));
			}
			// else {
			// 	$this->Order->updateAll(array('Order.order_confirmation' =>'3'), array('Order.id' => $oid));
			// }
	     }
	}
	public function event(){
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		$uid = $this->Session->read('Auth.User.id');
		$this->Transaction->recursive = 2;
		$events = $this->Transaction->find('all', array('conditions' => array('Transaction.user_id' => $uid, 'Transaction.status' => 'Completed')));
		$this->set(compact('events', 'uid'));
	}
	/*publishing*/
	public function publishing($id = null){
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		$uid = $this->Session->read('Auth.User.id');
		$curdate = date('Y-m-d h:i:s');
		$reg_infos = $this->Transaction->find('all', array('conditions' => array('Transaction.user_id' => $uid, 'Transaction.type' => '5', 'Transaction.status' => 'Completed')));
		$get_user = $this->User->find('first', array('conditions' => array('User.id' => $id)));
		$publishings = $this->Publishing->find('all', array('conditions' => array('Publishing.user_id' => $id, 'Publishing.status' => '1')));
		$this->set(compact('publishings', 'id', 'uid', 'get_user', 'curdate', 'reg_infos'));
	}
	/*seminar*/
	public function seminar($id = null){
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		$uid = $this->Session->read('Auth.User.id');
		$curdate = date('Y-m-d h:i:s');
		$reg_infos = $this->Transaction->find('all', array('conditions' => array('Transaction.user_id' => $uid, 'Transaction.type' => '1', 'Transaction.status' => 'Completed')));
		$get_user = $this->User->find('first', array('conditions' => array('User.id' => $id)));
		$seminars = $this->Seminar->find('all', array('conditions' => array('Seminar.user_id' => $id, 'Seminar.status' => '1')));
		$this->set(compact('seminars', 'id', 'uid', 'get_user', 'curdate', 'reg_infos'));
	}
	/*webinar*/
	public function webinar($id = null){
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		$uid = $this->Session->read('Auth.User.id');
		$curdate = date('Y-m-d h:i:s');
		$reg_infos = $this->Transaction->find('all', array('conditions' => array('Transaction.user_id' => $uid, 'Transaction.type' => '2', 'Transaction.status' => 'Completed')));
		$get_user = $this->User->find('first', array('conditions' => array('User.id' => $id)));
		$webinars = $this->Webinar->find('all', array('conditions' => array('Webinar.user_id' => $id, 'Webinar.status' => '1')));
		$this->set(compact('webinars', 'id', 'uid', 'get_user', 'curdate', 'reg_infos'));
	}
	/*workshop*/
	public function workshop($id = null){
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		$uid = $this->Session->read('Auth.User.id');
		$curdate = date('Y-m-d h:i:s');
		$reg_infos = $this->Transaction->find('all', array('conditions' => array('Transaction.user_id' => $uid, 'Transaction.type' => '3', 'Transaction.status' => 'Completed')));
		$get_user = $this->User->find('first', array('conditions' => array('User.id' => $id)));
		$workshops = $this->Workshop->find('all', array('conditions' => array('Workshop.user_id' => $id, 'Workshop.status' => '1')));
		$this->set(compact('workshops', 'id', 'uid', 'get_user', 'curdate', 'reg_infos'));
	}
	/*course*/
	public function course($id = null){
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		$uid = $this->Session->read('Auth.User.id');
		$curdate = date('Y-m-d h:i:s');
		$reg_infos = $this->Transaction->find('all', array('conditions' => array('Transaction.user_id' => $uid, 'Transaction.type' => '4', 'Transaction.status' => 'Completed')));
		$get_user = $this->User->find('first', array('conditions' => array('User.id' => $id)));
		$courses = $this->Course->find('all', array('conditions' => array('Course.user_id' => $id, 'Course.status' => '1')));
		$this->set(compact('courses', 'id', 'uid', 'get_user', 'curdate', 'reg_infos'));
	}
	/*archive*/
	public function archive($id = null){
		if(!$this->Session->read('Auth.User.id')){
			$this->Session->setFlash(__('ERROR :: You are not authorized to that location', true));
			$this->redirect('/');
		}
		$uid = $this->Session->read('Auth.User.id');
		$curdate = date('Y-m-d h:i:s');
		$reg_infos = $this->Transaction->find('all', array('conditions' => array('Transaction.user_id' => $uid, 'Transaction.type' => '1', 'Transaction.status' => 'Completed')));
		$get_user = $this->User->find('first', array('conditions' => array('User.id' => $uid)));
		$seminars = $this->Seminar->find('all', array('conditions' => array('Seminar.user_id' => $id, 'Seminar.status' => '1')));
		$this->set(compact('seminars', 'id', 'uid', 'get_user', 'curdate', 'reg_infos'));
	}
}