<?php
App::uses('AppModel', 'Model');
/**
 * Product Model
 *
 * @property Type $Type
 * @property Category $Category
 * @property User $User
 * @property Tags $Tags
 * @property ProductImage $ProductImage
 */
class Order extends AppModel {

/**
 * Validation rules
 *
 * @var array
 */

	public $belongsTo = array(
		'User' => array(
			'className' => 'User',
			'foreignKey' => 'user_id',
			'conditions' => '',
			'fields' => '',
			'order' => ''
		),
		'Owner' => array(
			'className' => 'User',
			'foreignKey' => 'owner_id',
			'conditions' => '',
			'fields' => '',
			'order' => ''
		),		
		
		
		
		
		'Product' => array(
			'className' => 'Product',
			'foreignKey' => 'product_id',
			'conditions' => array('Order.product_type' => array('dispensery','books')),
			'fields' => '',
			'order' => ''
		),
		'Webinar' => array(
			'className' => 'Webinar',
			'foreignKey' => 'product_id',
			'conditions' => array('Order.product_type' => 'webinar'),
			'fields' => '',
			'order' => ''
		),		
		'Workshop' => array(
			'className' => 'Workshop',
			'foreignKey' => 'product_id',
			'conditions' => array('Order.product_type' => 'workshop'),
			'fields' => '',
			'order' => ''
		),		
		'Sumhit' => array(
			'className' => 'Sumhit',
			'foreignKey' => 'product_id',
			'conditions' => array('Order.product_type' => 'summit'),
			'fields' => '',
			'order' => ''
		),		
		'Publishings' => array(
			'className' => 'Publishings',
			'foreignKey' => 'product_id',
			'conditions' => array('Order.product_type' => 'publish'),
			'fields' => '',
			'order' => ''
		),		
		'Seminar' => array(
			'className' => 'Seminar',
			'foreignKey' => 'product_id',
			'conditions' => array('Order.product_type' => 'seminer'),
			'fields' => '',
			'order' => ''
		),	
		'Course' => array(
			'className' => 'Course',
			'foreignKey' => 'product_id',
			'conditions' => array('Order.product_type' => 'course'),
			'fields' => '',
			'order' => ''
		),		
				
	);

/**
 * hasMany associations
 *
 * @var array
 */
	public $hasMany = array(
		'Groupmember' => array(
			'className' => 'Groupmember',
			'foreignKey' => 'group_id',
			'conditions' => '',
			'fields' => '',
			'order' => ''
		),
		'Grouppost' => array(
			'className' => 'Grouppost',
			'foreignKey' => 'group_id',
			'conditions' => '',
			'fields' => '',
			'order' => ''
		)		
	);

}
